(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 12.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    222837,       5583]
NotebookOptionsPosition[    219658,       5528]
NotebookOutlinePosition[    220031,       5544]
CellTagsIndexPosition[    219988,       5541]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[TextData[StyleBox["Definitions", "Section"]], "Subsubsection",
 CellChangeTimes->{{3.826872090791264*^9, 3.826872094622589*^9}, {
  3.826873503854273*^9, 3.82687350457395*^9}, {3.8268874805667534`*^9, 
  3.82688748496704*^9}, {3.8268955676768513`*^9, 3.826895569090865*^9}, {
  3.827239206053363*^9, 
  3.8272392078122063`*^9}},ExpressionUUID->"2ec9fe91-5b2e-440a-95fb-\
792e309927f2"],

Cell[TextData[StyleBox["Make sure to run the code below -- but don\
\[CloseCurlyQuote]t worry about the details, these are just definitions of \
the functions our demo will use",
 FontWeight->"Bold"]], "Text",
 CellChangeTimes->{{3.8262650902861843`*^9, 3.826265091099492*^9}, {
  3.8262652312441196`*^9, 3.826265473334661*^9}, {3.8264936657315893`*^9, 
  3.826493710958598*^9}, {3.826493827200305*^9, 3.8264938282809477`*^9}, {
  3.8264939742007303`*^9, 3.82649405518382*^9}, {3.8272392140975666`*^9, 
  3.827239224966739*^9}, {3.827239268488271*^9, 3.8272392931488256`*^9}},
 Background->RGBColor[
  0.88, 1, 0.88],ExpressionUUID->"18766686-4706-4c59-8807-cd44caabb3e2"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetDirectory", "[", 
   RowBox[{"NotebookDirectory", "[", "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Import", "[", "\"\<https://qtechtheory.org/QuESTlink.m\>\"", 
  "]"}], "\n", 
 RowBox[{
  RowBox[{"CreateDownloadedQuESTEnv", "[", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"pswap", "[", 
    RowBox[{"p1_", ",", "p2_"}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{
         RowBox[{"-", "\[ImaginaryI]"}], " ", "p2"}]], ",", "0", ",", "0", 
       ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{
        RowBox[{
         FractionBox["1", "2"], " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", "p1"}], "+", 
           RowBox[{"\[ImaginaryI]", " ", "p2"}]}]]}], "+", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", "\[ImaginaryI]", " ", "p1"}], "+", 
           RowBox[{"\[ImaginaryI]", " ", "p2"}]}]]}]}], ",", 
       RowBox[{
        RowBox[{
         FractionBox["1", "2"], " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", "p1"}], "+", 
           RowBox[{"\[ImaginaryI]", " ", "p2"}]}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", "\[ImaginaryI]", " ", "p1"}], "+", 
           RowBox[{"\[ImaginaryI]", " ", "p2"}]}]]}]}], ",", "0"}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{
        RowBox[{
         FractionBox["1", "2"], " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", "p1"}], "+", 
           RowBox[{"\[ImaginaryI]", " ", "p2"}]}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", "\[ImaginaryI]", " ", "p1"}], "+", 
           RowBox[{"\[ImaginaryI]", " ", "p2"}]}]]}]}], ",", 
       RowBox[{
        RowBox[{
         FractionBox["1", "2"], " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", "p1"}], "+", 
           RowBox[{"\[ImaginaryI]", " ", "p2"}]}]]}], "+", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"2", " ", "\[ImaginaryI]", " ", "p1"}], "+", 
           RowBox[{"\[ImaginaryI]", " ", "p2"}]}]]}]}], ",", "0"}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", 
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{
         RowBox[{"-", "\[ImaginaryI]"}], " ", "p2"}]]}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ccphasemat", "[", "\[Theta]_", "]"}], ":=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
        "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
       "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
        "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
       "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
        "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
       "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
        "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
       "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
        "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
        "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
        "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
        SuperscriptBox["\[ExponentialE]", 
         FractionBox[
          RowBox[{"\[ImaginaryI]", " ", "\[Theta]"}], "2"]]}], "}"}]}], 
     "}"}]}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gate", "[", 
   RowBox[{"c_", ",", "n1_", ",", "n2_", ",", "typ_"}], "]"}], ":=", 
  RowBox[{"Switch", "[", 
   RowBox[{
   "typ", "\[IndentingNewLine]", "\[IndentingNewLine]", ",", "\"\<crx\>\"", 
    ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       SubscriptBox["Ry", "n1"], "[", 
       FractionBox["\[Pi]", "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rz", "n2"], "[", 
       FractionBox[
        RowBox[{"5", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["C", "n1"], "[", 
       RowBox[{
        SubscriptBox["Rx", "n2"], "[", "\[Pi]", "]"}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rz", "n2"], "[", 
       FractionBox[
        RowBox[{"7", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["C", "c"], "[", 
       RowBox[{
        SubscriptBox["Rx", "n2"], "[", 
        FractionBox[
         RowBox[{"5", " ", "\[Pi]"}], "2"], "]"}], "]"}], ",", 
      RowBox[{
       SubscriptBox["C", "c"], "[", 
       RowBox[{
        SubscriptBox["Rx", "n1"], "[", 
        FractionBox["\[Pi]", "2"], "]"}], "]"}], ",", 
      RowBox[{
       SubscriptBox["C", "n1"], "[", 
       RowBox[{
        SubscriptBox["Rx", "n2"], "[", "\[Pi]", "]"}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rz", "n1"], "[", 
       FractionBox[
        RowBox[{"3", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["C", "c"], "[", 
       RowBox[{
        SubscriptBox["Rx", "n1"], "[", 
        FractionBox[
         RowBox[{"3", " ", "\[Pi]"}], "2"], "]"}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Ry", "n1"], "[", 
       FractionBox[
        RowBox[{"7", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rz", "n2"], "[", 
       FractionBox[
        RowBox[{"3", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["C", "n2"], "[", 
       RowBox[{
        SubscriptBox["Rx", "n1"], "[", "\[Pi]", "]"}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rz", "c"], "[", 
       FractionBox[
        RowBox[{"7", " ", "\[Pi]"}], "4"], "]"}]}], "}"}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", ",", "\"\<crxUE\>\"", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       SubscriptBox["C", "c"], "[", 
       RowBox[{
        SubscriptBox["Rx", "n1"], "[", 
        RowBox[{"3", " ", "\[Pi]"}], "]"}], "]"}], ",", 
      RowBox[{
       SubscriptBox["C", "n1"], "[", 
       RowBox[{
        SubscriptBox["Rx", "n2"], "[", " ", "\[Pi]", "]"}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rz", "n1"], "[", 
       FractionBox[
        RowBox[{"5", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rz", "n2"], "[", 
       FractionBox[
        RowBox[{"13", " ", "\[Pi]"}], "4"], "]"}], ",", 
      RowBox[{
       SubscriptBox["C", "n2"], "[", 
       RowBox[{
        SubscriptBox["Rx", "n1"], "[", 
        FractionBox["\[Pi]", "2"], "]"}], "]"}], ",", 
      RowBox[{
       SubscriptBox["C", "c"], "[", 
       RowBox[{
        SubscriptBox["Rx", "n2"], "[", 
        RowBox[{"3", " ", "\[Pi]"}], "]"}], "]"}], ",", 
      RowBox[{
       SubscriptBox["C", "c"], "[", 
       RowBox[{
        SubscriptBox["Rx", "n1"], "[", 
        FractionBox["\[Pi]", "2"], "]"}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rz", "c"], "[", 
       FractionBox["\[Pi]", "4"], "]"}]}], "}"}], "\[IndentingNewLine]", ",", 
    "\"\<crxOBSX\>\"", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       SubscriptBox["C", "n1"], "[", 
       RowBox[{
        SubscriptBox["Rx", "n2"], "[", "\[Pi]", "]"}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rz", "n1"], "[", 
       FractionBox[
        RowBox[{"5", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rz", "n2"], "[", 
       FractionBox[
        RowBox[{"15", " ", "\[Pi]"}], "4"], "]"}], ",", 
      RowBox[{
       SubscriptBox["C", "n2"], "[", 
       RowBox[{
        SubscriptBox["Rx", "n1"], "[", 
        FractionBox[
         RowBox[{"3", " ", "\[Pi]"}], "2"], "]"}], "]"}], ",", 
      RowBox[{
       SubscriptBox["C", "c"], "[", 
       RowBox[{
        SubscriptBox["Rx", "n2"], "[", "\[Pi]", "]"}], "]"}], ",", 
      RowBox[{
       SubscriptBox["C", "c"], "[", 
       RowBox[{
        SubscriptBox["Rx", "n1"], "[", 
        FractionBox["\[Pi]", "2"], "]"}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rz", "c"], "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{" ", "\[Pi]"}], "4"]}], "]"}]}], "}"}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", ",", "\"\<xx\>\"", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       SubscriptBox["Ry", "c"], "[", 
       FractionBox[
        RowBox[{"7", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rz", "n1"], "[", 
       FractionBox[
        RowBox[{"7", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{"R", "[", 
       RowBox[{
        FractionBox[
         RowBox[{"5", " ", "\[Pi]"}], "2"], ",", 
        RowBox[{
         SubscriptBox["X", "n1"], " ", 
         SubscriptBox["X", "n2"]}]}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rz", "n1"], "[", 
       FractionBox[
        RowBox[{"7", " ", "\[Pi]"}], "4"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rz", "n2"], "[", 
       FractionBox[
        RowBox[{"3", " ", "\[Pi]"}], "4"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Ry", "n1"], "[", 
       FractionBox["\[Pi]", "2"], "]"}], ",", 
      RowBox[{"R", "[", 
       RowBox[{
        FractionBox[
         RowBox[{"7", " ", "\[Pi]"}], "2"], ",", 
        RowBox[{
         SubscriptBox["X", "c"], " ", 
         SubscriptBox["X", "n2"]}]}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Ry", "n2"], "[", 
       FractionBox[
        RowBox[{"11", " ", "\[Pi]"}], "4"], "]"}], ",", 
      RowBox[{"R", "[", 
       RowBox[{
        FractionBox[
         RowBox[{"7", " ", "\[Pi]"}], "2"], ",", 
        RowBox[{
         SubscriptBox["X", "n1"], " ", 
         SubscriptBox["X", "n2"]}]}], "]"}], ",", 
      RowBox[{"R", "[", 
       RowBox[{
        FractionBox["\[Pi]", "4"], ",", 
        RowBox[{
         SubscriptBox["X", "c"], " ", 
         SubscriptBox["X", "n1"]}]}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rz", "n2"], "[", 
       FractionBox["\[Pi]", "4"], "]"}], ",", 
      RowBox[{"R", "[", 
       RowBox[{
        FractionBox[
         RowBox[{"5", " ", "\[Pi]"}], "2"], ",", 
        RowBox[{
         SubscriptBox["X", "c"], " ", 
         SubscriptBox["X", "n2"]}]}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Ry", "c"], "[", 
       FractionBox[
        RowBox[{"5", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rz", "n1"], "[", 
       FractionBox[
        RowBox[{"5", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Ry", "n2"], "[", 
       FractionBox[
        RowBox[{"7", " ", "\[Pi]"}], "4"], "]"}], ",", 
      RowBox[{"R", "[", 
       RowBox[{
        FractionBox[
         RowBox[{"7", " ", "\[Pi]"}], "2"], ",", 
        RowBox[{
         SubscriptBox["X", "n1"], " ", 
         SubscriptBox["X", "n2"]}]}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Ry", "n1"], "[", 
       FractionBox["\[Pi]", "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rz", "c"], "[", 
       FractionBox[
        RowBox[{"11", " ", "\[Pi]"}], "4"], "]"}]}], "}"}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", ",", "\"\<xxUE\>\"", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       SubscriptBox["Ry", "c"], "[", 
       FractionBox[
        RowBox[{"7", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rz", "n2"], "[", 
       FractionBox["\[Pi]", "2"], "]"}], ",", 
      RowBox[{"R", "[", 
       RowBox[{
        FractionBox[
         RowBox[{"7", " ", "\[Pi]"}], "2"], ",", 
        RowBox[{
         SubscriptBox["X", "n1"], " ", 
         SubscriptBox["X", "n2"]}]}], "]"}], ",", 
      RowBox[{"R", "[", 
       RowBox[{
        FractionBox[
         RowBox[{"7", " ", "\[Pi]"}], "2"], ",", 
        RowBox[{
         SubscriptBox["X", "c"], " ", 
         SubscriptBox["X", "n1"]}]}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Ry", "n1"], "[", 
       FractionBox[
        RowBox[{"5", " ", "\[Pi]"}], "4"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Ry", "n2"], "[", 
       FractionBox[
        RowBox[{"5", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{"R", "[", 
       RowBox[{
        FractionBox[
         RowBox[{"3", " ", "\[Pi]"}], "2"], ",", 
        RowBox[{
         SubscriptBox["X", "n1"], " ", 
         SubscriptBox["X", "n2"]}]}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rz", "n1"], "[", 
       FractionBox[
        RowBox[{"3", " ", "\[Pi]"}], "4"], "]"}], ",", 
      RowBox[{"R", "[", 
       RowBox[{
        FractionBox[
         RowBox[{"11", " ", "\[Pi]"}], "4"], ",", 
        RowBox[{
         SubscriptBox["X", "c"], " ", 
         SubscriptBox["X", "n2"]}]}], "]"}], ",", 
      RowBox[{"R", "[", 
       RowBox[{
        FractionBox["\[Pi]", "2"], ",", 
        RowBox[{
         SubscriptBox["X", "c"], " ", 
         SubscriptBox["X", "n1"]}]}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Ry", "c"], "[", 
       FractionBox["\[Pi]", "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rz", "c"], "[", 
       FractionBox[
        RowBox[{"5", " ", "\[Pi]"}], "4"], "]"}]}], "}"}], 
    "\[IndentingNewLine]", ",", "\"\<xxOBSX\>\"", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       SubscriptBox["Rz", "n2"], "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{" ", "\[Pi]"}], "2"]}], "]"}], ",", 
      RowBox[{"R", "[", 
       RowBox[{
        FractionBox["\[Pi]", "2"], ",", 
        RowBox[{
         SubscriptBox["X", "n1"], " ", 
         SubscriptBox["X", "n2"]}]}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rz", "n1"], "[", 
       FractionBox[
        RowBox[{"3", " ", "\[Pi]"}], "4"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Ry", "n2"], "[", 
       FractionBox["\[Pi]", "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Ry", "c"], "[", 
       FractionBox[
        RowBox[{"3", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{"R", "[", 
       RowBox[{
        FractionBox[
         RowBox[{"7", " ", "\[Pi]"}], "2"], ",", 
        RowBox[{
         SubscriptBox["X", "n1"], " ", 
         SubscriptBox["X", "n2"]}]}], "]"}], ",", 
      RowBox[{"R", "[", 
       RowBox[{
        FractionBox[
         RowBox[{"5", " ", "\[Pi]"}], "4"], ",", 
        RowBox[{
         SubscriptBox["X", "c"], " ", 
         SubscriptBox["X", "n2"]}]}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Ry", "n1"], "[", 
       FractionBox[
        RowBox[{"3", " ", "\[Pi]"}], "4"], "]"}], ",", 
      RowBox[{"R", "[", 
       RowBox[{
        FractionBox[
         RowBox[{" ", "\[Pi]"}], "2"], ",", 
        RowBox[{
         SubscriptBox["X", "c"], " ", 
         SubscriptBox["X", "n1"]}]}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Ry", "c"], "[", 
       FractionBox["\[Pi]", "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rz", "c"], "[", 
       FractionBox[
        RowBox[{"5", " ", "\[Pi]"}], "4"], "]"}]}], "}"}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", ",", "\"\<pswap\>\"", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       SubscriptBox["Rx", "n1"], "[", 
       FractionBox["\[Pi]", "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rx", "n2"], "[", 
       FractionBox[
        RowBox[{"5", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["pSWAP", 
        RowBox[{"n1", ",", "n2"}]], "[", 
       RowBox[{
        FractionBox[
         RowBox[{"31", " ", "\[Pi]"}], "8"], ",", 
        FractionBox[
         RowBox[{"3", " ", "\[Pi]"}], "4"]}], "]"}], ",", 
      RowBox[{
       SubscriptBox["pSWAP", 
        RowBox[{"n2", ",", "c"}]], "[", 
       RowBox[{
        FractionBox[
         RowBox[{"7", " ", "\[Pi]"}], "2"], ",", 
        FractionBox[
         RowBox[{"7", " ", "\[Pi]"}], "4"]}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rz", "n1"], "[", 
       FractionBox[
        RowBox[{"5", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Ry", "n1"], "[", 
       FractionBox[
        RowBox[{"7", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Ry", "n2"], "[", 
       FractionBox["\[Pi]", "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["pSWAP", 
        RowBox[{"n1", ",", "n2"}]], "[", 
       RowBox[{
        FractionBox["\[Pi]", "8"], ",", 
        FractionBox[
         RowBox[{"5", " ", "\[Pi]"}], "2"]}], "]"}], ",", 
      RowBox[{
       SubscriptBox["pSWAP", 
        RowBox[{"n1", ",", "c"}]], "[", 
       RowBox[{
        FractionBox["\[Pi]", "4"], ",", 
        FractionBox[
         RowBox[{"5", " ", "\[Pi]"}], "2"]}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rz", "n2"], "[", 
       FractionBox[
        RowBox[{"7", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Ry", "n2"], "[", 
       FractionBox[
        RowBox[{"5", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Ry", "c"], "[", 
       FractionBox["\[Pi]", "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["pSWAP", 
        RowBox[{"n2", ",", "c"}]], "[", 
       RowBox[{
        FractionBox[
         RowBox[{"19", " ", "\[Pi]"}], "8"], ",", 
        FractionBox["\[Pi]", "2"]}], "]"}], ",", 
      RowBox[{
       SubscriptBox["pSWAP", 
        RowBox[{"n1", ",", "c"}]], "[", 
       RowBox[{
        FractionBox["\[Pi]", "4"], ",", "\[Pi]"}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rz", "n1"], "[", 
       FractionBox["\[Pi]", "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Ry", "n1"], "[", 
       FractionBox["\[Pi]", "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Ry", "n2"], "[", 
       FractionBox[
        RowBox[{"7", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rz", "c"], "[", 
       FractionBox[
        RowBox[{"13", " ", "\[Pi]"}], "4"], "]"}]}], "}"}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", ",", "\"\<pswapUE\>\"", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       SubscriptBox["Rz", "n2"], "[", 
       FractionBox[
        RowBox[{"3", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["pSWAP", 
        RowBox[{"n1", ",", "n2"}]], "[", 
       RowBox[{
        FractionBox[
         RowBox[{"19", " ", "\[Pi]"}], "8"], ",", 
        FractionBox[
         RowBox[{"159", " ", "\[Pi]"}], "200"]}], "]"}], ",", 
      RowBox[{
       SubscriptBox["pSWAP", 
        RowBox[{"n2", ",", "c"}]], "[", 
       RowBox[{"n1", ",", 
        FractionBox[
         RowBox[{"13", " ", "\[Pi]"}], "8"]}], "]"}], ",", 
      RowBox[{
       SubscriptBox["pSWAP", 
        RowBox[{"n1", ",", "c"}]], "[", 
       RowBox[{"n1", ",", 
        FractionBox[
         RowBox[{"23", " ", "\[Pi]"}], "8"]}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Ry", "n2"], "[", 
       FractionBox[
        RowBox[{"7", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["pSWAP", 
        RowBox[{"n1", ",", "n2"}]], "[", 
       RowBox[{
        FractionBox[
         RowBox[{"15", " ", "\[Pi]"}], "4"], ",", 
        FractionBox[
         RowBox[{"7", " ", "\[Pi]"}], "2"]}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rz", "n1"], "[", 
       FractionBox[
        RowBox[{"7", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Ry", "n1"], "[", 
       FractionBox["\[Pi]", "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["pSWAP", 
        RowBox[{"n1", ",", "c"}]], "[", 
       RowBox[{
        FractionBox[
         RowBox[{"7", " ", "\[Pi]"}], "2"], ",", 
        FractionBox[
         RowBox[{"31", " ", "\[Pi]"}], "8"]}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rz", "c"], "[", 
       FractionBox[
        RowBox[{"7", " ", "\[Pi]"}], "4"], "]"}]}], "}"}], 
    "\[IndentingNewLine]", ",", "\"\<pswapOBSX\>\"", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       SubscriptBox["pSWAP", 
        RowBox[{"0", ",", "1"}]], "[", 
       RowBox[{
        FractionBox[
         RowBox[{"5", " ", "\[Pi]"}], "8"], ",", 
        FractionBox[
         RowBox[{"5", " ", "\[Pi]"}], "2"]}], "]"}], ",", 
      RowBox[{
       SubscriptBox["pSWAP", 
        RowBox[{"1", ",", "2"}]], "[", 
       RowBox[{
        FractionBox["\[Pi]", "2"], ",", 
        FractionBox[
         RowBox[{"13", " ", "\[Pi]"}], "4"]}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rz", "n1"], "[", 
       FractionBox["\[Pi]", "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Ry", "n1"], "[", 
       FractionBox[
        RowBox[{"3", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Ry", "n2"], "[", 
       FractionBox[
        RowBox[{"5", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["pSWAP", 
        RowBox[{"0", ",", "1"}]], "[", 
       RowBox[{
        FractionBox[
         RowBox[{"25", " ", "\[Pi]"}], "8"], ",", "0"}], "]"}], ",", 
      RowBox[{
       SubscriptBox["pSWAP", 
        RowBox[{"0", ",", "2"}]], "[", 
       RowBox[{"\[Pi]", ",", 
        FractionBox[
         RowBox[{"15", " ", "\[Pi]"}], "4"]}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rz", "c"], "[", 
       FractionBox[
        RowBox[{"13", " ", "\[Pi]"}], "4"], "]"}]}], "}"}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", ",", "\"\<cz\>\"", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       SubscriptBox["Rx", "n2"], "[", 
       FractionBox[
        RowBox[{"7", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["C", "n1"], "[", 
       RowBox[{
        SubscriptBox["Rz", "n2"], "[", 
        RowBox[{"3", " ", "\[Pi]"}], "]"}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Ry", "n2"], "[", 
       FractionBox[
        RowBox[{"3", " ", "\[Pi]"}], "4"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rz", "n2"], "[", 
       RowBox[{"3", " ", "\[Pi]"}], "]"}], ",", 
      RowBox[{
       SubscriptBox["C", "c"], "[", 
       RowBox[{
        SubscriptBox["Rz", "n2"], "[", "\[Pi]", "]"}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Ry", "n1"], "[", 
       FractionBox[
        RowBox[{"5", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Ry", "n2"], "[", 
       FractionBox[
        RowBox[{"7", " ", "\[Pi]"}], "4"], "]"}], ",", 
      RowBox[{
       SubscriptBox["C", "n2"], "[", 
       RowBox[{
        SubscriptBox["Rz", "n1"], "[", "\[Pi]", "]"}], "]"}], ",", 
      RowBox[{
       SubscriptBox["C", "c"], "[", 
       RowBox[{
        SubscriptBox["Rz", "n1"], "[", 
        FractionBox[
         RowBox[{"5", " ", "\[Pi]"}], "2"], "]"}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rx", "n1"], "[", 
       FractionBox[
        RowBox[{"3", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rx", "n2"], "[", 
       FractionBox[
        RowBox[{"3", " ", "\[Pi]"}], "4"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rz", "n1"], "[", 
       FractionBox[
        RowBox[{"5", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["C", "c"], "[", 
       RowBox[{
        SubscriptBox["Rz", "n2"], "[", "\[Pi]", "]"}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rx", "n1"], "[", "\[Pi]", "]"}], ",", 
      RowBox[{
       SubscriptBox["Rx", "n2"], "[", 
       FractionBox["\[Pi]", "4"], "]"}], ",", 
      RowBox[{
       SubscriptBox["C", "n2"], "[", 
       RowBox[{
        SubscriptBox["Rz", "n1"], "[", "\[Pi]", "]"}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Ry", "n2"], "[", 
       FractionBox[
        RowBox[{"7", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rx", "n1"], "[", 
       FractionBox["\[Pi]", "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rx", "c"], "[", "n1", "]"}], ",", 
      RowBox[{
       SubscriptBox["Rz", "n1"], "[", 
       FractionBox[
        RowBox[{"7", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rz", "n2"], "[", 
       FractionBox["\[Pi]", "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rz", "c"], "[", 
       FractionBox[
        RowBox[{"3", " ", "\[Pi]"}], "4"], "]"}]}], "}"}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", ",", "\"\<czUE\>\"", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       SubscriptBox["Ry", "n1"], "[", 
       FractionBox["\[Pi]", "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["C", "n2"], "[", 
       RowBox[{
        SubscriptBox["Rz", "n1"], "[", 
        RowBox[{"-", "\[Pi]"}], "]"}], "]"}], ",", 
      RowBox[{
       SubscriptBox["C", "c"], "[", 
       RowBox[{
        SubscriptBox["Rz", "n1"], "[", " ", "\[Pi]", "]"}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rx", "n1"], "[", 
       FractionBox[
        RowBox[{"3", " ", "\[Pi]"}], "4"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rx", "n2"], "[", 
       FractionBox[
        RowBox[{"5", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["C", "n2"], "[", 
       RowBox[{
        SubscriptBox["Rz", "n1"], "[", 
        RowBox[{"-", " ", "\[Pi]"}], "]"}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rx", "n1"], "[", 
       FractionBox[
        RowBox[{"11", " ", "\[Pi]"}], "4"], "]"}], ",", 
      RowBox[{
       SubscriptBox["C", "c"], "[", 
       RowBox[{
        SubscriptBox["Rz", "n2"], "[", 
        FractionBox[
         RowBox[{"7", " ", "\[Pi]"}], "2"], "]"}], "]"}], ",", 
      RowBox[{
       SubscriptBox["C", "c"], "[", 
       RowBox[{
        SubscriptBox["Rz", "n1"], "[", 
        RowBox[{"-", "\[Pi]"}], "]"}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rz", "c"], "[", 
       FractionBox[
        RowBox[{"9", " ", "\[Pi]"}], "4"], "]"}]}], "}"}], 
    "\[IndentingNewLine]", ",", "\"\<czOBSX\>\"", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       SubscriptBox["Ry", "n1"], "[", 
       FractionBox[
        RowBox[{"7", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["C", "n1"], "[", 
       RowBox[{
        SubscriptBox["Rz", "n2"], "[", "\[Pi]", "]"}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Ry", "n2"], "[", 
       FractionBox[
        RowBox[{"7", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rx", "n1"], "[", 
       FractionBox[
        RowBox[{"3", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["C", "n2"], "[", 
       RowBox[{
        SubscriptBox["Rz", "n1"], "[", 
        FractionBox[
         RowBox[{"3", " ", "\[Pi]"}], "2"], "]"}], "]"}], ",", 
      RowBox[{
       SubscriptBox["C", "c"], "[", 
       RowBox[{
        SubscriptBox["Rz", "n2"], "[", 
        FractionBox[
         RowBox[{"5", " ", "\[Pi]"}], "2"], "]"}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rx", "n1"], "[", 
       FractionBox["\[Pi]", "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["C", "c"], "[", 
       RowBox[{
        SubscriptBox["Rz", "n1"], "[", "\[Pi]", "]"}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rz", "c"], "[", 
       FractionBox[
        RowBox[{"15", " ", "\[Pi]"}], "4"], "]"}]}], "}"}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", ",", "\"\<xxx\>\"", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       SubscriptBox["Ry", "c"], "[", 
       FractionBox["\[Pi]", "2"], "]"}], ",", 
      RowBox[{"R", "[", 
       RowBox[{
        FractionBox[
         RowBox[{"11", " ", "\[Pi]"}], "4"], ",", 
        RowBox[{
         SubscriptBox["X", "n1"], " ", 
         SubscriptBox["X", "n2"]}]}], "]"}], ",", 
      RowBox[{"R", "[", 
       RowBox[{
        FractionBox["\[Pi]", "4"], ",", 
        RowBox[{
         SubscriptBox["X", "c"], " ", 
         SubscriptBox["X", "n1"], " ", 
         SubscriptBox["X", "n2"]}]}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Ry", "n1"], "[", 
       FractionBox[
        RowBox[{"3", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Ry", "n2"], "[", 
       FractionBox[
        RowBox[{"5", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{"R", "[", 
       RowBox[{
        FractionBox["\[Pi]", "4"], ",", 
        RowBox[{
         SubscriptBox["X", "n1"], " ", 
         SubscriptBox["X", "n2"]}]}], "]"}], ",", 
      RowBox[{"R", "[", 
       RowBox[{
        FractionBox[
         RowBox[{"3", " ", "\[Pi]"}], "4"], ",", 
        RowBox[{
         SubscriptBox["X", "c"], " ", 
         SubscriptBox["X", "n1"], " ", 
         SubscriptBox["X", "n2"]}]}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Ry", "n1"], "[", 
       FractionBox["\[Pi]", "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Ry", "n2"], "[", 
       FractionBox[
        RowBox[{"3", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rz", "n1"], "[", 
       FractionBox[
        RowBox[{"5", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rz", "n2"], "[", 
       FractionBox[
        RowBox[{"3", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{"R", "[", 
       RowBox[{
        FractionBox[
         RowBox[{"5", " ", "\[Pi]"}], "4"], ",", 
        RowBox[{
         SubscriptBox["X", "n1"], " ", 
         SubscriptBox["X", "n2"]}]}], "]"}], ",", 
      RowBox[{"R", "[", 
       RowBox[{
        FractionBox[
         RowBox[{"15", " ", "\[Pi]"}], "4"], ",", 
        RowBox[{
         SubscriptBox["X", "c"], " ", 
         SubscriptBox["X", "n1"], " ", 
         SubscriptBox["X", "n2"]}]}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Ry", "c"], "[", 
       FractionBox[
        RowBox[{"3", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rz", "n1"], "[", 
       FractionBox[
        RowBox[{"7", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rz", "n2"], "[", 
       FractionBox["\[Pi]", "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rz", "c"], "[", 
       FractionBox[
        RowBox[{"11", " ", "\[Pi]"}], "4"], "]"}]}], "}"}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", ",", "\"\<xxxUE\>\"", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       SubscriptBox["Ry", "c"], "[", 
       FractionBox["\[Pi]", "2"], "]"}], ",", 
      RowBox[{"R", "[", 
       RowBox[{
        FractionBox[
         RowBox[{"3", " ", "\[Pi]"}], "4"], ",", 
        RowBox[{
         SubscriptBox["X", "c"], " ", 
         SubscriptBox["X", "n1"], " ", 
         SubscriptBox["X", "n2"]}]}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Ry", "n1"], "[", 
       FractionBox["\[Pi]", "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Ry", "n2"], "[", 
       FractionBox[
        RowBox[{"7", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{"R", "[", 
       RowBox[{
        FractionBox[
         RowBox[{"13", " ", "\[Pi]"}], "4"], ",", 
        RowBox[{
         SubscriptBox["X", "c"], " ", 
         SubscriptBox["X", "n1"], " ", 
         SubscriptBox["X", "n2"]}]}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rz", "n1"], "[", 
       FractionBox[
        RowBox[{"5", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rz", "n2"], "[", 
       FractionBox["\[Pi]", "2"], "]"}], ",", 
      RowBox[{"R", "[", 
       RowBox[{
        FractionBox[
         RowBox[{"11", " ", "\[Pi]"}], "4"], ",", 
        RowBox[{
         SubscriptBox["X", "c"], " ", 
         SubscriptBox["X", "n1"], " ", 
         SubscriptBox["X", "n2"]}]}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Ry", "c"], "[", 
       FractionBox[
        RowBox[{"3", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rz", "c"], "[", 
       FractionBox[
        RowBox[{"13", " ", "\[Pi]"}], "4"], "]"}]}], "}"}], 
    "\[IndentingNewLine]", ",", "\"\<xxxOBSX\>\"", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       SubscriptBox["Ry", "c"], "[", 
       FractionBox["\[Pi]", "2"], "]"}], ",", 
      RowBox[{"R", "[", 
       RowBox[{
        FractionBox[
         RowBox[{"5", " ", "\[Pi]"}], "4"], ",", 
        RowBox[{
         SubscriptBox["X", "c"], " ", 
         SubscriptBox["X", "n1"], " ", 
         SubscriptBox["X", "n2"]}]}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Ry", "n2"], "[", 
       FractionBox["\[Pi]", "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rz", "n1"], "[", 
       FractionBox[
        RowBox[{"3", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{"R", "[", 
       RowBox[{
        FractionBox["\[Pi]", "2"], ",", 
        RowBox[{
         SubscriptBox["X", "n1"], " ", 
         SubscriptBox["X", "n2"]}]}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Ry", "n1"], "[", 
       FractionBox[
        RowBox[{"15", " ", "\[Pi]"}], "4"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rz", "n2"], "[", 
       FractionBox[
        RowBox[{"15", " ", "\[Pi]"}], "4"], "]"}], ",", 
      RowBox[{"R", "[", 
       RowBox[{
        FractionBox["\[Pi]", "2"], ",", 
        RowBox[{
         SubscriptBox["X", "c"], " ", 
         SubscriptBox["X", "n1"], " ", 
         SubscriptBox["X", "n2"]}]}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Ry", "c"], "[", 
       FractionBox[
        RowBox[{"3", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rz", "c"], "[", 
       FractionBox[
        RowBox[{"9", " ", "\[Pi]"}], "4"], "]"}]}], "}"}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", ",", "\"\<ccphase\>\"", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       SubscriptBox["Rx", "n2"], "[", 
       FractionBox[
        RowBox[{"5", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["C", "n2"], "[", 
       RowBox[{
        SubscriptBox["Rz", "n1"], "[", "\[Pi]", "]"}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Ry", "n2"], "[", 
       FractionBox["\[Pi]", "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rx", "n1"], "[", 
       FractionBox["\[Pi]", "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["CCPhase", 
        RowBox[{"c", ",", "n1", ",", "n2"}]], "[", 
       RowBox[{"2", " ", "\[Pi]"}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Ry", "n2"], "[", 
       FractionBox[
        RowBox[{"7", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rx", "n1"], "[", 
       FractionBox[
        RowBox[{"7", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["C", "n2"], "[", 
       RowBox[{
        SubscriptBox["Rz", "n1"], "[", 
        RowBox[{"3", " ", "\[Pi]"}], "]"}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rx", "n2"], "[", 
       FractionBox[
        RowBox[{"3", " ", "\[Pi]"}], "2"], "]"}]}], "}"}], 
    "\[IndentingNewLine]", ",", "\"\<ccphaseUE\>\"", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       SubscriptBox["Ry", "n1"], "[", 
       FractionBox[
        RowBox[{"7", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["C", "n2"], "[", 
       RowBox[{
        SubscriptBox["Rz", "n1"], "[", "\[Pi]", "]"}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Ry", "n1"], "[", 
       FractionBox[
        RowBox[{"5", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rx", "n2"], "[", 
       FractionBox[
        RowBox[{"7", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["CCPhase", 
        RowBox[{"c", ",", "n1", ",", "n2"}]], "[", 
       RowBox[{"2", " ", "\[Pi]"}], "]"}]}], "}"}], "\[IndentingNewLine]", 
    ",", "\"\<ccphaseOBSX\>\"", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       SubscriptBox["Ry", "n2"], "[", 
       FractionBox[
        RowBox[{"5", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["C", "n2"], "[", 
       RowBox[{
        SubscriptBox["Rz", "n1"], "[", " ", "\[Pi]", "]"}], "]"}], ",", 
      RowBox[{
       SubscriptBox["C", "c"], "[", 
       RowBox[{
        SubscriptBox["Rz", "n2"], "[", 
        RowBox[{"-", " ", "\[Pi]"}], "]"}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Ry", "n1"], "[", 
       FractionBox["\[Pi]", "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rx", "n2"], "[", 
       FractionBox[
        RowBox[{"5", " ", "\[Pi]"}], "2"], "]"}], ",", 
      RowBox[{
       SubscriptBox["CCPhase", 
        RowBox[{"c", ",", "n1", ",", "n2"}]], "[", 
       RowBox[{"2", "\[Pi]"}], "]"}], ",", 
      RowBox[{
       SubscriptBox["Rz", "c"], "[", 
       FractionBox["\[Pi]", "2"], "]"}]}], "}"}]}], "\[IndentingNewLine]", 
   "]"}]}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.8293750045056553`*^9, 3.829375049621785*^9}, {
   3.82937530694094*^9, 3.829375328463464*^9}, {3.8293755663027253`*^9, 
   3.829375587677044*^9}, {3.829375952964411*^9, 3.829375978924985*^9}, {
   3.829376071087164*^9, 3.8293761821782713`*^9}, {3.829376218162442*^9, 
   3.8293762184154406`*^9}, {3.829376253341789*^9, 3.8293762663407063`*^9}, 
   3.829376318467383*^9, {3.8293764751693687`*^9, 3.8293765326304975`*^9}, 
   3.829376564528343*^9, {3.829376621475816*^9, 3.8293766602949376`*^9}, {
   3.82937669065119*^9, 3.8293767975175676`*^9}, {3.8293768431580334`*^9, 
   3.829376863279248*^9}, {3.8293768963824663`*^9, 3.8293769534651165`*^9}, {
   3.8293772043562417`*^9, 3.829377250027317*^9}, {3.8293772871047907`*^9, 
   3.829377290318157*^9}, {3.829377323455752*^9, 3.8293774020983534`*^9}, {
   3.829377770960002*^9, 3.8293777876659293`*^9}, {3.8293778398233614`*^9, 
   3.8293778969230027`*^9}, {3.829377993874569*^9, 3.8293779961554346`*^9}, {
   3.829538295637911*^9, 3.8295384529878445`*^9}, 3.82962720526433*^9, {
   3.829627317334736*^9, 3.8296274364508467`*^9}, {3.829627509266594*^9, 
   3.8296275529711256`*^9}, {3.829627598717691*^9, 3.8296276001751165`*^9}, {
   3.8317253156592484`*^9, 3.831725359230248*^9}, {3.831725413527099*^9, 
   3.831725446010893*^9}, {3.8317257889455385`*^9, 3.8317258010659943`*^9}, {
   3.8317261027634115`*^9, 3.8317261032524724`*^9}},
 CellLabel->"In[7]:=",ExpressionUUID->"d862482c-9b4a-49dc-b1ec-d006a34c40cb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["1) Type A and Type B recompilations", "Section"]], \
"Subsubsection",
 CellChangeTimes->{{3.826872090791264*^9, 3.8268721137745934`*^9}, {
  3.826872162007494*^9, 3.826872162855002*^9}, {3.8268758156045923`*^9, 
  3.826875819318865*^9}, {3.8268761409065065`*^9, 3.8268761426449947`*^9}, {
  3.8268892945064564`*^9, 3.826889318494529*^9}, {3.82689704773733*^9, 
  3.826897048300024*^9}, {3.8317261453455906`*^9, 
  3.8317261584001446`*^9}},ExpressionUUID->"1ff7798e-b57f-4f99-b80b-\
a1ed14b8ee28"],

Cell[TextData[{
 StyleBox["Type A recompilation: ",
  FontWeight->"Bold"],
 "fully equivalent recompilation of the elementary controlled-SWAP gate",
 StyleBox["\nType B recompilation: ",
  FontWeight->"Bold"],
 "the elementary controlled-SWAP gate was recompiled up to an SU(4) freedom \
on the two swapped qubits"
}], "Text",
 CellChangeTimes->{{3.8262650902861843`*^9, 3.826265091099492*^9}, {
  3.8262652312441196`*^9, 3.826265473334661*^9}, {3.8264936657315893`*^9, 
  3.826493710958598*^9}, {3.826493827200305*^9, 3.8264938282809477`*^9}, {
  3.8264939742007303`*^9, 3.82649405518382*^9}, {3.8272392140975666`*^9, 
  3.827239224966739*^9}, {3.827239268488271*^9, 3.8272392931488256`*^9}, {
  3.8317261941842413`*^9, 3.8317262652560663`*^9}},
 Background->RGBColor[
  0.88, 1, 0.88],ExpressionUUID->"f3b5fe19-9cd4-406a-8c1e-6557540b0cd1"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[Rho]", "=", 
   RowBox[{"CreateDensityQureg", "[", "3", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gateCanDo", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<crx\>\"", ",", "\"\<crxUE\>\"", ",", "\"\<xx\>\"", ",", 
     "\"\<xxUE\>\"", ",", "\"\<pswap\>\"", ",", "\"\<pswapUE\>\"", ",", 
     "\"\<cz\>\"", ",", "\"\<czUE\>\"", ",", "\"\<xxx\>\"", ",", 
     "\"\<xxxUE\>\"", ",", "\"\<ccphase\>\"", ",", "\"\<ccphaseUE\>\""}], 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dat", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"gateTyp", "=", 
      RowBox[{"gateCanDo", "[", 
       RowBox[{"[", "k", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"cSWAPCirc", "=", 
      RowBox[{"gate", "[", 
       RowBox[{"2", ",", "0", ",", "1", ",", "gateTyp"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"circ", "=", 
      RowBox[{
       RowBox[{"Flatten", "@", 
        RowBox[{"{", 
         RowBox[{
          SubscriptBox["H", "2"], ",", "cSWAPCirc", ",", 
          SubscriptBox["H", "2"]}], "}"}]}], "/.", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{
           SubscriptBox["pSWAP", 
            RowBox[{"n1_", ",", "n2_"}]], "[", 
           RowBox[{"p1_", ",", "p2_"}], "]"}], "\[RuleDelayed]", 
          RowBox[{
           SubscriptBox["U", 
            RowBox[{"n1", ",", "n2"}]], "[", 
           RowBox[{"pswap", "[", 
            RowBox[{"p1", ",", "p2"}], "]"}], "]"}]}], ",", 
         RowBox[{
          RowBox[{
           SubscriptBox["CCPhase", 
            RowBox[{"c_", ",", "n1_", ",", "n2_"}]], "[", "p1_", "]"}], 
          "\[RuleDelayed]", 
          RowBox[{
           SubscriptBox["U", 
            RowBox[{"c", ",", "n1", ",", "n2"}]], "[", 
           RowBox[{"ccphasemat", "[", "p1", "]"}], "]"}]}]}], "}"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"twoQubitGateCount", "=", 
      RowBox[{"Count", "[", 
       RowBox[{"cSWAPCirc", ",", 
        RowBox[{
         RowBox[{"R", "[", "__", "]"}], "|", 
         RowBox[{
          SubscriptBox["U", "__"], "[", "__", "]"}], "|", 
         RowBox[{
          SubscriptBox["C", "__"], "[", "__", "]"}], "|", 
         RowBox[{
          SubscriptBox["CCPhase", "__"], "[", "__", "]"}], "|", 
         RowBox[{
          SubscriptBox["pSWAP", "__"], "[", "__", "]"}]}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"rand", "=", 
      RowBox[{"With", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"r", "=", 
          RowBox[{"RandomComplex", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "1"}], "-", "\[ImaginaryI]"}], ",", 
              RowBox[{"1", "+", "\[ImaginaryI]"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}]}], "]"}]}], "}"}], ",", 
        "\[IndentingNewLine]", "\t", 
        RowBox[{
         RowBox[{"r", " ", ".", " ", 
          RowBox[{"r", "\[ConjugateTranspose]"}]}], " ", "/", " ", 
         RowBox[{"Tr", "[", 
          RowBox[{"r", " ", ".", " ", 
           RowBox[{"r", "\[ConjugateTranspose]"}]}], "]"}]}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"SetQuregMatrix", "[", 
      RowBox[{"\[Rho]", ",", 
       RowBox[{"KroneckerProduct", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "0"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "0"}], "}"}]}], "}"}], ",", 
         RowBox[{"KroneckerProduct", "[", 
          RowBox[{"rand", ",", "rand"}], "]"}]}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ApplyCircuit", "[", 
      RowBox[{"circ", ",", "\[Rho]"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"circPic", "=", 
      RowBox[{"DrawCircuit", "[", 
       RowBox[{
        RowBox[{"cSWAPCirc", "/.", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{
             SubscriptBox["CCPhase", 
              RowBox[{"c_", ",", "n1_", ",", "n2_"}]], "[", "__", "]"}], 
            "\[RuleDelayed]", 
            RowBox[{
             SubscriptBox["C", 
              RowBox[{"c", ",", "n1"}]], "[", 
             SubscriptBox["Z", "n2"], "]"}]}], ",", 
           RowBox[{
            RowBox[{
             SubscriptBox["pSWAP", 
              RowBox[{"n1_", ",", "n2_"}]], "[", "__", "]"}], 
            "\[RuleDelayed]", 
            SubscriptBox["pSW", 
             RowBox[{"n1", ",", "n2"}]]}]}], "}"}]}], ",", 
        RowBox[{"ImageSize", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Automatic", ",", "60"}], "}"}]}], ",", 
        RowBox[{"FontFamily", "\[Rule]", "\"\<Times New Roman\>\""}]}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"dat", ",", 
       RowBox[{"{", 
        RowBox[{"circPic", ",", "twoQubitGateCount", ",", 
         RowBox[{
          RowBox[{"Length", "@", "cSWAPCirc"}], "-", "twoQubitGateCount"}]}], 
        "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{
      "\"\<Gate Type: \>\"", ",", "gateTyp", ",", 
       "\"\<\\n#2-qubit gates:  \>\"", " ", ",", "twoQubitGateCount", ",", 
       "\"\<\\n#1-qubit gates:  \>\"", ",", 
       RowBox[{
        RowBox[{"Length", "@", "cSWAPCirc"}], "-", "twoQubitGateCount"}], 
       ",", "\"\<(-1) by removing the Z gate at the end\\n\>\"", ",", 
       "\[IndentingNewLine]", "circPic", "\[IndentingNewLine]", ",", 
       "\"\<\\n\>\"", ",", 
       RowBox[{"gate", "[", 
        RowBox[{"c", ",", "n1", ",", "n2", ",", "gateTyp"}], "]"}], ",", 
       "\[IndentingNewLine]", " ", "\"\<\\nis the circuit correct:   \>\"", 
       "\[IndentingNewLine]", ",", 
       RowBox[{
        RowBox[{"Chop", "[", 
         RowBox[{
          RowBox[{"2", 
           RowBox[{"CalcProbOfOutcome", "[", 
            RowBox[{"\[Rho]", ",", "2", ",", "0"}], "]"}]}], "-", "1", "-", 
          RowBox[{"Tr", "[", 
           RowBox[{"rand", ".", "rand"}], "]"}]}], "]"}], "\[Equal]", "0"}], 
       ",", "\"\<\\n\\n\>\""}], "\[IndentingNewLine]", "]"}], ";"}], 
    "\[IndentingNewLine]", ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", "1", ",", 
      RowBox[{"Length", "@", "gateCanDo"}]}], "}"}]}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DestroyAllQuregs", "[", "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.831725837821173*^9, 3.831725838939871*^9}, {
  3.8317258725536437`*^9, 3.831725881986624*^9}, {3.831725912139662*^9, 
  3.8317259309957757`*^9}},
 CellLabel->"In[13]:=",ExpressionUUID->"92d50411-2e68-4056-a9f8-a69c97438ddb"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Gate Type: \"\>", "\[InvisibleSpace]", "\<\"crx\"\>", 
   "\[InvisibleSpace]", "\<\"\\n#2-qubit gates:  \"\>", "\[InvisibleSpace]", 
   "6", "\[InvisibleSpace]", "\<\"\\n#1-qubit gates:  \"\>", 
   "\[InvisibleSpace]", "7", 
   "\[InvisibleSpace]", "\<\"(-1) by removing the Z gate at the end\\n\"\>", 
   "\[InvisibleSpace]", 
   GraphicsBox[
    {EdgeForm[GrayLevel[0]], FaceForm[GrayLevel[
     1]], {{LineBox[{{0, 0.5}, {1, 0.5}}], LineBox[{{0, 1.5}, {1, 1.5}}], 
       LineBox[{{0, 2.5}, {1, 2.5}}]}, {LineBox[{{1, 0.5}, {2, 0.5}}], 
       LineBox[{{1, 1.5}, {2, 1.5}}], LineBox[{{1, 2.5}, {2, 2.5}}]}, {
       LineBox[{{2, 0.5}, {3, 0.5}}], LineBox[{{2, 1.5}, {3, 1.5}}], 
       LineBox[{{2, 2.5}, {3, 2.5}}]}, {LineBox[{{3, 0.5}, {4, 0.5}}], 
       LineBox[{{3, 1.5}, {4, 1.5}}], LineBox[{{3, 2.5}, {4, 2.5}}]}, {
       LineBox[{{4, 0.5}, {5, 0.5}}], LineBox[{{4, 1.5}, {5, 1.5}}], 
       LineBox[{{4, 2.5}, {5, 2.5}}]}, {LineBox[{{5, 0.5}, {6, 0.5}}], 
       LineBox[{{5, 1.5}, {6, 1.5}}], LineBox[{{5, 2.5}, {6, 2.5}}]}, {
       LineBox[{{6, 0.5}, {7, 0.5}}], LineBox[{{6, 1.5}, {7, 1.5}}], 
       LineBox[{{6, 2.5}, {7, 2.5}}]}, {LineBox[{{7, 0.5}, {8, 0.5}}], 
       LineBox[{{7, 1.5}, {8, 1.5}}], LineBox[{{7, 2.5}, {8, 2.5}}]}, {
       LineBox[{{8, 0.5}, {9, 0.5}}], LineBox[{{8, 1.5}, {9, 1.5}}], 
       LineBox[{{8, 2.5}, {9, 2.5}}]}, {LineBox[{{9, 0.5}, {10, 0.5}}], 
       LineBox[{{9, 1.5}, {10, 1.5}}], LineBox[{{9, 2.5}, {10, 2.5}}]}}, {{
       RectangleBox[{0.1, 0.1}, {0.9, 0.9}], 
       InsetBox["\<\"Ry\"\>", {0.5, 0.5}]}, {
       RectangleBox[{0.1, 1.1}, {0.9, 1.9}], 
       InsetBox["\<\"Rz\"\>", {0.5, 1.5}]}, {
       {FaceForm[GrayLevel[0]], DiskBox[{1.5, 0.5}, 0.1], 
        LineBox[{{1.5, 0.5}, {1.5, 1.5}}]}, {
        RectangleBox[{1.1, 1.1}, {1.9, 1.9}], 
        InsetBox["\<\"Rx\"\>", {1.5, 1.5}]}}, {
       RectangleBox[{2.1, 1.1}, {2.9, 1.9}], 
       InsetBox["\<\"Rz\"\>", {2.5, 1.5}]}, {
       {FaceForm[GrayLevel[0]], DiskBox[{3.5, 2.5}, 0.1], 
        LineBox[{{3.5, 1.5}, {3.5, 2.5}}]}, {
        RectangleBox[{3.1, 1.1}, {3.9, 1.9}], 
        InsetBox["\<\"Rx\"\>", {3.5, 1.5}]}}, {
       {FaceForm[GrayLevel[0]], DiskBox[{4.5, 2.5}, 0.1], 
        LineBox[{{4.5, 0.5}, {4.5, 2.5}}]}, {
        RectangleBox[{4.1, 0.1}, {4.9, 0.9}], 
        InsetBox["\<\"Rx\"\>", {4.5, 0.5}]}}, {
       {FaceForm[GrayLevel[0]], DiskBox[{5.5, 0.5}, 0.1], 
        LineBox[{{5.5, 0.5}, {5.5, 1.5}}]}, {
        RectangleBox[{5.1, 1.1}, {5.9, 1.9}], 
        InsetBox["\<\"Rx\"\>", {5.5, 1.5}]}}, {
       RectangleBox[{6.1, 0.1}, {6.9, 0.9}], 
       InsetBox["\<\"Rz\"\>", {6.5, 0.5}]}, {
       RectangleBox[{6.1, 1.1}, {6.9, 1.9}], 
       InsetBox["\<\"Rz\"\>", {6.5, 1.5}]}, {
       {FaceForm[GrayLevel[0]], DiskBox[{7.5, 2.5}, 0.1], 
        LineBox[{{7.5, 0.5}, {7.5, 2.5}}]}, {
        RectangleBox[{7.1, 0.1}, {7.9, 0.9}], 
        InsetBox["\<\"Rx\"\>", {7.5, 0.5}]}}, {
       RectangleBox[{8.1, 0.1}, {8.9, 0.9}], 
       InsetBox["\<\"Ry\"\>", {8.5, 0.5}]}, {
       RectangleBox[{8.1, 2.1}, {8.9, 2.9}], 
       InsetBox["\<\"Rz\"\>", {8.5, 2.5}]}, {
       {FaceForm[GrayLevel[0]], DiskBox[{9.5, 1.5}, 0.1], 
        LineBox[{{9.5, 0.5}, {9.5, 1.5}}]}, {
        RectangleBox[{9.1, 0.1}, {9.9, 0.9}], 
        InsetBox["\<\"Rx\"\>", {9.5, 0.5}]}}}},
    ImageSize->{Automatic, 60},
    PlotRangePadding->None], "\[InvisibleSpace]", "\<\"\\n\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      SubscriptBox["Ry", "n1"], "[", 
      FractionBox["\[Pi]", "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rz", "n2"], "[", 
      FractionBox[
       RowBox[{"5", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["C", "n1"], "[", 
      RowBox[{
       SubscriptBox["Rx", "n2"], "[", "\[Pi]", "]"}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rz", "n2"], "[", 
      FractionBox[
       RowBox[{"7", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["C", "c"], "[", 
      RowBox[{
       SubscriptBox["Rx", "n2"], "[", 
       FractionBox[
        RowBox[{"5", " ", "\[Pi]"}], "2"], "]"}], "]"}], ",", 
     RowBox[{
      SubscriptBox["C", "c"], "[", 
      RowBox[{
       SubscriptBox["Rx", "n1"], "[", 
       FractionBox["\[Pi]", "2"], "]"}], "]"}], ",", 
     RowBox[{
      SubscriptBox["C", "n1"], "[", 
      RowBox[{
       SubscriptBox["Rx", "n2"], "[", "\[Pi]", "]"}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rz", "n1"], "[", 
      FractionBox[
       RowBox[{"3", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["C", "c"], "[", 
      RowBox[{
       SubscriptBox["Rx", "n1"], "[", 
       FractionBox[
        RowBox[{"3", " ", "\[Pi]"}], "2"], "]"}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Ry", "n1"], "[", 
      FractionBox[
       RowBox[{"7", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rz", "n2"], "[", 
      FractionBox[
       RowBox[{"3", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["C", "n2"], "[", 
      RowBox[{
       SubscriptBox["Rx", "n1"], "[", "\[Pi]", "]"}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rz", "c"], "[", 
      FractionBox[
       RowBox[{"7", " ", "\[Pi]"}], "4"], "]"}]}], "}"}], 
   "\[InvisibleSpace]", "\<\"\\nis the circuit correct:   \"\>", 
   "\[InvisibleSpace]", "True", "\[InvisibleSpace]", "\<\"\\n\\n\"\>"}],
  SequenceForm[
  "Gate Type: ", "crx", "\n#2-qubit gates:  ", 6, "\n#1-qubit gates:  ", 7, 
   "(-1) by removing the Z gate at the end\n", 
   Graphics[{
     FaceForm[
      GrayLevel[1]], 
     EdgeForm[
      GrayLevel[0]], {{
       Line[{{0, 0.5}, {1, 0.5}}], 
       Line[{{0, 1.5}, {1, 1.5}}], 
       Line[{{0, 2.5}, {1, 2.5}}]}, {
       Line[{{1, 0.5}, {2, 0.5}}], 
       Line[{{1, 1.5}, {2, 1.5}}], 
       Line[{{1, 2.5}, {2, 2.5}}]}, {
       Line[{{2, 0.5}, {3, 0.5}}], 
       Line[{{2, 1.5}, {3, 1.5}}], 
       Line[{{2, 2.5}, {3, 2.5}}]}, {
       Line[{{3, 0.5}, {4, 0.5}}], 
       Line[{{3, 1.5}, {4, 1.5}}], 
       Line[{{3, 2.5}, {4, 2.5}}]}, {
       Line[{{4, 0.5}, {5, 0.5}}], 
       Line[{{4, 1.5}, {5, 1.5}}], 
       Line[{{4, 2.5}, {5, 2.5}}]}, {
       Line[{{5, 0.5}, {6, 0.5}}], 
       Line[{{5, 1.5}, {6, 1.5}}], 
       Line[{{5, 2.5}, {6, 2.5}}]}, {
       Line[{{6, 0.5}, {7, 0.5}}], 
       Line[{{6, 1.5}, {7, 1.5}}], 
       Line[{{6, 2.5}, {7, 2.5}}]}, {
       Line[{{7, 0.5}, {8, 0.5}}], 
       Line[{{7, 1.5}, {8, 1.5}}], 
       Line[{{7, 2.5}, {8, 2.5}}]}, {
       Line[{{8, 0.5}, {9, 0.5}}], 
       Line[{{8, 1.5}, {9, 1.5}}], 
       Line[{{8, 2.5}, {9, 2.5}}]}, {
       Line[{{9, 0.5}, {10, 0.5}}], 
       Line[{{9, 1.5}, {10, 1.5}}], 
       Line[{{9, 2.5}, {10, 2.5}}]}}, {{
       Rectangle[{0.1, 0.1}, {0.9, 0.9}], 
       Text["Ry", {0.5, 0.5}]}, {
       Rectangle[{0.1, 1.1}, {0.9, 1.9}], 
       Text["Rz", {0.5, 1.5}]}, {{
        FaceForm[
         GrayLevel[0]], {
         Disk[{1.5, 0.5}, 0.1]}, 
        Line[{{1.5, 0.5}, {1.5, 1.5}}]}, {
        Rectangle[{1.1, 1.1}, {1.9, 1.9}], 
        Text["Rx", {1.5, 1.5}]}}, {
       Rectangle[{2.1, 1.1}, {2.9, 1.9}], 
       Text["Rz", {2.5, 1.5}]}, {{
        FaceForm[
         GrayLevel[0]], {
         Disk[{3.5, 2.5}, 0.1]}, 
        Line[{{3.5, 1.5}, {3.5, 2.5}}]}, {
        Rectangle[{3.1, 1.1}, {3.9, 1.9}], 
        Text["Rx", {3.5, 1.5}]}}, {{
        FaceForm[
         GrayLevel[0]], {
         Disk[{4.5, 2.5}, 0.1]}, 
        Line[{{4.5, 0.5}, {4.5, 2.5}}]}, {
        Rectangle[{4.1, 0.1}, {4.9, 0.9}], 
        Text["Rx", {4.5, 0.5}]}}, {{
        FaceForm[
         GrayLevel[0]], {
         Disk[{5.5, 0.5}, 0.1]}, 
        Line[{{5.5, 0.5}, {5.5, 1.5}}]}, {
        Rectangle[{5.1, 1.1}, {5.9, 1.9}], 
        Text["Rx", {5.5, 1.5}]}}, {
       Rectangle[{6.1, 0.1}, {6.9, 0.9}], 
       Text["Rz", {6.5, 0.5}]}, {
       Rectangle[{6.1, 1.1}, {6.9, 1.9}], 
       Text["Rz", {6.5, 1.5}]}, {{
        FaceForm[
         GrayLevel[0]], {
         Disk[{7.5, 2.5}, 0.1]}, 
        Line[{{7.5, 0.5}, {7.5, 2.5}}]}, {
        Rectangle[{7.1, 0.1}, {7.9, 0.9}], 
        Text["Rx", {7.5, 0.5}]}}, {
       Rectangle[{8.1, 0.1}, {8.9, 0.9}], 
       Text["Ry", {8.5, 0.5}]}, {
       Rectangle[{8.1, 2.1}, {8.9, 2.9}], 
       Text["Rz", {8.5, 2.5}]}, {{
        FaceForm[
         GrayLevel[0]], {
         Disk[{9.5, 1.5}, 0.1]}, 
        Line[{{9.5, 0.5}, {9.5, 1.5}}]}, {
        Rectangle[{9.1, 0.1}, {9.9, 0.9}], 
        Text["Rx", {9.5, 0.5}]}}}}, {ImageSize -> {Automatic, 60}}, ImageSize -> 
    330, PlotRangePadding -> None], "\n", {
    Subscript[QuEST`Gate`Ry, $CellContext`n1][Rational[1, 2] Pi], 
    Subscript[QuEST`Gate`Rz, $CellContext`n2][Rational[5, 2] Pi], 
    Subscript[C, $CellContext`n1][
     Subscript[QuEST`Gate`Rx, $CellContext`n2][Pi]], 
    Subscript[QuEST`Gate`Rz, $CellContext`n2][Rational[7, 2] Pi], 
    Subscript[C, $CellContext`c][
     Subscript[QuEST`Gate`Rx, $CellContext`n2][Rational[5, 2] Pi]], 
    Subscript[C, $CellContext`c][
     Subscript[QuEST`Gate`Rx, $CellContext`n1][Rational[1, 2] Pi]], 
    Subscript[C, $CellContext`n1][
     Subscript[QuEST`Gate`Rx, $CellContext`n2][Pi]], 
    Subscript[QuEST`Gate`Rz, $CellContext`n1][Rational[3, 2] Pi], 
    Subscript[C, $CellContext`c][
     Subscript[QuEST`Gate`Rx, $CellContext`n1][Rational[3, 2] Pi]], 
    Subscript[QuEST`Gate`Ry, $CellContext`n1][Rational[7, 2] Pi], 
    Subscript[QuEST`Gate`Rz, $CellContext`n2][Rational[3, 2] Pi], 
    Subscript[C, $CellContext`n2][
     Subscript[QuEST`Gate`Rx, $CellContext`n1][Pi]], 
    Subscript[QuEST`Gate`Rz, $CellContext`c][Rational[7, 4] Pi]}, 
   "\nis the circuit correct:   ", True, "\n\n"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.831725854855904*^9, 3.8317258823995237`*^9}, 
   3.8317259314680758`*^9, 3.8317263600340323`*^9},
 CellLabel->
  "During evaluation of \
In[13]:=",ExpressionUUID->"70440f64-b715-4c77-b3d9-d49109b36149"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Gate Type: \"\>", "\[InvisibleSpace]", "\<\"crxUE\"\>", 
   "\[InvisibleSpace]", "\<\"\\n#2-qubit gates:  \"\>", "\[InvisibleSpace]", 
   "5", "\[InvisibleSpace]", "\<\"\\n#1-qubit gates:  \"\>", 
   "\[InvisibleSpace]", "3", 
   "\[InvisibleSpace]", "\<\"(-1) by removing the Z gate at the end\\n\"\>", 
   "\[InvisibleSpace]", 
   GraphicsBox[
    {EdgeForm[GrayLevel[0]], FaceForm[GrayLevel[
     1]], {{LineBox[{{0, 0.5}, {1, 0.5}}], LineBox[{{0, 1.5}, {1, 1.5}}], 
       LineBox[{{0, 2.5}, {1, 2.5}}]}, {LineBox[{{1, 0.5}, {2, 0.5}}], 
       LineBox[{{1, 1.5}, {2, 1.5}}], LineBox[{{1, 2.5}, {2, 2.5}}]}, {
       LineBox[{{2, 0.5}, {3, 0.5}}], LineBox[{{2, 1.5}, {3, 1.5}}], 
       LineBox[{{2, 2.5}, {3, 2.5}}]}, {LineBox[{{3, 0.5}, {4, 0.5}}], 
       LineBox[{{3, 1.5}, {4, 1.5}}], LineBox[{{3, 2.5}, {4, 2.5}}]}, {
       LineBox[{{4, 0.5}, {5, 0.5}}], LineBox[{{4, 1.5}, {5, 1.5}}], 
       LineBox[{{4, 2.5}, {5, 2.5}}]}, {LineBox[{{5, 0.5}, {6, 0.5}}], 
       LineBox[{{5, 1.5}, {6, 1.5}}], LineBox[{{5, 2.5}, {6, 2.5}}]}, {
       LineBox[{{6, 0.5}, {7, 0.5}}], LineBox[{{6, 1.5}, {7, 1.5}}], 
       LineBox[{{6, 2.5}, {7, 2.5}}]}}, {{
       {FaceForm[GrayLevel[0]], DiskBox[{0.5, 2.5}, 0.1], 
        LineBox[{{0.5, 0.5}, {0.5, 2.5}}]}, {
        RectangleBox[{0.1, 0.1}, {0.9, 0.9}], 
        InsetBox["\<\"Rx\"\>", {0.5, 0.5}]}}, {
       {FaceForm[GrayLevel[0]], DiskBox[{1.5, 0.5}, 0.1], 
        LineBox[{{1.5, 0.5}, {1.5, 1.5}}]}, {
        RectangleBox[{1.1, 1.1}, {1.9, 1.9}], 
        InsetBox["\<\"Rx\"\>", {1.5, 1.5}]}}, {
       RectangleBox[{2.1, 0.1}, {2.9, 0.9}], 
       InsetBox["\<\"Rz\"\>", {2.5, 0.5}]}, {
       RectangleBox[{2.1, 1.1}, {2.9, 1.9}], 
       InsetBox["\<\"Rz\"\>", {2.5, 1.5}]}, {
       {FaceForm[GrayLevel[0]], DiskBox[{3.5, 1.5}, 0.1], 
        LineBox[{{3.5, 0.5}, {3.5, 1.5}}]}, {
        RectangleBox[{3.1, 0.1}, {3.9, 0.9}], 
        InsetBox["\<\"Rx\"\>", {3.5, 0.5}]}}, {
       {FaceForm[GrayLevel[0]], DiskBox[{4.5, 2.5}, 0.1], 
        LineBox[{{4.5, 1.5}, {4.5, 2.5}}]}, {
        RectangleBox[{4.1, 1.1}, {4.9, 1.9}], 
        InsetBox["\<\"Rx\"\>", {4.5, 1.5}]}}, {
       {FaceForm[GrayLevel[0]], DiskBox[{5.5, 2.5}, 0.1], 
        LineBox[{{5.5, 0.5}, {5.5, 2.5}}]}, {
        RectangleBox[{5.1, 0.1}, {5.9, 0.9}], 
        InsetBox["\<\"Rx\"\>", {5.5, 0.5}]}}, {
       RectangleBox[{6.1, 2.1}, {6.9, 2.9}], 
       InsetBox["\<\"Rz\"\>", {6.5, 2.5}]}}},
    ImageSize->{Automatic, 60},
    PlotRangePadding->None], "\[InvisibleSpace]", "\<\"\\n\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      SubscriptBox["C", "c"], "[", 
      RowBox[{
       SubscriptBox["Rx", "n1"], "[", 
       RowBox[{"3", " ", "\[Pi]"}], "]"}], "]"}], ",", 
     RowBox[{
      SubscriptBox["C", "n1"], "[", 
      RowBox[{
       SubscriptBox["Rx", "n2"], "[", "\[Pi]", "]"}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rz", "n1"], "[", 
      FractionBox[
       RowBox[{"5", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rz", "n2"], "[", 
      FractionBox[
       RowBox[{"13", " ", "\[Pi]"}], "4"], "]"}], ",", 
     RowBox[{
      SubscriptBox["C", "n2"], "[", 
      RowBox[{
       SubscriptBox["Rx", "n1"], "[", 
       FractionBox["\[Pi]", "2"], "]"}], "]"}], ",", 
     RowBox[{
      SubscriptBox["C", "c"], "[", 
      RowBox[{
       SubscriptBox["Rx", "n2"], "[", 
       RowBox[{"3", " ", "\[Pi]"}], "]"}], "]"}], ",", 
     RowBox[{
      SubscriptBox["C", "c"], "[", 
      RowBox[{
       SubscriptBox["Rx", "n1"], "[", 
       FractionBox["\[Pi]", "2"], "]"}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rz", "c"], "[", 
      FractionBox["\[Pi]", "4"], "]"}]}], "}"}], 
   "\[InvisibleSpace]", "\<\"\\nis the circuit correct:   \"\>", 
   "\[InvisibleSpace]", "True", "\[InvisibleSpace]", "\<\"\\n\\n\"\>"}],
  SequenceForm[
  "Gate Type: ", "crxUE", "\n#2-qubit gates:  ", 5, "\n#1-qubit gates:  ", 3, 
   "(-1) by removing the Z gate at the end\n", 
   Graphics[{
     FaceForm[
      GrayLevel[1]], 
     EdgeForm[
      GrayLevel[0]], {{
       Line[{{0, 0.5}, {1, 0.5}}], 
       Line[{{0, 1.5}, {1, 1.5}}], 
       Line[{{0, 2.5}, {1, 2.5}}]}, {
       Line[{{1, 0.5}, {2, 0.5}}], 
       Line[{{1, 1.5}, {2, 1.5}}], 
       Line[{{1, 2.5}, {2, 2.5}}]}, {
       Line[{{2, 0.5}, {3, 0.5}}], 
       Line[{{2, 1.5}, {3, 1.5}}], 
       Line[{{2, 2.5}, {3, 2.5}}]}, {
       Line[{{3, 0.5}, {4, 0.5}}], 
       Line[{{3, 1.5}, {4, 1.5}}], 
       Line[{{3, 2.5}, {4, 2.5}}]}, {
       Line[{{4, 0.5}, {5, 0.5}}], 
       Line[{{4, 1.5}, {5, 1.5}}], 
       Line[{{4, 2.5}, {5, 2.5}}]}, {
       Line[{{5, 0.5}, {6, 0.5}}], 
       Line[{{5, 1.5}, {6, 1.5}}], 
       Line[{{5, 2.5}, {6, 2.5}}]}, {
       Line[{{6, 0.5}, {7, 0.5}}], 
       Line[{{6, 1.5}, {7, 1.5}}], 
       Line[{{6, 2.5}, {7, 2.5}}]}}, {{{
        FaceForm[
         GrayLevel[0]], {
         Disk[{0.5, 2.5}, 0.1]}, 
        Line[{{0.5, 0.5}, {0.5, 2.5}}]}, {
        Rectangle[{0.1, 0.1}, {0.9, 0.9}], 
        Text["Rx", {0.5, 0.5}]}}, {{
        FaceForm[
         GrayLevel[0]], {
         Disk[{1.5, 0.5}, 0.1]}, 
        Line[{{1.5, 0.5}, {1.5, 1.5}}]}, {
        Rectangle[{1.1, 1.1}, {1.9, 1.9}], 
        Text["Rx", {1.5, 1.5}]}}, {
       Rectangle[{2.1, 0.1}, {2.9, 0.9}], 
       Text["Rz", {2.5, 0.5}]}, {
       Rectangle[{2.1, 1.1}, {2.9, 1.9}], 
       Text["Rz", {2.5, 1.5}]}, {{
        FaceForm[
         GrayLevel[0]], {
         Disk[{3.5, 1.5}, 0.1]}, 
        Line[{{3.5, 0.5}, {3.5, 1.5}}]}, {
        Rectangle[{3.1, 0.1}, {3.9, 0.9}], 
        Text["Rx", {3.5, 0.5}]}}, {{
        FaceForm[
         GrayLevel[0]], {
         Disk[{4.5, 2.5}, 0.1]}, 
        Line[{{4.5, 1.5}, {4.5, 2.5}}]}, {
        Rectangle[{4.1, 1.1}, {4.9, 1.9}], 
        Text["Rx", {4.5, 1.5}]}}, {{
        FaceForm[
         GrayLevel[0]], {
         Disk[{5.5, 2.5}, 0.1]}, 
        Line[{{5.5, 0.5}, {5.5, 2.5}}]}, {
        Rectangle[{5.1, 0.1}, {5.9, 0.9}], 
        Text["Rx", {5.5, 0.5}]}}, {
       Rectangle[{6.1, 2.1}, {6.9, 2.9}], 
       Text["Rz", {6.5, 2.5}]}}}, {ImageSize -> {Automatic, 60}}, ImageSize -> 
    240, PlotRangePadding -> None], "\n", {
    Subscript[C, $CellContext`c][
     Subscript[QuEST`Gate`Rx, $CellContext`n1][3 Pi]], 
    Subscript[C, $CellContext`n1][
     Subscript[QuEST`Gate`Rx, $CellContext`n2][Pi]], 
    Subscript[QuEST`Gate`Rz, $CellContext`n1][Rational[5, 2] Pi], 
    Subscript[QuEST`Gate`Rz, $CellContext`n2][Rational[13, 4] Pi], 
    Subscript[C, $CellContext`n2][
     Subscript[QuEST`Gate`Rx, $CellContext`n1][Rational[1, 2] Pi]], 
    Subscript[C, $CellContext`c][
     Subscript[QuEST`Gate`Rx, $CellContext`n2][3 Pi]], 
    Subscript[C, $CellContext`c][
     Subscript[QuEST`Gate`Rx, $CellContext`n1][Rational[1, 2] Pi]], 
    Subscript[QuEST`Gate`Rz, $CellContext`c][Rational[1, 4] Pi]}, 
   "\nis the circuit correct:   ", True, "\n\n"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.831725854855904*^9, 3.8317258823995237`*^9}, 
   3.8317259314680758`*^9, 3.831726360061119*^9},
 CellLabel->
  "During evaluation of \
In[13]:=",ExpressionUUID->"1b72ae66-4b25-411d-9124-251e273fe3c5"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Gate Type: \"\>", "\[InvisibleSpace]", "\<\"xx\"\>", 
   "\[InvisibleSpace]", "\<\"\\n#2-qubit gates:  \"\>", "\[InvisibleSpace]", 
   "6", "\[InvisibleSpace]", "\<\"\\n#1-qubit gates:  \"\>", 
   "\[InvisibleSpace]", "12", 
   "\[InvisibleSpace]", "\<\"(-1) by removing the Z gate at the end\\n\"\>", 
   "\[InvisibleSpace]", 
   GraphicsBox[
    {EdgeForm[GrayLevel[0]], FaceForm[GrayLevel[
     1]], {{LineBox[{{0, 0.5}, {1, 0.5}}], LineBox[{{0, 1.5}, {1, 1.5}}], 
       LineBox[{{0, 2.5}, {1, 2.5}}]}, {LineBox[{{1, 0.5}, {2, 0.5}}], 
       LineBox[{{1, 1.5}, {2, 1.5}}], LineBox[{{1, 2.5}, {2, 2.5}}]}, {
       LineBox[{{2, 0.5}, {3, 0.5}}], LineBox[{{2, 1.5}, {3, 1.5}}], 
       LineBox[{{2, 2.5}, {3, 2.5}}]}, {LineBox[{{3, 0.5}, {4, 0.5}}], 
       LineBox[{{3, 1.5}, {4, 1.5}}], LineBox[{{3, 2.5}, {4, 2.5}}]}, {
       LineBox[{{4, 0.5}, {5, 0.5}}], LineBox[{{4, 1.5}, {5, 1.5}}], 
       LineBox[{{4, 2.5}, {5, 2.5}}]}, {LineBox[{{5, 0.5}, {6, 0.5}}], 
       LineBox[{{5, 1.5}, {6, 1.5}}], LineBox[{{5, 2.5}, {6, 2.5}}]}, {
       LineBox[{{6, 0.5}, {7, 0.5}}], LineBox[{{6, 1.5}, {7, 1.5}}], 
       LineBox[{{6, 2.5}, {7, 2.5}}]}, {LineBox[{{7, 0.5}, {8, 0.5}}], 
       LineBox[{{7, 1.5}, {8, 1.5}}], LineBox[{{7, 2.5}, {8, 2.5}}]}, {
       LineBox[{{8, 0.5}, {9, 0.5}}], LineBox[{{8, 1.5}, {9, 1.5}}], 
       LineBox[{{8, 2.5}, {9, 2.5}}]}, {LineBox[{{9, 0.5}, {10, 0.5}}], 
       LineBox[{{9, 1.5}, {10, 1.5}}], LineBox[{{9, 2.5}, {10, 2.5}}]}, {
       LineBox[{{10, 0.5}, {11, 0.5}}], LineBox[{{10, 1.5}, {11, 1.5}}], 
       LineBox[{{10, 2.5}, {11, 2.5}}]}, {LineBox[{{11, 0.5}, {12, 0.5}}], 
       LineBox[{{11, 1.5}, {12, 1.5}}], LineBox[{{11, 2.5}, {12, 2.5}}]}}, {{
       RectangleBox[{0.1, 2.1}, {0.9, 2.9}], 
       InsetBox["\<\"Ry\"\>", {0.5, 2.5}]}, {
       RectangleBox[{0.1, 0.1}, {0.9, 0.9}], 
       InsetBox["\<\"Rz\"\>", {0.5, 0.5}]}, {
       LineBox[{{1.5, 0.5}, {1.5, 1.5}}], {
        RectangleBox[{1.1, 0.1}, {1.9, 0.9}], 
        InsetBox["\<\"Rx\"\>", {1.5, 0.5}]}, {
        RectangleBox[{1.1, 1.1}, {1.9, 1.9}], 
        InsetBox["\<\"Rx\"\>", {1.5, 1.5}]}}, {
       RectangleBox[{2.1, 0.1}, {2.9, 0.9}], 
       InsetBox["\<\"Rz\"\>", {2.5, 0.5}]}, {
       RectangleBox[{2.1, 1.1}, {2.9, 1.9}], 
       InsetBox["\<\"Rz\"\>", {2.5, 1.5}]}, {
       RectangleBox[{3.1, 0.1}, {3.9, 0.9}], 
       InsetBox["\<\"Ry\"\>", {3.5, 0.5}]}, {
       LineBox[{{3.5, 1.5}, {3.5, 2.5}}], {
        RectangleBox[{3.1, 1.1}, {3.9, 1.9}], 
        InsetBox["\<\"Rx\"\>", {3.5, 1.5}]}, {
        RectangleBox[{3.1, 2.1}, {3.9, 2.9}], 
        InsetBox["\<\"Rx\"\>", {3.5, 2.5}]}}, {
       RectangleBox[{4.1, 1.1}, {4.9, 1.9}], 
       InsetBox["\<\"Ry\"\>", {4.5, 1.5}]}, {
       LineBox[{{5.5, 0.5}, {5.5, 1.5}}], {
        RectangleBox[{5.1, 0.1}, {5.9, 0.9}], 
        InsetBox["\<\"Rx\"\>", {5.5, 0.5}]}, {
        RectangleBox[{5.1, 1.1}, {5.9, 1.9}], 
        InsetBox["\<\"Rx\"\>", {5.5, 1.5}]}}, {
       LineBox[{{6.5, 0.5}, {6.5, 2.5}}], {
        RectangleBox[{6.1, 0.1}, {6.9, 0.9}], 
        InsetBox["\<\"Rx\"\>", {6.5, 0.5}]}, {
        RectangleBox[{6.1, 2.1}, {6.9, 2.9}], 
        InsetBox["\<\"Rx\"\>", {6.5, 2.5}]}}, {
       RectangleBox[{7.1, 1.1}, {7.9, 1.9}], 
       InsetBox["\<\"Rz\"\>", {7.5, 1.5}]}, {
       LineBox[{{8.5, 1.5}, {8.5, 2.5}}], {
        RectangleBox[{8.1, 1.1}, {8.9, 1.9}], 
        InsetBox["\<\"Rx\"\>", {8.5, 1.5}]}, {
        RectangleBox[{8.1, 2.1}, {8.9, 2.9}], 
        InsetBox["\<\"Rx\"\>", {8.5, 2.5}]}}, {
       RectangleBox[{8.1, 0.1}, {8.9, 0.9}], 
       InsetBox["\<\"Rz\"\>", {8.5, 0.5}]}, {
       RectangleBox[{9.1, 2.1}, {9.9, 2.9}], 
       InsetBox["\<\"Ry\"\>", {9.5, 2.5}]}, {
       RectangleBox[{9.1, 1.1}, {9.9, 1.9}], 
       InsetBox["\<\"Ry\"\>", {9.5, 1.5}]}, {
       LineBox[{{10.5, 0.5}, {10.5, 1.5}}], {
        RectangleBox[{10.1, 0.1}, {10.9, 0.9}], 
        InsetBox["\<\"Rx\"\>", {10.5, 0.5}]}, {
        RectangleBox[{10.1, 1.1}, {10.9, 1.9}], 
        InsetBox["\<\"Rx\"\>", {10.5, 1.5}]}}, {
       RectangleBox[{10.1, 2.1}, {10.9, 2.9}], 
       InsetBox["\<\"Rz\"\>", {10.5, 2.5}]}, {
       RectangleBox[{11.1, 0.1}, {11.9, 0.9}], 
       InsetBox["\<\"Ry\"\>", {11.5, 0.5}]}}},
    ImageSize->{Automatic, 60},
    PlotRangePadding->None], "\[InvisibleSpace]", "\<\"\\n\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      SubscriptBox["Ry", "c"], "[", 
      FractionBox[
       RowBox[{"7", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rz", "n1"], "[", 
      FractionBox[
       RowBox[{"7", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{"R", "[", 
      RowBox[{
       FractionBox[
        RowBox[{"5", " ", "\[Pi]"}], "2"], ",", 
       RowBox[{
        SubscriptBox["X", "n1"], " ", 
        SubscriptBox["X", "n2"]}]}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rz", "n1"], "[", 
      FractionBox[
       RowBox[{"7", " ", "\[Pi]"}], "4"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rz", "n2"], "[", 
      FractionBox[
       RowBox[{"3", " ", "\[Pi]"}], "4"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Ry", "n1"], "[", 
      FractionBox["\[Pi]", "2"], "]"}], ",", 
     RowBox[{"R", "[", 
      RowBox[{
       FractionBox[
        RowBox[{"7", " ", "\[Pi]"}], "2"], ",", 
       RowBox[{
        SubscriptBox["X", "c"], " ", 
        SubscriptBox["X", "n2"]}]}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Ry", "n2"], "[", 
      FractionBox[
       RowBox[{"11", " ", "\[Pi]"}], "4"], "]"}], ",", 
     RowBox[{"R", "[", 
      RowBox[{
       FractionBox[
        RowBox[{"7", " ", "\[Pi]"}], "2"], ",", 
       RowBox[{
        SubscriptBox["X", "n1"], " ", 
        SubscriptBox["X", "n2"]}]}], "]"}], ",", 
     RowBox[{"R", "[", 
      RowBox[{
       FractionBox["\[Pi]", "4"], ",", 
       RowBox[{
        SubscriptBox["X", "c"], " ", 
        SubscriptBox["X", "n1"]}]}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rz", "n2"], "[", 
      FractionBox["\[Pi]", "4"], "]"}], ",", 
     RowBox[{"R", "[", 
      RowBox[{
       FractionBox[
        RowBox[{"5", " ", "\[Pi]"}], "2"], ",", 
       RowBox[{
        SubscriptBox["X", "c"], " ", 
        SubscriptBox["X", "n2"]}]}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Ry", "c"], "[", 
      FractionBox[
       RowBox[{"5", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rz", "n1"], "[", 
      FractionBox[
       RowBox[{"5", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Ry", "n2"], "[", 
      FractionBox[
       RowBox[{"7", " ", "\[Pi]"}], "4"], "]"}], ",", 
     RowBox[{"R", "[", 
      RowBox[{
       FractionBox[
        RowBox[{"7", " ", "\[Pi]"}], "2"], ",", 
       RowBox[{
        SubscriptBox["X", "n1"], " ", 
        SubscriptBox["X", "n2"]}]}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Ry", "n1"], "[", 
      FractionBox["\[Pi]", "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rz", "c"], "[", 
      FractionBox[
       RowBox[{"11", " ", "\[Pi]"}], "4"], "]"}]}], "}"}], 
   "\[InvisibleSpace]", "\<\"\\nis the circuit correct:   \"\>", 
   "\[InvisibleSpace]", "True", "\[InvisibleSpace]", "\<\"\\n\\n\"\>"}],
  SequenceForm[
  "Gate Type: ", "xx", "\n#2-qubit gates:  ", 6, "\n#1-qubit gates:  ", 12, 
   "(-1) by removing the Z gate at the end\n", 
   Graphics[{
     FaceForm[
      GrayLevel[1]], 
     EdgeForm[
      GrayLevel[0]], {{
       Line[{{0, 0.5}, {1, 0.5}}], 
       Line[{{0, 1.5}, {1, 1.5}}], 
       Line[{{0, 2.5}, {1, 2.5}}]}, {
       Line[{{1, 0.5}, {2, 0.5}}], 
       Line[{{1, 1.5}, {2, 1.5}}], 
       Line[{{1, 2.5}, {2, 2.5}}]}, {
       Line[{{2, 0.5}, {3, 0.5}}], 
       Line[{{2, 1.5}, {3, 1.5}}], 
       Line[{{2, 2.5}, {3, 2.5}}]}, {
       Line[{{3, 0.5}, {4, 0.5}}], 
       Line[{{3, 1.5}, {4, 1.5}}], 
       Line[{{3, 2.5}, {4, 2.5}}]}, {
       Line[{{4, 0.5}, {5, 0.5}}], 
       Line[{{4, 1.5}, {5, 1.5}}], 
       Line[{{4, 2.5}, {5, 2.5}}]}, {
       Line[{{5, 0.5}, {6, 0.5}}], 
       Line[{{5, 1.5}, {6, 1.5}}], 
       Line[{{5, 2.5}, {6, 2.5}}]}, {
       Line[{{6, 0.5}, {7, 0.5}}], 
       Line[{{6, 1.5}, {7, 1.5}}], 
       Line[{{6, 2.5}, {7, 2.5}}]}, {
       Line[{{7, 0.5}, {8, 0.5}}], 
       Line[{{7, 1.5}, {8, 1.5}}], 
       Line[{{7, 2.5}, {8, 2.5}}]}, {
       Line[{{8, 0.5}, {9, 0.5}}], 
       Line[{{8, 1.5}, {9, 1.5}}], 
       Line[{{8, 2.5}, {9, 2.5}}]}, {
       Line[{{9, 0.5}, {10, 0.5}}], 
       Line[{{9, 1.5}, {10, 1.5}}], 
       Line[{{9, 2.5}, {10, 2.5}}]}, {
       Line[{{10, 0.5}, {11, 0.5}}], 
       Line[{{10, 1.5}, {11, 1.5}}], 
       Line[{{10, 2.5}, {11, 2.5}}]}, {
       Line[{{11, 0.5}, {12, 0.5}}], 
       Line[{{11, 1.5}, {12, 1.5}}], 
       Line[{{11, 2.5}, {12, 2.5}}]}}, {{
       Rectangle[{0.1, 2.1}, {0.9, 2.9}], 
       Text["Ry", {0.5, 2.5}]}, {
       Rectangle[{0.1, 0.1}, {0.9, 0.9}], 
       Text["Rz", {0.5, 0.5}]}, {
       Line[{{1.5, 0.5}, {1.5, 1.5}}], {
        Rectangle[{1.1, 0.1}, {1.9, 0.9}], 
        Text["Rx", {1.5, 0.5}]}, {
        Rectangle[{1.1, 1.1}, {1.9, 1.9}], 
        Text["Rx", {1.5, 1.5}]}}, {
       Rectangle[{2.1, 0.1}, {2.9, 0.9}], 
       Text["Rz", {2.5, 0.5}]}, {
       Rectangle[{2.1, 1.1}, {2.9, 1.9}], 
       Text["Rz", {2.5, 1.5}]}, {
       Rectangle[{3.1, 0.1}, {3.9, 0.9}], 
       Text["Ry", {3.5, 0.5}]}, {
       Line[{{3.5, 1.5}, {3.5, 2.5}}], {
        Rectangle[{3.1, 1.1}, {3.9, 1.9}], 
        Text["Rx", {3.5, 1.5}]}, {
        Rectangle[{3.1, 2.1}, {3.9, 2.9}], 
        Text["Rx", {3.5, 2.5}]}}, {
       Rectangle[{4.1, 1.1}, {4.9, 1.9}], 
       Text["Ry", {4.5, 1.5}]}, {
       Line[{{5.5, 0.5}, {5.5, 1.5}}], {
        Rectangle[{5.1, 0.1}, {5.9, 0.9}], 
        Text["Rx", {5.5, 0.5}]}, {
        Rectangle[{5.1, 1.1}, {5.9, 1.9}], 
        Text["Rx", {5.5, 1.5}]}}, {
       Line[{{6.5, 0.5}, {6.5, 2.5}}], {
        Rectangle[{6.1, 0.1}, {6.9, 0.9}], 
        Text["Rx", {6.5, 0.5}]}, {
        Rectangle[{6.1, 2.1}, {6.9, 2.9}], 
        Text["Rx", {6.5, 2.5}]}}, {
       Rectangle[{7.1, 1.1}, {7.9, 1.9}], 
       Text["Rz", {7.5, 1.5}]}, {
       Line[{{8.5, 1.5}, {8.5, 2.5}}], {
        Rectangle[{8.1, 1.1}, {8.9, 1.9}], 
        Text["Rx", {8.5, 1.5}]}, {
        Rectangle[{8.1, 2.1}, {8.9, 2.9}], 
        Text["Rx", {8.5, 2.5}]}}, {
       Rectangle[{8.1, 0.1}, {8.9, 0.9}], 
       Text["Rz", {8.5, 0.5}]}, {
       Rectangle[{9.1, 2.1}, {9.9, 2.9}], 
       Text["Ry", {9.5, 2.5}]}, {
       Rectangle[{9.1, 1.1}, {9.9, 1.9}], 
       Text["Ry", {9.5, 1.5}]}, {
       Line[{{10.5, 0.5}, {10.5, 1.5}}], {
        Rectangle[{10.1, 0.1}, {10.9, 0.9}], 
        Text["Rx", {10.5, 0.5}]}, {
        Rectangle[{10.1, 1.1}, {10.9, 1.9}], 
        Text["Rx", {10.5, 1.5}]}}, {
       Rectangle[{10.1, 2.1}, {10.9, 2.9}], 
       Text["Rz", {10.5, 2.5}]}, {
       Rectangle[{11.1, 0.1}, {11.9, 0.9}], 
       Text["Ry", {11.5, 0.5}]}}}, {ImageSize -> {Automatic, 60}}, ImageSize -> 
    390, PlotRangePadding -> None], "\n", {
    Subscript[QuEST`Gate`Ry, $CellContext`c][Rational[7, 2] Pi], 
    Subscript[QuEST`Gate`Rz, $CellContext`n1][Rational[7, 2] Pi], 
    QuEST`Gate`R[
    Rational[5, 2] Pi, Subscript[QuEST`Gate`X, $CellContext`n1] 
     Subscript[QuEST`Gate`X, $CellContext`n2]], 
    Subscript[QuEST`Gate`Rz, $CellContext`n1][Rational[7, 4] Pi], 
    Subscript[QuEST`Gate`Rz, $CellContext`n2][Rational[3, 4] Pi], 
    Subscript[QuEST`Gate`Ry, $CellContext`n1][Rational[1, 2] Pi], 
    QuEST`Gate`R[
    Rational[7, 2] Pi, Subscript[QuEST`Gate`X, $CellContext`c] 
     Subscript[QuEST`Gate`X, $CellContext`n2]], 
    Subscript[QuEST`Gate`Ry, $CellContext`n2][Rational[11, 4] Pi], 
    QuEST`Gate`R[
    Rational[7, 2] Pi, Subscript[QuEST`Gate`X, $CellContext`n1] 
     Subscript[QuEST`Gate`X, $CellContext`n2]], 
    QuEST`Gate`R[
    Rational[1, 4] Pi, Subscript[QuEST`Gate`X, $CellContext`c] 
     Subscript[QuEST`Gate`X, $CellContext`n1]], 
    Subscript[QuEST`Gate`Rz, $CellContext`n2][Rational[1, 4] Pi], 
    QuEST`Gate`R[
    Rational[5, 2] Pi, Subscript[QuEST`Gate`X, $CellContext`c] 
     Subscript[QuEST`Gate`X, $CellContext`n2]], 
    Subscript[QuEST`Gate`Ry, $CellContext`c][Rational[5, 2] Pi], 
    Subscript[QuEST`Gate`Rz, $CellContext`n1][Rational[5, 2] Pi], 
    Subscript[QuEST`Gate`Ry, $CellContext`n2][Rational[7, 4] Pi], 
    QuEST`Gate`R[
    Rational[7, 2] Pi, Subscript[QuEST`Gate`X, $CellContext`n1] 
     Subscript[QuEST`Gate`X, $CellContext`n2]], 
    Subscript[QuEST`Gate`Ry, $CellContext`n1][Rational[1, 2] Pi], 
    Subscript[QuEST`Gate`Rz, $CellContext`c][Rational[11, 4] Pi]}, 
   "\nis the circuit correct:   ", True, "\n\n"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.831725854855904*^9, 3.8317258823995237`*^9}, 
   3.8317259314680758`*^9, 3.83172636009308*^9},
 CellLabel->
  "During evaluation of \
In[13]:=",ExpressionUUID->"f8c0072b-0fac-4bd0-84b2-59ebeb312560"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Gate Type: \"\>", "\[InvisibleSpace]", "\<\"xxUE\"\>", 
   "\[InvisibleSpace]", "\<\"\\n#2-qubit gates:  \"\>", "\[InvisibleSpace]", 
   "5", "\[InvisibleSpace]", "\<\"\\n#1-qubit gates:  \"\>", 
   "\[InvisibleSpace]", "7", 
   "\[InvisibleSpace]", "\<\"(-1) by removing the Z gate at the end\\n\"\>", 
   "\[InvisibleSpace]", 
   GraphicsBox[
    {EdgeForm[GrayLevel[0]], FaceForm[GrayLevel[
     1]], {{LineBox[{{0, 0.5}, {1, 0.5}}], LineBox[{{0, 1.5}, {1, 1.5}}], 
       LineBox[{{0, 2.5}, {1, 2.5}}]}, {LineBox[{{1, 0.5}, {2, 0.5}}], 
       LineBox[{{1, 1.5}, {2, 1.5}}], LineBox[{{1, 2.5}, {2, 2.5}}]}, {
       LineBox[{{2, 0.5}, {3, 0.5}}], LineBox[{{2, 1.5}, {3, 1.5}}], 
       LineBox[{{2, 2.5}, {3, 2.5}}]}, {LineBox[{{3, 0.5}, {4, 0.5}}], 
       LineBox[{{3, 1.5}, {4, 1.5}}], LineBox[{{3, 2.5}, {4, 2.5}}]}, {
       LineBox[{{4, 0.5}, {5, 0.5}}], LineBox[{{4, 1.5}, {5, 1.5}}], 
       LineBox[{{4, 2.5}, {5, 2.5}}]}, {LineBox[{{5, 0.5}, {6, 0.5}}], 
       LineBox[{{5, 1.5}, {6, 1.5}}], LineBox[{{5, 2.5}, {6, 2.5}}]}, {
       LineBox[{{6, 0.5}, {7, 0.5}}], LineBox[{{6, 1.5}, {7, 1.5}}], 
       LineBox[{{6, 2.5}, {7, 2.5}}]}, {LineBox[{{7, 0.5}, {8, 0.5}}], 
       LineBox[{{7, 1.5}, {8, 1.5}}], LineBox[{{7, 2.5}, {8, 2.5}}]}, {
       LineBox[{{8, 0.5}, {9, 0.5}}], LineBox[{{8, 1.5}, {9, 1.5}}], 
       LineBox[{{8, 2.5}, {9, 2.5}}]}}, {{
       RectangleBox[{0.1, 2.1}, {0.9, 2.9}], 
       InsetBox["\<\"Ry\"\>", {0.5, 2.5}]}, {
       RectangleBox[{0.1, 1.1}, {0.9, 1.9}], 
       InsetBox["\<\"Rz\"\>", {0.5, 1.5}]}, {
       LineBox[{{1.5, 0.5}, {1.5, 1.5}}], {
        RectangleBox[{1.1, 0.1}, {1.9, 0.9}], 
        InsetBox["\<\"Rx\"\>", {1.5, 0.5}]}, {
        RectangleBox[{1.1, 1.1}, {1.9, 1.9}], 
        InsetBox["\<\"Rx\"\>", {1.5, 1.5}]}}, {
       LineBox[{{2.5, 0.5}, {2.5, 2.5}}], {
        RectangleBox[{2.1, 0.1}, {2.9, 0.9}], 
        InsetBox["\<\"Rx\"\>", {2.5, 0.5}]}, {
        RectangleBox[{2.1, 2.1}, {2.9, 2.9}], 
        InsetBox["\<\"Rx\"\>", {2.5, 2.5}]}}, {
       RectangleBox[{3.1, 1.1}, {3.9, 1.9}], 
       InsetBox["\<\"Ry\"\>", {3.5, 1.5}]}, {
       RectangleBox[{3.1, 0.1}, {3.9, 0.9}], 
       InsetBox["\<\"Ry\"\>", {3.5, 0.5}]}, {
       LineBox[{{4.5, 0.5}, {4.5, 1.5}}], {
        RectangleBox[{4.1, 0.1}, {4.9, 0.9}], 
        InsetBox["\<\"Rx\"\>", {4.5, 0.5}]}, {
        RectangleBox[{4.1, 1.1}, {4.9, 1.9}], 
        InsetBox["\<\"Rx\"\>", {4.5, 1.5}]}}, {
       RectangleBox[{5.1, 0.1}, {5.9, 0.9}], 
       InsetBox["\<\"Rz\"\>", {5.5, 0.5}]}, {
       LineBox[{{5.5, 1.5}, {5.5, 2.5}}], {
        RectangleBox[{5.1, 1.1}, {5.9, 1.9}], 
        InsetBox["\<\"Rx\"\>", {5.5, 1.5}]}, {
        RectangleBox[{5.1, 2.1}, {5.9, 2.9}], 
        InsetBox["\<\"Rx\"\>", {5.5, 2.5}]}}, {
       LineBox[{{6.5, 0.5}, {6.5, 2.5}}], {
        RectangleBox[{6.1, 0.1}, {6.9, 0.9}], 
        InsetBox["\<\"Rx\"\>", {6.5, 0.5}]}, {
        RectangleBox[{6.1, 2.1}, {6.9, 2.9}], 
        InsetBox["\<\"Rx\"\>", {6.5, 2.5}]}}, {
       RectangleBox[{7.1, 2.1}, {7.9, 2.9}], 
       InsetBox["\<\"Ry\"\>", {7.5, 2.5}]}, {
       RectangleBox[{8.1, 2.1}, {8.9, 2.9}], 
       InsetBox["\<\"Rz\"\>", {8.5, 2.5}]}}},
    ImageSize->{Automatic, 60},
    PlotRangePadding->None], "\[InvisibleSpace]", "\<\"\\n\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      SubscriptBox["Ry", "c"], "[", 
      FractionBox[
       RowBox[{"7", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rz", "n2"], "[", 
      FractionBox["\[Pi]", "2"], "]"}], ",", 
     RowBox[{"R", "[", 
      RowBox[{
       FractionBox[
        RowBox[{"7", " ", "\[Pi]"}], "2"], ",", 
       RowBox[{
        SubscriptBox["X", "n1"], " ", 
        SubscriptBox["X", "n2"]}]}], "]"}], ",", 
     RowBox[{"R", "[", 
      RowBox[{
       FractionBox[
        RowBox[{"7", " ", "\[Pi]"}], "2"], ",", 
       RowBox[{
        SubscriptBox["X", "c"], " ", 
        SubscriptBox["X", "n1"]}]}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Ry", "n1"], "[", 
      FractionBox[
       RowBox[{"5", " ", "\[Pi]"}], "4"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Ry", "n2"], "[", 
      FractionBox[
       RowBox[{"5", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{"R", "[", 
      RowBox[{
       FractionBox[
        RowBox[{"3", " ", "\[Pi]"}], "2"], ",", 
       RowBox[{
        SubscriptBox["X", "n1"], " ", 
        SubscriptBox["X", "n2"]}]}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rz", "n1"], "[", 
      FractionBox[
       RowBox[{"3", " ", "\[Pi]"}], "4"], "]"}], ",", 
     RowBox[{"R", "[", 
      RowBox[{
       FractionBox[
        RowBox[{"11", " ", "\[Pi]"}], "4"], ",", 
       RowBox[{
        SubscriptBox["X", "c"], " ", 
        SubscriptBox["X", "n2"]}]}], "]"}], ",", 
     RowBox[{"R", "[", 
      RowBox[{
       FractionBox["\[Pi]", "2"], ",", 
       RowBox[{
        SubscriptBox["X", "c"], " ", 
        SubscriptBox["X", "n1"]}]}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Ry", "c"], "[", 
      FractionBox["\[Pi]", "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rz", "c"], "[", 
      FractionBox[
       RowBox[{"5", " ", "\[Pi]"}], "4"], "]"}]}], "}"}], 
   "\[InvisibleSpace]", "\<\"\\nis the circuit correct:   \"\>", 
   "\[InvisibleSpace]", "True", "\[InvisibleSpace]", "\<\"\\n\\n\"\>"}],
  SequenceForm[
  "Gate Type: ", "xxUE", "\n#2-qubit gates:  ", 5, "\n#1-qubit gates:  ", 7, 
   "(-1) by removing the Z gate at the end\n", 
   Graphics[{
     FaceForm[
      GrayLevel[1]], 
     EdgeForm[
      GrayLevel[0]], {{
       Line[{{0, 0.5}, {1, 0.5}}], 
       Line[{{0, 1.5}, {1, 1.5}}], 
       Line[{{0, 2.5}, {1, 2.5}}]}, {
       Line[{{1, 0.5}, {2, 0.5}}], 
       Line[{{1, 1.5}, {2, 1.5}}], 
       Line[{{1, 2.5}, {2, 2.5}}]}, {
       Line[{{2, 0.5}, {3, 0.5}}], 
       Line[{{2, 1.5}, {3, 1.5}}], 
       Line[{{2, 2.5}, {3, 2.5}}]}, {
       Line[{{3, 0.5}, {4, 0.5}}], 
       Line[{{3, 1.5}, {4, 1.5}}], 
       Line[{{3, 2.5}, {4, 2.5}}]}, {
       Line[{{4, 0.5}, {5, 0.5}}], 
       Line[{{4, 1.5}, {5, 1.5}}], 
       Line[{{4, 2.5}, {5, 2.5}}]}, {
       Line[{{5, 0.5}, {6, 0.5}}], 
       Line[{{5, 1.5}, {6, 1.5}}], 
       Line[{{5, 2.5}, {6, 2.5}}]}, {
       Line[{{6, 0.5}, {7, 0.5}}], 
       Line[{{6, 1.5}, {7, 1.5}}], 
       Line[{{6, 2.5}, {7, 2.5}}]}, {
       Line[{{7, 0.5}, {8, 0.5}}], 
       Line[{{7, 1.5}, {8, 1.5}}], 
       Line[{{7, 2.5}, {8, 2.5}}]}, {
       Line[{{8, 0.5}, {9, 0.5}}], 
       Line[{{8, 1.5}, {9, 1.5}}], 
       Line[{{8, 2.5}, {9, 2.5}}]}}, {{
       Rectangle[{0.1, 2.1}, {0.9, 2.9}], 
       Text["Ry", {0.5, 2.5}]}, {
       Rectangle[{0.1, 1.1}, {0.9, 1.9}], 
       Text["Rz", {0.5, 1.5}]}, {
       Line[{{1.5, 0.5}, {1.5, 1.5}}], {
        Rectangle[{1.1, 0.1}, {1.9, 0.9}], 
        Text["Rx", {1.5, 0.5}]}, {
        Rectangle[{1.1, 1.1}, {1.9, 1.9}], 
        Text["Rx", {1.5, 1.5}]}}, {
       Line[{{2.5, 0.5}, {2.5, 2.5}}], {
        Rectangle[{2.1, 0.1}, {2.9, 0.9}], 
        Text["Rx", {2.5, 0.5}]}, {
        Rectangle[{2.1, 2.1}, {2.9, 2.9}], 
        Text["Rx", {2.5, 2.5}]}}, {
       Rectangle[{3.1, 1.1}, {3.9, 1.9}], 
       Text["Ry", {3.5, 1.5}]}, {
       Rectangle[{3.1, 0.1}, {3.9, 0.9}], 
       Text["Ry", {3.5, 0.5}]}, {
       Line[{{4.5, 0.5}, {4.5, 1.5}}], {
        Rectangle[{4.1, 0.1}, {4.9, 0.9}], 
        Text["Rx", {4.5, 0.5}]}, {
        Rectangle[{4.1, 1.1}, {4.9, 1.9}], 
        Text["Rx", {4.5, 1.5}]}}, {
       Rectangle[{5.1, 0.1}, {5.9, 0.9}], 
       Text["Rz", {5.5, 0.5}]}, {
       Line[{{5.5, 1.5}, {5.5, 2.5}}], {
        Rectangle[{5.1, 1.1}, {5.9, 1.9}], 
        Text["Rx", {5.5, 1.5}]}, {
        Rectangle[{5.1, 2.1}, {5.9, 2.9}], 
        Text["Rx", {5.5, 2.5}]}}, {
       Line[{{6.5, 0.5}, {6.5, 2.5}}], {
        Rectangle[{6.1, 0.1}, {6.9, 0.9}], 
        Text["Rx", {6.5, 0.5}]}, {
        Rectangle[{6.1, 2.1}, {6.9, 2.9}], 
        Text["Rx", {6.5, 2.5}]}}, {
       Rectangle[{7.1, 2.1}, {7.9, 2.9}], 
       Text["Ry", {7.5, 2.5}]}, {
       Rectangle[{8.1, 2.1}, {8.9, 2.9}], 
       Text["Rz", {8.5, 2.5}]}}}, {ImageSize -> {Automatic, 60}}, ImageSize -> 
    300, PlotRangePadding -> None], "\n", {
    Subscript[QuEST`Gate`Ry, $CellContext`c][Rational[7, 2] Pi], 
    Subscript[QuEST`Gate`Rz, $CellContext`n2][Rational[1, 2] Pi], 
    QuEST`Gate`R[
    Rational[7, 2] Pi, Subscript[QuEST`Gate`X, $CellContext`n1] 
     Subscript[QuEST`Gate`X, $CellContext`n2]], 
    QuEST`Gate`R[
    Rational[7, 2] Pi, Subscript[QuEST`Gate`X, $CellContext`c] 
     Subscript[QuEST`Gate`X, $CellContext`n1]], 
    Subscript[QuEST`Gate`Ry, $CellContext`n1][Rational[5, 4] Pi], 
    Subscript[QuEST`Gate`Ry, $CellContext`n2][Rational[5, 2] Pi], 
    QuEST`Gate`R[
    Rational[3, 2] Pi, Subscript[QuEST`Gate`X, $CellContext`n1] 
     Subscript[QuEST`Gate`X, $CellContext`n2]], 
    Subscript[QuEST`Gate`Rz, $CellContext`n1][Rational[3, 4] Pi], 
    QuEST`Gate`R[
    Rational[11, 4] Pi, Subscript[QuEST`Gate`X, $CellContext`c] 
     Subscript[QuEST`Gate`X, $CellContext`n2]], 
    QuEST`Gate`R[
    Rational[1, 2] Pi, Subscript[QuEST`Gate`X, $CellContext`c] 
     Subscript[QuEST`Gate`X, $CellContext`n1]], 
    Subscript[QuEST`Gate`Ry, $CellContext`c][Rational[1, 2] Pi], 
    Subscript[QuEST`Gate`Rz, $CellContext`c][Rational[5, 4] Pi]}, 
   "\nis the circuit correct:   ", True, "\n\n"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.831725854855904*^9, 3.8317258823995237`*^9}, 
   3.8317259314680758`*^9, 3.831726360124137*^9},
 CellLabel->
  "During evaluation of \
In[13]:=",ExpressionUUID->"068b191d-609a-4f1a-8067-c0ec6059bc7e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Gate Type: \"\>", "\[InvisibleSpace]", "\<\"pswap\"\>", 
   "\[InvisibleSpace]", "\<\"\\n#2-qubit gates:  \"\>", "\[InvisibleSpace]", 
   "6", "\[InvisibleSpace]", "\<\"\\n#1-qubit gates:  \"\>", 
   "\[InvisibleSpace]", "12", 
   "\[InvisibleSpace]", "\<\"(-1) by removing the Z gate at the end\\n\"\>", 
   "\[InvisibleSpace]", 
   GraphicsBox[
    {EdgeForm[GrayLevel[0]], FaceForm[GrayLevel[
     1]], {{LineBox[{{0, 0.5}, {1, 0.5}}], LineBox[{{0, 1.5}, {1, 1.5}}], 
       LineBox[{{0, 2.5}, {1, 2.5}}]}, {LineBox[{{1, 0.5}, {2, 0.5}}], 
       LineBox[{{1, 1.5}, {2, 1.5}}], LineBox[{{1, 2.5}, {2, 2.5}}]}, {
       LineBox[{{2, 0.5}, {3, 0.5}}], LineBox[{{2, 1.5}, {3, 1.5}}], 
       LineBox[{{2, 2.5}, {3, 2.5}}]}, {LineBox[{{3, 0.5}, {4, 0.5}}], 
       LineBox[{{3, 1.5}, {4, 1.5}}], LineBox[{{3, 2.5}, {4, 2.5}}]}, {
       LineBox[{{4, 0.5}, {5, 0.5}}], LineBox[{{4, 1.5}, {5, 1.5}}], 
       LineBox[{{4, 2.5}, {5, 2.5}}]}, {{LineBox[{{5.5, 0.5}, {6.5, 0.5}}], 
        LineBox[{{5.5, 1.5}, {6.5, 1.5}}], LineBox[{{5.5, 2.5}, {6.5, 2.5}}]},
        LineBox[{{5, 0.5}, {6, 0.5}}], LineBox[{{6, 0.5}, {7, 0.5}}]}, {
       LineBox[{{7, 0.5}, {8, 0.5}}], LineBox[{{7, 1.5}, {8, 1.5}}], 
       LineBox[{{7, 2.5}, {8, 2.5}}]}, {LineBox[{{8, 0.5}, {9, 0.5}}], 
       LineBox[{{8, 1.5}, {9, 1.5}}], LineBox[{{8, 2.5}, {9, 2.5}}]}, {
       LineBox[{{9, 0.5}, {10, 0.5}}], LineBox[{{9, 1.5}, {10, 1.5}}], 
       LineBox[{{9, 2.5}, {10, 2.5}}]}, {{LineBox[{{10.5, 0.5}, {11.5, 0.5}}],
         LineBox[{{10.5, 1.5}, {11.5, 1.5}}], 
        LineBox[{{10.5, 2.5}, {11.5, 2.5}}]}, LineBox[{{10, 0.5}, {11, 0.5}}],
        LineBox[{{11, 0.5}, {12, 0.5}}]}, {LineBox[{{12, 0.5}, {13, 0.5}}], 
       LineBox[{{12, 1.5}, {13, 1.5}}], LineBox[{{12, 2.5}, {13, 2.5}}]}, {
       LineBox[{{13, 0.5}, {14, 0.5}}], LineBox[{{13, 1.5}, {14, 1.5}}], 
       LineBox[{{13, 2.5}, {14, 2.5}}]}}, {{
       RectangleBox[{0.1, 0.1}, {0.9, 0.9}], 
       InsetBox["\<\"Rx\"\>", {0.5, 0.5}]}, {
       RectangleBox[{0.1, 1.1}, {0.9, 1.9}], 
       InsetBox["\<\"Rx\"\>", {0.5, 1.5}]}, {
       RectangleBox[{1.1, 0.1}, {1.9, 1.9}], 
       InsetBox["\<\"pSW\"\>", {1.5, 1.}]}, {
       RectangleBox[{2.1, 1.1}, {2.9, 2.9}], 
       InsetBox["\<\"pSW\"\>", {2.5, 2.}]}, {
       RectangleBox[{2.1, 0.1}, {2.9, 0.9}], 
       InsetBox["\<\"Rz\"\>", {2.5, 0.5}]}, {
       RectangleBox[{3.1, 0.1}, {3.9, 0.9}], 
       InsetBox["\<\"Ry\"\>", {3.5, 0.5}]}, {
       RectangleBox[{3.1, 1.1}, {3.9, 1.9}], 
       InsetBox["\<\"Ry\"\>", {3.5, 1.5}]}, {
       RectangleBox[{4.1, 0.1}, {4.9, 1.9}], 
       InsetBox["\<\"pSW\"\>", {4.5, 1.}]}, {{{
         LineBox[{{5, 2.5}, {5.1, 2.5}}], LineBox[{{5.1, 2.5}, {5.4, 1.5}}], 
         LineBox[{{5.4, 1.5}, {5.5, 1.5}}]}, {LineBox[{{5, 1.5}, {5.1, 1.5}}],
          LineBox[{{5.1, 1.5}, {5.4, 2.5}}], 
         LineBox[{{5.4, 2.5}, {5.5, 2.5}}]}}, {
        RectangleBox[{5.6, 0.1}, {6.4, 1.9}], 
        InsetBox["\<\"pSW\"\>", {6., 1.}]}, {{
         LineBox[{{6.5, 2.5}, {6.6, 2.5}}], LineBox[{{6.6, 2.5}, {6.9, 1.5}}],
          LineBox[{{6.9, 1.5}, {7., 1.5}}]}, {
         LineBox[{{6.5, 1.5}, {6.6, 1.5}}], LineBox[{{6.6, 1.5}, {6.9, 2.5}}],
          LineBox[{{6.9, 2.5}, {7., 2.5}}]}}}, {
       RectangleBox[{7.1, 1.1}, {7.9, 1.9}], 
       InsetBox["\<\"Rz\"\>", {7.5, 1.5}]}, {
       RectangleBox[{8.1, 1.1}, {8.9, 1.9}], 
       InsetBox["\<\"Ry\"\>", {8.5, 1.5}]}, {
       RectangleBox[{8.1, 2.1}, {8.9, 2.9}], 
       InsetBox["\<\"Ry\"\>", {8.5, 2.5}]}, {
       RectangleBox[{9.1, 1.1}, {9.9, 2.9}], 
       InsetBox["\<\"pSW\"\>", {9.5, 2.}]}, {{{
         LineBox[{{10, 2.5}, {10.1, 2.5}}], 
         LineBox[{{10.1, 2.5}, {10.4, 1.5}}], 
         LineBox[{{10.4, 1.5}, {10.5, 1.5}}]}, {
         LineBox[{{10, 1.5}, {10.1, 1.5}}], 
         LineBox[{{10.1, 1.5}, {10.4, 2.5}}], 
         LineBox[{{10.4, 2.5}, {10.5, 2.5}}]}}, {
        RectangleBox[{10.6, 0.1}, {11.4, 1.9}], 
        InsetBox["\<\"pSW\"\>", {11., 1.}]}, {{
         LineBox[{{11.5, 2.5}, {11.6, 2.5}}], 
         LineBox[{{11.6, 2.5}, {11.9, 1.5}}], 
         LineBox[{{11.9, 1.5}, {12., 1.5}}]}, {
         LineBox[{{11.5, 1.5}, {11.6, 1.5}}], 
         LineBox[{{11.6, 1.5}, {11.9, 2.5}}], 
         LineBox[{{11.9, 2.5}, {12., 2.5}}]}}}, {
       RectangleBox[{12.1, 1.1}, {12.9, 1.9}], 
       InsetBox["\<\"Ry\"\>", {12.5, 1.5}]}, {
       RectangleBox[{12.1, 0.1}, {12.9, 0.9}], 
       InsetBox["\<\"Rz\"\>", {12.5, 0.5}]}, {
       RectangleBox[{12.1, 2.1}, {12.9, 2.9}], 
       InsetBox["\<\"Rz\"\>", {12.5, 2.5}]}, {
       RectangleBox[{13.1, 0.1}, {13.9, 0.9}], 
       InsetBox["\<\"Ry\"\>", {13.5, 0.5}]}}},
    ImageSize->{Automatic, 60},
    PlotRangePadding->None], "\[InvisibleSpace]", "\<\"\\n\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      SubscriptBox["Rx", "n1"], "[", 
      FractionBox["\[Pi]", "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rx", "n2"], "[", 
      FractionBox[
       RowBox[{"5", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["pSWAP", 
       RowBox[{"n1", ",", "n2"}]], "[", 
      RowBox[{
       FractionBox[
        RowBox[{"31", " ", "\[Pi]"}], "8"], ",", 
       FractionBox[
        RowBox[{"3", " ", "\[Pi]"}], "4"]}], "]"}], ",", 
     RowBox[{
      SubscriptBox["pSWAP", 
       RowBox[{"n2", ",", "c"}]], "[", 
      RowBox[{
       FractionBox[
        RowBox[{"7", " ", "\[Pi]"}], "2"], ",", 
       FractionBox[
        RowBox[{"7", " ", "\[Pi]"}], "4"]}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rz", "n1"], "[", 
      FractionBox[
       RowBox[{"5", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Ry", "n1"], "[", 
      FractionBox[
       RowBox[{"7", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Ry", "n2"], "[", 
      FractionBox["\[Pi]", "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["pSWAP", 
       RowBox[{"n1", ",", "n2"}]], "[", 
      RowBox[{
       FractionBox["\[Pi]", "8"], ",", 
       FractionBox[
        RowBox[{"5", " ", "\[Pi]"}], "2"]}], "]"}], ",", 
     RowBox[{
      SubscriptBox["pSWAP", 
       RowBox[{"n1", ",", "c"}]], "[", 
      RowBox[{
       FractionBox["\[Pi]", "4"], ",", 
       FractionBox[
        RowBox[{"5", " ", "\[Pi]"}], "2"]}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rz", "n2"], "[", 
      FractionBox[
       RowBox[{"7", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Ry", "n2"], "[", 
      FractionBox[
       RowBox[{"5", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Ry", "c"], "[", 
      FractionBox["\[Pi]", "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["pSWAP", 
       RowBox[{"n2", ",", "c"}]], "[", 
      RowBox[{
       FractionBox[
        RowBox[{"19", " ", "\[Pi]"}], "8"], ",", 
       FractionBox["\[Pi]", "2"]}], "]"}], ",", 
     RowBox[{
      SubscriptBox["pSWAP", 
       RowBox[{"n1", ",", "c"}]], "[", 
      RowBox[{
       FractionBox["\[Pi]", "4"], ",", "\[Pi]"}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rz", "n1"], "[", 
      FractionBox["\[Pi]", "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Ry", "n1"], "[", 
      FractionBox["\[Pi]", "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Ry", "n2"], "[", 
      FractionBox[
       RowBox[{"7", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rz", "c"], "[", 
      FractionBox[
       RowBox[{"13", " ", "\[Pi]"}], "4"], "]"}]}], "}"}], 
   "\[InvisibleSpace]", "\<\"\\nis the circuit correct:   \"\>", 
   "\[InvisibleSpace]", "True", "\[InvisibleSpace]", "\<\"\\n\\n\"\>"}],
  SequenceForm[
  "Gate Type: ", "pswap", "\n#2-qubit gates:  ", 6, "\n#1-qubit gates:  ", 12,
    "(-1) by removing the Z gate at the end\n", 
   Graphics[{
     FaceForm[
      GrayLevel[1]], 
     EdgeForm[
      GrayLevel[0]], {{
       Line[{{0, 0.5}, {1, 0.5}}], 
       Line[{{0, 1.5}, {1, 1.5}}], 
       Line[{{0, 2.5}, {1, 2.5}}]}, {
       Line[{{1, 0.5}, {2, 0.5}}], 
       Line[{{1, 1.5}, {2, 1.5}}], 
       Line[{{1, 2.5}, {2, 2.5}}]}, {
       Line[{{2, 0.5}, {3, 0.5}}], 
       Line[{{2, 1.5}, {3, 1.5}}], 
       Line[{{2, 2.5}, {3, 2.5}}]}, {
       Line[{{3, 0.5}, {4, 0.5}}], 
       Line[{{3, 1.5}, {4, 1.5}}], 
       Line[{{3, 2.5}, {4, 2.5}}]}, {
       Line[{{4, 0.5}, {5, 0.5}}], 
       Line[{{4, 1.5}, {5, 1.5}}], 
       Line[{{4, 2.5}, {5, 2.5}}]}, {{
        Line[{{5.5, 0.5}, {6.5, 0.5}}], 
        Line[{{5.5, 1.5}, {6.5, 1.5}}], 
        Line[{{5.5, 2.5}, {6.5, 2.5}}]}, {
        Line[{{5, 0.5}, {6, 0.5}}]}, {
        Line[{{6, 0.5}, {7, 0.5}}]}}, {
       Line[{{7, 0.5}, {8, 0.5}}], 
       Line[{{7, 1.5}, {8, 1.5}}], 
       Line[{{7, 2.5}, {8, 2.5}}]}, {
       Line[{{8, 0.5}, {9, 0.5}}], 
       Line[{{8, 1.5}, {9, 1.5}}], 
       Line[{{8, 2.5}, {9, 2.5}}]}, {
       Line[{{9, 0.5}, {10, 0.5}}], 
       Line[{{9, 1.5}, {10, 1.5}}], 
       Line[{{9, 2.5}, {10, 2.5}}]}, {{
        Line[{{10.5, 0.5}, {11.5, 0.5}}], 
        Line[{{10.5, 1.5}, {11.5, 1.5}}], 
        Line[{{10.5, 2.5}, {11.5, 2.5}}]}, {
        Line[{{10, 0.5}, {11, 0.5}}]}, {
        Line[{{11, 0.5}, {12, 0.5}}]}}, {
       Line[{{12, 0.5}, {13, 0.5}}], 
       Line[{{12, 1.5}, {13, 1.5}}], 
       Line[{{12, 2.5}, {13, 2.5}}]}, {
       Line[{{13, 0.5}, {14, 0.5}}], 
       Line[{{13, 1.5}, {14, 1.5}}], 
       Line[{{13, 2.5}, {14, 2.5}}]}}, {{
       Rectangle[{0.1, 0.1}, {0.9, 0.9}], 
       Text["Rx", {0.5, 0.5}]}, {
       Rectangle[{0.1, 1.1}, {0.9, 1.9}], 
       Text["Rx", {0.5, 1.5}]}, {
       Rectangle[{1.1, 0.1}, {1.9, 1.9}], 
       Text["pSW", {1.5, 1.}]}, {
       Rectangle[{2.1, 1.1}, {2.9, 2.9}], 
       Text["pSW", {2.5, 2.}]}, {
       Rectangle[{2.1, 0.1}, {2.9, 0.9}], 
       Text["Rz", {2.5, 0.5}]}, {
       Rectangle[{3.1, 0.1}, {3.9, 0.9}], 
       Text["Ry", {3.5, 0.5}]}, {
       Rectangle[{3.1, 1.1}, {3.9, 1.9}], 
       Text["Ry", {3.5, 1.5}]}, {
       Rectangle[{4.1, 0.1}, {4.9, 1.9}], 
       Text["pSW", {4.5, 1.}]}, {{{
         Line[{{5, 2.5}, {5.1, 2.5}}], 
         Line[{{5.1, 2.5}, {5.4, 1.5}}], 
         Line[{{5.4, 1.5}, {5.5, 1.5}}]}, {
         Line[{{5, 1.5}, {5.1, 1.5}}], 
         Line[{{5.1, 1.5}, {5.4, 2.5}}], 
         Line[{{5.4, 2.5}, {5.5, 2.5}}]}}, {
        Rectangle[{5.6, 0.1}, {6.4, 1.9}], 
        Text["pSW", {6., 1.}]}, {{
         Line[{{6.5, 2.5}, {6.6, 2.5}}], 
         Line[{{6.6, 2.5}, {6.9, 1.5}}], 
         Line[{{6.9, 1.5}, {7., 1.5}}]}, {
         Line[{{6.5, 1.5}, {6.6, 1.5}}], 
         Line[{{6.6, 1.5}, {6.9, 2.5}}], 
         Line[{{6.9, 2.5}, {7., 2.5}}]}}}, {
       Rectangle[{7.1, 1.1}, {7.9, 1.9}], 
       Text["Rz", {7.5, 1.5}]}, {
       Rectangle[{8.1, 1.1}, {8.9, 1.9}], 
       Text["Ry", {8.5, 1.5}]}, {
       Rectangle[{8.1, 2.1}, {8.9, 2.9}], 
       Text["Ry", {8.5, 2.5}]}, {
       Rectangle[{9.1, 1.1}, {9.9, 2.9}], 
       Text["pSW", {9.5, 2.}]}, {{{
         Line[{{10, 2.5}, {10.1, 2.5}}], 
         Line[{{10.1, 2.5}, {10.4, 1.5}}], 
         Line[{{10.4, 1.5}, {10.5, 1.5}}]}, {
         Line[{{10, 1.5}, {10.1, 1.5}}], 
         Line[{{10.1, 1.5}, {10.4, 2.5}}], 
         Line[{{10.4, 2.5}, {10.5, 2.5}}]}}, {
        Rectangle[{10.6, 0.1}, {11.4, 1.9}], 
        Text["pSW", {11., 1.}]}, {{
         Line[{{11.5, 2.5}, {11.6, 2.5}}], 
         Line[{{11.6, 2.5}, {11.9, 1.5}}], 
         Line[{{11.9, 1.5}, {12., 1.5}}]}, {
         Line[{{11.5, 1.5}, {11.6, 1.5}}], 
         Line[{{11.6, 1.5}, {11.9, 2.5}}], 
         Line[{{11.9, 2.5}, {12., 2.5}}]}}}, {
       Rectangle[{12.1, 1.1}, {12.9, 1.9}], 
       Text["Ry", {12.5, 1.5}]}, {
       Rectangle[{12.1, 0.1}, {12.9, 0.9}], 
       Text["Rz", {12.5, 0.5}]}, {
       Rectangle[{12.1, 2.1}, {12.9, 2.9}], 
       Text["Rz", {12.5, 2.5}]}, {
       Rectangle[{13.1, 0.1}, {13.9, 0.9}], 
       Text["Ry", {13.5, 0.5}]}}}, {ImageSize -> {Automatic, 60}}, ImageSize -> 
    450, PlotRangePadding -> None], "\n", {
    Subscript[QuEST`Gate`Rx, $CellContext`n1][Rational[1, 2] Pi], 
    Subscript[QuEST`Gate`Rx, $CellContext`n2][Rational[5, 2] Pi], 
    Subscript[$CellContext`pSWAP, $CellContext`n1, $CellContext`n2][
    Rational[31, 8] Pi, Rational[3, 4] Pi], 
    Subscript[$CellContext`pSWAP, $CellContext`n2, $CellContext`c][
    Rational[7, 2] Pi, Rational[7, 4] Pi], 
    Subscript[QuEST`Gate`Rz, $CellContext`n1][Rational[5, 2] Pi], 
    Subscript[QuEST`Gate`Ry, $CellContext`n1][Rational[7, 2] Pi], 
    Subscript[QuEST`Gate`Ry, $CellContext`n2][Rational[1, 2] Pi], 
    Subscript[$CellContext`pSWAP, $CellContext`n1, $CellContext`n2][
    Rational[1, 8] Pi, Rational[5, 2] Pi], 
    Subscript[$CellContext`pSWAP, $CellContext`n1, $CellContext`c][
    Rational[1, 4] Pi, Rational[5, 2] Pi], 
    Subscript[QuEST`Gate`Rz, $CellContext`n2][Rational[7, 2] Pi], 
    Subscript[QuEST`Gate`Ry, $CellContext`n2][Rational[5, 2] Pi], 
    Subscript[QuEST`Gate`Ry, $CellContext`c][Rational[1, 2] Pi], 
    Subscript[$CellContext`pSWAP, $CellContext`n2, $CellContext`c][
    Rational[19, 8] Pi, Rational[1, 2] Pi], 
    Subscript[$CellContext`pSWAP, $CellContext`n1, $CellContext`c][
    Rational[1, 4] Pi, Pi], 
    Subscript[QuEST`Gate`Rz, $CellContext`n1][Rational[1, 2] Pi], 
    Subscript[QuEST`Gate`Ry, $CellContext`n1][Rational[1, 2] Pi], 
    Subscript[QuEST`Gate`Ry, $CellContext`n2][Rational[7, 2] Pi], 
    Subscript[QuEST`Gate`Rz, $CellContext`c][Rational[13, 4] Pi]}, 
   "\nis the circuit correct:   ", True, "\n\n"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.831725854855904*^9, 3.8317258823995237`*^9}, 
   3.8317259314680758`*^9, 3.8317263601541*^9},
 CellLabel->
  "During evaluation of \
In[13]:=",ExpressionUUID->"0316abb2-dbd2-40b2-a14f-7ab9de2e9c3b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Gate Type: \"\>", "\[InvisibleSpace]", "\<\"pswapUE\"\>", 
   "\[InvisibleSpace]", "\<\"\\n#2-qubit gates:  \"\>", "\[InvisibleSpace]", 
   "5", "\[InvisibleSpace]", "\<\"\\n#1-qubit gates:  \"\>", 
   "\[InvisibleSpace]", "5", 
   "\[InvisibleSpace]", "\<\"(-1) by removing the Z gate at the end\\n\"\>", 
   "\[InvisibleSpace]", 
   GraphicsBox[
    {EdgeForm[GrayLevel[0]], FaceForm[GrayLevel[
     1]], {{LineBox[{{0, 0.5}, {1, 0.5}}], LineBox[{{0, 1.5}, {1, 1.5}}], 
       LineBox[{{0, 2.5}, {1, 2.5}}]}, {LineBox[{{1, 0.5}, {2, 0.5}}], 
       LineBox[{{1, 1.5}, {2, 1.5}}], LineBox[{{1, 2.5}, {2, 2.5}}]}, {
       LineBox[{{2, 0.5}, {3, 0.5}}], LineBox[{{2, 1.5}, {3, 1.5}}], 
       LineBox[{{2, 2.5}, {3, 2.5}}]}, {{LineBox[{{3.5, 0.5}, {4.5, 0.5}}], 
        LineBox[{{3.5, 1.5}, {4.5, 1.5}}], LineBox[{{3.5, 2.5}, {4.5, 2.5}}]},
        LineBox[{{3, 0.5}, {4, 0.5}}], LineBox[{{4, 0.5}, {5, 0.5}}]}, {
       LineBox[{{5, 0.5}, {6, 0.5}}], LineBox[{{5, 1.5}, {6, 1.5}}], 
       LineBox[{{5, 2.5}, {6, 2.5}}]}, {LineBox[{{6, 0.5}, {7, 0.5}}], 
       LineBox[{{6, 1.5}, {7, 1.5}}], LineBox[{{6, 2.5}, {7, 2.5}}]}, {
       LineBox[{{7, 0.5}, {8, 0.5}}], LineBox[{{7, 1.5}, {8, 1.5}}], 
       LineBox[{{7, 2.5}, {8, 2.5}}]}, {LineBox[{{8, 0.5}, {9, 0.5}}], 
       LineBox[{{8, 1.5}, {9, 1.5}}], 
       LineBox[{{8, 2.5}, {9, 2.5}}]}, {{LineBox[{{9.5, 0.5}, {10.5, 0.5}}], 
        LineBox[{{9.5, 1.5}, {10.5, 1.5}}], 
        LineBox[{{9.5, 2.5}, {10.5, 2.5}}]}, LineBox[{{9, 0.5}, {10, 0.5}}], 
       LineBox[{{10, 0.5}, {11, 0.5}}]}, {LineBox[{{11, 0.5}, {12, 0.5}}], 
       LineBox[{{11, 1.5}, {12, 1.5}}], LineBox[{{11, 2.5}, {12, 2.5}}]}}, {{
       RectangleBox[{0.1, 1.1}, {0.9, 1.9}], 
       InsetBox["\<\"Rz\"\>", {0.5, 1.5}]}, {
       RectangleBox[{1.1, 0.1}, {1.9, 1.9}], 
       InsetBox["\<\"pSW\"\>", {1.5, 1.}]}, {
       RectangleBox[{2.1, 1.1}, {2.9, 2.9}], 
       InsetBox["\<\"pSW\"\>", {2.5, 2.}]}, {{{
         LineBox[{{3, 2.5}, {3.1, 2.5}}], LineBox[{{3.1, 2.5}, {3.4, 1.5}}], 
         LineBox[{{3.4, 1.5}, {3.5, 1.5}}]}, {LineBox[{{3, 1.5}, {3.1, 1.5}}],
          LineBox[{{3.1, 1.5}, {3.4, 2.5}}], 
         LineBox[{{3.4, 2.5}, {3.5, 2.5}}]}}, {
        RectangleBox[{3.6, 0.1}, {4.4, 1.9}], 
        InsetBox["\<\"pSW\"\>", {4., 1.}]}, {{
         LineBox[{{4.5, 2.5}, {4.6, 2.5}}], LineBox[{{4.6, 2.5}, {4.9, 1.5}}],
          LineBox[{{4.9, 1.5}, {5., 1.5}}]}, {
         LineBox[{{4.5, 1.5}, {4.6, 1.5}}], LineBox[{{4.6, 1.5}, {4.9, 2.5}}],
          LineBox[{{4.9, 2.5}, {5., 2.5}}]}}}, {
       RectangleBox[{5.1, 1.1}, {5.9, 1.9}], 
       InsetBox["\<\"Ry\"\>", {5.5, 1.5}]}, {
       RectangleBox[{6.1, 0.1}, {6.9, 1.9}], 
       InsetBox["\<\"pSW\"\>", {6.5, 1.}]}, {
       RectangleBox[{7.1, 0.1}, {7.9, 0.9}], 
       InsetBox["\<\"Rz\"\>", {7.5, 0.5}]}, {
       RectangleBox[{8.1, 0.1}, {8.9, 0.9}], 
       InsetBox["\<\"Ry\"\>", {8.5, 0.5}]}, {{{
         LineBox[{{9, 2.5}, {9.1, 2.5}}], LineBox[{{9.1, 2.5}, {9.4, 1.5}}], 
         LineBox[{{9.4, 1.5}, {9.5, 1.5}}]}, {LineBox[{{9, 1.5}, {9.1, 1.5}}],
          LineBox[{{9.1, 1.5}, {9.4, 2.5}}], 
         LineBox[{{9.4, 2.5}, {9.5, 2.5}}]}}, {
        RectangleBox[{9.6, 0.1}, {10.4, 1.9}], 
        InsetBox["\<\"pSW\"\>", {10., 1.}]}, {{
         LineBox[{{10.5, 2.5}, {10.6, 2.5}}], 
         LineBox[{{10.6, 2.5}, {10.9, 1.5}}], 
         LineBox[{{10.9, 1.5}, {11., 1.5}}]}, {
         LineBox[{{10.5, 1.5}, {10.6, 1.5}}], 
         LineBox[{{10.6, 1.5}, {10.9, 2.5}}], 
         LineBox[{{10.9, 2.5}, {11., 2.5}}]}}}, {
       RectangleBox[{11.1, 2.1}, {11.9, 2.9}], 
       InsetBox["\<\"Rz\"\>", {11.5, 2.5}]}}},
    ImageSize->{Automatic, 60},
    PlotRangePadding->None], "\[InvisibleSpace]", "\<\"\\n\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      SubscriptBox["Rz", "n2"], "[", 
      FractionBox[
       RowBox[{"3", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["pSWAP", 
       RowBox[{"n1", ",", "n2"}]], "[", 
      RowBox[{
       FractionBox[
        RowBox[{"19", " ", "\[Pi]"}], "8"], ",", 
       FractionBox[
        RowBox[{"159", " ", "\[Pi]"}], "200"]}], "]"}], ",", 
     RowBox[{
      SubscriptBox["pSWAP", 
       RowBox[{"n2", ",", "c"}]], "[", 
      RowBox[{"n1", ",", 
       FractionBox[
        RowBox[{"13", " ", "\[Pi]"}], "8"]}], "]"}], ",", 
     RowBox[{
      SubscriptBox["pSWAP", 
       RowBox[{"n1", ",", "c"}]], "[", 
      RowBox[{"n1", ",", 
       FractionBox[
        RowBox[{"23", " ", "\[Pi]"}], "8"]}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Ry", "n2"], "[", 
      FractionBox[
       RowBox[{"7", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["pSWAP", 
       RowBox[{"n1", ",", "n2"}]], "[", 
      RowBox[{
       FractionBox[
        RowBox[{"15", " ", "\[Pi]"}], "4"], ",", 
       FractionBox[
        RowBox[{"7", " ", "\[Pi]"}], "2"]}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rz", "n1"], "[", 
      FractionBox[
       RowBox[{"7", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Ry", "n1"], "[", 
      FractionBox["\[Pi]", "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["pSWAP", 
       RowBox[{"n1", ",", "c"}]], "[", 
      RowBox[{
       FractionBox[
        RowBox[{"7", " ", "\[Pi]"}], "2"], ",", 
       FractionBox[
        RowBox[{"31", " ", "\[Pi]"}], "8"]}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rz", "c"], "[", 
      FractionBox[
       RowBox[{"7", " ", "\[Pi]"}], "4"], "]"}]}], "}"}], 
   "\[InvisibleSpace]", "\<\"\\nis the circuit correct:   \"\>", 
   "\[InvisibleSpace]", "True", "\[InvisibleSpace]", "\<\"\\n\\n\"\>"}],
  SequenceForm[
  "Gate Type: ", "pswapUE", "\n#2-qubit gates:  ", 5, "\n#1-qubit gates:  ", 
   5, "(-1) by removing the Z gate at the end\n", 
   Graphics[{
     FaceForm[
      GrayLevel[1]], 
     EdgeForm[
      GrayLevel[0]], {{
       Line[{{0, 0.5}, {1, 0.5}}], 
       Line[{{0, 1.5}, {1, 1.5}}], 
       Line[{{0, 2.5}, {1, 2.5}}]}, {
       Line[{{1, 0.5}, {2, 0.5}}], 
       Line[{{1, 1.5}, {2, 1.5}}], 
       Line[{{1, 2.5}, {2, 2.5}}]}, {
       Line[{{2, 0.5}, {3, 0.5}}], 
       Line[{{2, 1.5}, {3, 1.5}}], 
       Line[{{2, 2.5}, {3, 2.5}}]}, {{
        Line[{{3.5, 0.5}, {4.5, 0.5}}], 
        Line[{{3.5, 1.5}, {4.5, 1.5}}], 
        Line[{{3.5, 2.5}, {4.5, 2.5}}]}, {
        Line[{{3, 0.5}, {4, 0.5}}]}, {
        Line[{{4, 0.5}, {5, 0.5}}]}}, {
       Line[{{5, 0.5}, {6, 0.5}}], 
       Line[{{5, 1.5}, {6, 1.5}}], 
       Line[{{5, 2.5}, {6, 2.5}}]}, {
       Line[{{6, 0.5}, {7, 0.5}}], 
       Line[{{6, 1.5}, {7, 1.5}}], 
       Line[{{6, 2.5}, {7, 2.5}}]}, {
       Line[{{7, 0.5}, {8, 0.5}}], 
       Line[{{7, 1.5}, {8, 1.5}}], 
       Line[{{7, 2.5}, {8, 2.5}}]}, {
       Line[{{8, 0.5}, {9, 0.5}}], 
       Line[{{8, 1.5}, {9, 1.5}}], 
       Line[{{8, 2.5}, {9, 2.5}}]}, {{
        Line[{{9.5, 0.5}, {10.5, 0.5}}], 
        Line[{{9.5, 1.5}, {10.5, 1.5}}], 
        Line[{{9.5, 2.5}, {10.5, 2.5}}]}, {
        Line[{{9, 0.5}, {10, 0.5}}]}, {
        Line[{{10, 0.5}, {11, 0.5}}]}}, {
       Line[{{11, 0.5}, {12, 0.5}}], 
       Line[{{11, 1.5}, {12, 1.5}}], 
       Line[{{11, 2.5}, {12, 2.5}}]}}, {{
       Rectangle[{0.1, 1.1}, {0.9, 1.9}], 
       Text["Rz", {0.5, 1.5}]}, {
       Rectangle[{1.1, 0.1}, {1.9, 1.9}], 
       Text["pSW", {1.5, 1.}]}, {
       Rectangle[{2.1, 1.1}, {2.9, 2.9}], 
       Text["pSW", {2.5, 2.}]}, {{{
         Line[{{3, 2.5}, {3.1, 2.5}}], 
         Line[{{3.1, 2.5}, {3.4, 1.5}}], 
         Line[{{3.4, 1.5}, {3.5, 1.5}}]}, {
         Line[{{3, 1.5}, {3.1, 1.5}}], 
         Line[{{3.1, 1.5}, {3.4, 2.5}}], 
         Line[{{3.4, 2.5}, {3.5, 2.5}}]}}, {
        Rectangle[{3.6, 0.1}, {4.4, 1.9}], 
        Text["pSW", {4., 1.}]}, {{
         Line[{{4.5, 2.5}, {4.6, 2.5}}], 
         Line[{{4.6, 2.5}, {4.9, 1.5}}], 
         Line[{{4.9, 1.5}, {5., 1.5}}]}, {
         Line[{{4.5, 1.5}, {4.6, 1.5}}], 
         Line[{{4.6, 1.5}, {4.9, 2.5}}], 
         Line[{{4.9, 2.5}, {5., 2.5}}]}}}, {
       Rectangle[{5.1, 1.1}, {5.9, 1.9}], 
       Text["Ry", {5.5, 1.5}]}, {
       Rectangle[{6.1, 0.1}, {6.9, 1.9}], 
       Text["pSW", {6.5, 1.}]}, {
       Rectangle[{7.1, 0.1}, {7.9, 0.9}], 
       Text["Rz", {7.5, 0.5}]}, {
       Rectangle[{8.1, 0.1}, {8.9, 0.9}], 
       Text["Ry", {8.5, 0.5}]}, {{{
         Line[{{9, 2.5}, {9.1, 2.5}}], 
         Line[{{9.1, 2.5}, {9.4, 1.5}}], 
         Line[{{9.4, 1.5}, {9.5, 1.5}}]}, {
         Line[{{9, 1.5}, {9.1, 1.5}}], 
         Line[{{9.1, 1.5}, {9.4, 2.5}}], 
         Line[{{9.4, 2.5}, {9.5, 2.5}}]}}, {
        Rectangle[{9.6, 0.1}, {10.4, 1.9}], 
        Text["pSW", {10., 1.}]}, {{
         Line[{{10.5, 2.5}, {10.6, 2.5}}], 
         Line[{{10.6, 2.5}, {10.9, 1.5}}], 
         Line[{{10.9, 1.5}, {11., 1.5}}]}, {
         Line[{{10.5, 1.5}, {10.6, 1.5}}], 
         Line[{{10.6, 1.5}, {10.9, 2.5}}], 
         Line[{{10.9, 2.5}, {11., 2.5}}]}}}, {
       Rectangle[{11.1, 2.1}, {11.9, 2.9}], 
       Text["Rz", {11.5, 2.5}]}}}, {ImageSize -> {Automatic, 60}}, ImageSize -> 
    390, PlotRangePadding -> None], "\n", {
    Subscript[QuEST`Gate`Rz, $CellContext`n2][Rational[3, 2] Pi], 
    Subscript[$CellContext`pSWAP, $CellContext`n1, $CellContext`n2][
    Rational[19, 8] Pi, Rational[159, 200] Pi], 
    Subscript[$CellContext`pSWAP, $CellContext`n2, \
$CellContext`c][$CellContext`n1, Rational[13, 8] Pi], 
    Subscript[$CellContext`pSWAP, $CellContext`n1, \
$CellContext`c][$CellContext`n1, Rational[23, 8] Pi], 
    Subscript[QuEST`Gate`Ry, $CellContext`n2][Rational[7, 2] Pi], 
    Subscript[$CellContext`pSWAP, $CellContext`n1, $CellContext`n2][
    Rational[15, 4] Pi, Rational[7, 2] Pi], 
    Subscript[QuEST`Gate`Rz, $CellContext`n1][Rational[7, 2] Pi], 
    Subscript[QuEST`Gate`Ry, $CellContext`n1][Rational[1, 2] Pi], 
    Subscript[$CellContext`pSWAP, $CellContext`n1, $CellContext`c][
    Rational[7, 2] Pi, Rational[31, 8] Pi], 
    Subscript[QuEST`Gate`Rz, $CellContext`c][Rational[7, 4] Pi]}, 
   "\nis the circuit correct:   ", True, "\n\n"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.831725854855904*^9, 3.8317258823995237`*^9}, 
   3.8317259314680758`*^9, 3.8317263601830225`*^9},
 CellLabel->
  "During evaluation of \
In[13]:=",ExpressionUUID->"53e07ff8-39bf-465d-8e01-e90047cfd22d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Gate Type: \"\>", "\[InvisibleSpace]", "\<\"cz\"\>", 
   "\[InvisibleSpace]", "\<\"\\n#2-qubit gates:  \"\>", "\[InvisibleSpace]", 
   "6", "\[InvisibleSpace]", "\<\"\\n#1-qubit gates:  \"\>", 
   "\[InvisibleSpace]", "16", 
   "\[InvisibleSpace]", "\<\"(-1) by removing the Z gate at the end\\n\"\>", 
   "\[InvisibleSpace]", 
   GraphicsBox[
    {EdgeForm[GrayLevel[0]], FaceForm[GrayLevel[
     1]], {{LineBox[{{0, 0.5}, {1, 0.5}}], LineBox[{{0, 1.5}, {1, 1.5}}], 
       LineBox[{{0, 2.5}, {1, 2.5}}]}, {LineBox[{{1, 0.5}, {2, 0.5}}], 
       LineBox[{{1, 1.5}, {2, 1.5}}], LineBox[{{1, 2.5}, {2, 2.5}}]}, {
       LineBox[{{2, 0.5}, {3, 0.5}}], LineBox[{{2, 1.5}, {3, 1.5}}], 
       LineBox[{{2, 2.5}, {3, 2.5}}]}, {LineBox[{{3, 0.5}, {4, 0.5}}], 
       LineBox[{{3, 1.5}, {4, 1.5}}], LineBox[{{3, 2.5}, {4, 2.5}}]}, {
       LineBox[{{4, 0.5}, {5, 0.5}}], LineBox[{{4, 1.5}, {5, 1.5}}], 
       LineBox[{{4, 2.5}, {5, 2.5}}]}, {LineBox[{{5, 0.5}, {6, 0.5}}], 
       LineBox[{{5, 1.5}, {6, 1.5}}], LineBox[{{5, 2.5}, {6, 2.5}}]}, {
       LineBox[{{6, 0.5}, {7, 0.5}}], LineBox[{{6, 1.5}, {7, 1.5}}], 
       LineBox[{{6, 2.5}, {7, 2.5}}]}, {LineBox[{{7, 0.5}, {8, 0.5}}], 
       LineBox[{{7, 1.5}, {8, 1.5}}], LineBox[{{7, 2.5}, {8, 2.5}}]}, {
       LineBox[{{8, 0.5}, {9, 0.5}}], LineBox[{{8, 1.5}, {9, 1.5}}], 
       LineBox[{{8, 2.5}, {9, 2.5}}]}, {LineBox[{{9, 0.5}, {10, 0.5}}], 
       LineBox[{{9, 1.5}, {10, 1.5}}], LineBox[{{9, 2.5}, {10, 2.5}}]}, {
       LineBox[{{10, 0.5}, {11, 0.5}}], LineBox[{{10, 1.5}, {11, 1.5}}], 
       LineBox[{{10, 2.5}, {11, 2.5}}]}, {LineBox[{{11, 0.5}, {12, 0.5}}], 
       LineBox[{{11, 1.5}, {12, 1.5}}], LineBox[{{11, 2.5}, {12, 2.5}}]}, {
       LineBox[{{12, 0.5}, {13, 0.5}}], LineBox[{{12, 1.5}, {13, 1.5}}], 
       LineBox[{{12, 2.5}, {13, 2.5}}]}, {LineBox[{{13, 0.5}, {14, 0.5}}], 
       LineBox[{{13, 1.5}, {14, 1.5}}], LineBox[{{13, 2.5}, {14, 2.5}}]}}, {{
       RectangleBox[{0.1, 1.1}, {0.9, 1.9}], 
       InsetBox["\<\"Rx\"\>", {0.5, 1.5}]}, {
       {FaceForm[GrayLevel[0]], DiskBox[{1.5, 0.5}, 0.1], 
        LineBox[{{1.5, 0.5}, {1.5, 1.5}}]}, {
        RectangleBox[{1.1, 1.1}, {1.9, 1.9}], 
        InsetBox["\<\"Rz\"\>", {1.5, 1.5}]}}, {
       RectangleBox[{2.1, 1.1}, {2.9, 1.9}], 
       InsetBox["\<\"Ry\"\>", {2.5, 1.5}]}, {
       RectangleBox[{2.1, 0.1}, {2.9, 0.9}], 
       InsetBox["\<\"Ry\"\>", {2.5, 0.5}]}, {
       RectangleBox[{3.1, 1.1}, {3.9, 1.9}], 
       InsetBox["\<\"Rz\"\>", {3.5, 1.5}]}, {
       {FaceForm[GrayLevel[0]], DiskBox[{4.5, 2.5}, 0.1], 
        LineBox[{{4.5, 1.5}, {4.5, 2.5}}]}, {
        RectangleBox[{4.1, 1.1}, {4.9, 1.9}], 
        InsetBox["\<\"Rz\"\>", {4.5, 1.5}]}}, {
       RectangleBox[{5.1, 1.1}, {5.9, 1.9}], 
       InsetBox["\<\"Ry\"\>", {5.5, 1.5}]}, {
       {FaceForm[GrayLevel[0]], DiskBox[{6.5, 1.5}, 0.1], 
        LineBox[{{6.5, 0.5}, {6.5, 1.5}}]}, {
        RectangleBox[{6.1, 0.1}, {6.9, 0.9}], 
        InsetBox["\<\"Rz\"\>", {6.5, 0.5}]}}, {
       {FaceForm[GrayLevel[0]], DiskBox[{7.5, 2.5}, 0.1], 
        LineBox[{{7.5, 0.5}, {7.5, 2.5}}]}, {
        RectangleBox[{7.1, 0.1}, {7.9, 0.9}], 
        InsetBox["\<\"Rz\"\>", {7.5, 0.5}]}}, {
       RectangleBox[{8.1, 1.1}, {8.9, 1.9}], 
       InsetBox["\<\"Rx\"\>", {8.5, 1.5}]}, {
       RectangleBox[{8.1, 0.1}, {8.9, 0.9}], 
       InsetBox["\<\"Rx\"\>", {8.5, 0.5}]}, {
       {FaceForm[GrayLevel[0]], DiskBox[{9.5, 2.5}, 0.1], 
        LineBox[{{9.5, 1.5}, {9.5, 2.5}}]}, {
        RectangleBox[{9.1, 1.1}, {9.9, 1.9}], 
        InsetBox["\<\"Rz\"\>", {9.5, 1.5}]}}, {
       RectangleBox[{9.1, 0.1}, {9.9, 0.9}], 
       InsetBox["\<\"Rz\"\>", {9.5, 0.5}]}, {
       RectangleBox[{10.1, 1.1}, {10.9, 1.9}], 
       InsetBox["\<\"Rx\"\>", {10.5, 1.5}]}, {
       RectangleBox[{10.1, 2.1}, {10.9, 2.9}], 
       InsetBox["\<\"Rx\"\>", {10.5, 2.5}]}, {
       RectangleBox[{10.1, 0.1}, {10.9, 0.9}], 
       InsetBox["\<\"Rx\"\>", {10.5, 0.5}]}, {
       RectangleBox[{11.1, 2.1}, {11.9, 2.9}], 
       InsetBox["\<\"Rz\"\>", {11.5, 2.5}]}, {
       {FaceForm[GrayLevel[0]], DiskBox[{11.5, 1.5}, 0.1], 
        LineBox[{{11.5, 0.5}, {11.5, 1.5}}]}, {
        RectangleBox[{11.1, 0.1}, {11.9, 0.9}], 
        InsetBox["\<\"Rz\"\>", {11.5, 0.5}]}}, {
       RectangleBox[{12.1, 1.1}, {12.9, 1.9}], 
       InsetBox["\<\"Ry\"\>", {12.5, 1.5}]}, {
       RectangleBox[{12.1, 0.1}, {12.9, 0.9}], 
       InsetBox["\<\"Rx\"\>", {12.5, 0.5}]}, {
       RectangleBox[{13.1, 0.1}, {13.9, 0.9}], 
       InsetBox["\<\"Rz\"\>", {13.5, 0.5}]}, {
       RectangleBox[{13.1, 1.1}, {13.9, 1.9}], 
       InsetBox["\<\"Rz\"\>", {13.5, 1.5}]}}},
    ImageSize->{Automatic, 60},
    PlotRangePadding->None], "\[InvisibleSpace]", "\<\"\\n\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      SubscriptBox["Rx", "n2"], "[", 
      FractionBox[
       RowBox[{"7", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["C", "n1"], "[", 
      RowBox[{
       SubscriptBox["Rz", "n2"], "[", 
       RowBox[{"3", " ", "\[Pi]"}], "]"}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Ry", "n2"], "[", 
      FractionBox[
       RowBox[{"3", " ", "\[Pi]"}], "4"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rz", "n2"], "[", 
      RowBox[{"3", " ", "\[Pi]"}], "]"}], ",", 
     RowBox[{
      SubscriptBox["C", "c"], "[", 
      RowBox[{
       SubscriptBox["Rz", "n2"], "[", "\[Pi]", "]"}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Ry", "n1"], "[", 
      FractionBox[
       RowBox[{"5", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Ry", "n2"], "[", 
      FractionBox[
       RowBox[{"7", " ", "\[Pi]"}], "4"], "]"}], ",", 
     RowBox[{
      SubscriptBox["C", "n2"], "[", 
      RowBox[{
       SubscriptBox["Rz", "n1"], "[", "\[Pi]", "]"}], "]"}], ",", 
     RowBox[{
      SubscriptBox["C", "c"], "[", 
      RowBox[{
       SubscriptBox["Rz", "n1"], "[", 
       FractionBox[
        RowBox[{"5", " ", "\[Pi]"}], "2"], "]"}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rx", "n1"], "[", 
      FractionBox[
       RowBox[{"3", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rx", "n2"], "[", 
      FractionBox[
       RowBox[{"3", " ", "\[Pi]"}], "4"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rz", "n1"], "[", 
      FractionBox[
       RowBox[{"5", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["C", "c"], "[", 
      RowBox[{
       SubscriptBox["Rz", "n2"], "[", "\[Pi]", "]"}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rx", "n1"], "[", "\[Pi]", "]"}], ",", 
     RowBox[{
      SubscriptBox["Rx", "n2"], "[", 
      FractionBox["\[Pi]", "4"], "]"}], ",", 
     RowBox[{
      SubscriptBox["C", "n2"], "[", 
      RowBox[{
       SubscriptBox["Rz", "n1"], "[", "\[Pi]", "]"}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Ry", "n2"], "[", 
      FractionBox[
       RowBox[{"7", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rx", "n1"], "[", 
      FractionBox["\[Pi]", "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rx", "c"], "[", "n1", "]"}], ",", 
     RowBox[{
      SubscriptBox["Rz", "n1"], "[", 
      FractionBox[
       RowBox[{"7", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rz", "n2"], "[", 
      FractionBox["\[Pi]", "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rz", "c"], "[", 
      FractionBox[
       RowBox[{"3", " ", "\[Pi]"}], "4"], "]"}]}], "}"}], 
   "\[InvisibleSpace]", "\<\"\\nis the circuit correct:   \"\>", 
   "\[InvisibleSpace]", "True", "\[InvisibleSpace]", "\<\"\\n\\n\"\>"}],
  SequenceForm[
  "Gate Type: ", "cz", "\n#2-qubit gates:  ", 6, "\n#1-qubit gates:  ", 16, 
   "(-1) by removing the Z gate at the end\n", 
   Graphics[{
     FaceForm[
      GrayLevel[1]], 
     EdgeForm[
      GrayLevel[0]], {{
       Line[{{0, 0.5}, {1, 0.5}}], 
       Line[{{0, 1.5}, {1, 1.5}}], 
       Line[{{0, 2.5}, {1, 2.5}}]}, {
       Line[{{1, 0.5}, {2, 0.5}}], 
       Line[{{1, 1.5}, {2, 1.5}}], 
       Line[{{1, 2.5}, {2, 2.5}}]}, {
       Line[{{2, 0.5}, {3, 0.5}}], 
       Line[{{2, 1.5}, {3, 1.5}}], 
       Line[{{2, 2.5}, {3, 2.5}}]}, {
       Line[{{3, 0.5}, {4, 0.5}}], 
       Line[{{3, 1.5}, {4, 1.5}}], 
       Line[{{3, 2.5}, {4, 2.5}}]}, {
       Line[{{4, 0.5}, {5, 0.5}}], 
       Line[{{4, 1.5}, {5, 1.5}}], 
       Line[{{4, 2.5}, {5, 2.5}}]}, {
       Line[{{5, 0.5}, {6, 0.5}}], 
       Line[{{5, 1.5}, {6, 1.5}}], 
       Line[{{5, 2.5}, {6, 2.5}}]}, {
       Line[{{6, 0.5}, {7, 0.5}}], 
       Line[{{6, 1.5}, {7, 1.5}}], 
       Line[{{6, 2.5}, {7, 2.5}}]}, {
       Line[{{7, 0.5}, {8, 0.5}}], 
       Line[{{7, 1.5}, {8, 1.5}}], 
       Line[{{7, 2.5}, {8, 2.5}}]}, {
       Line[{{8, 0.5}, {9, 0.5}}], 
       Line[{{8, 1.5}, {9, 1.5}}], 
       Line[{{8, 2.5}, {9, 2.5}}]}, {
       Line[{{9, 0.5}, {10, 0.5}}], 
       Line[{{9, 1.5}, {10, 1.5}}], 
       Line[{{9, 2.5}, {10, 2.5}}]}, {
       Line[{{10, 0.5}, {11, 0.5}}], 
       Line[{{10, 1.5}, {11, 1.5}}], 
       Line[{{10, 2.5}, {11, 2.5}}]}, {
       Line[{{11, 0.5}, {12, 0.5}}], 
       Line[{{11, 1.5}, {12, 1.5}}], 
       Line[{{11, 2.5}, {12, 2.5}}]}, {
       Line[{{12, 0.5}, {13, 0.5}}], 
       Line[{{12, 1.5}, {13, 1.5}}], 
       Line[{{12, 2.5}, {13, 2.5}}]}, {
       Line[{{13, 0.5}, {14, 0.5}}], 
       Line[{{13, 1.5}, {14, 1.5}}], 
       Line[{{13, 2.5}, {14, 2.5}}]}}, {{
       Rectangle[{0.1, 1.1}, {0.9, 1.9}], 
       Text["Rx", {0.5, 1.5}]}, {{
        FaceForm[
         GrayLevel[0]], {
         Disk[{1.5, 0.5}, 0.1]}, 
        Line[{{1.5, 0.5}, {1.5, 1.5}}]}, {
        Rectangle[{1.1, 1.1}, {1.9, 1.9}], 
        Text["Rz", {1.5, 1.5}]}}, {
       Rectangle[{2.1, 1.1}, {2.9, 1.9}], 
       Text["Ry", {2.5, 1.5}]}, {
       Rectangle[{2.1, 0.1}, {2.9, 0.9}], 
       Text["Ry", {2.5, 0.5}]}, {
       Rectangle[{3.1, 1.1}, {3.9, 1.9}], 
       Text["Rz", {3.5, 1.5}]}, {{
        FaceForm[
         GrayLevel[0]], {
         Disk[{4.5, 2.5}, 0.1]}, 
        Line[{{4.5, 1.5}, {4.5, 2.5}}]}, {
        Rectangle[{4.1, 1.1}, {4.9, 1.9}], 
        Text["Rz", {4.5, 1.5}]}}, {
       Rectangle[{5.1, 1.1}, {5.9, 1.9}], 
       Text["Ry", {5.5, 1.5}]}, {{
        FaceForm[
         GrayLevel[0]], {
         Disk[{6.5, 1.5}, 0.1]}, 
        Line[{{6.5, 0.5}, {6.5, 1.5}}]}, {
        Rectangle[{6.1, 0.1}, {6.9, 0.9}], 
        Text["Rz", {6.5, 0.5}]}}, {{
        FaceForm[
         GrayLevel[0]], {
         Disk[{7.5, 2.5}, 0.1]}, 
        Line[{{7.5, 0.5}, {7.5, 2.5}}]}, {
        Rectangle[{7.1, 0.1}, {7.9, 0.9}], 
        Text["Rz", {7.5, 0.5}]}}, {
       Rectangle[{8.1, 1.1}, {8.9, 1.9}], 
       Text["Rx", {8.5, 1.5}]}, {
       Rectangle[{8.1, 0.1}, {8.9, 0.9}], 
       Text["Rx", {8.5, 0.5}]}, {{
        FaceForm[
         GrayLevel[0]], {
         Disk[{9.5, 2.5}, 0.1]}, 
        Line[{{9.5, 1.5}, {9.5, 2.5}}]}, {
        Rectangle[{9.1, 1.1}, {9.9, 1.9}], 
        Text["Rz", {9.5, 1.5}]}}, {
       Rectangle[{9.1, 0.1}, {9.9, 0.9}], 
       Text["Rz", {9.5, 0.5}]}, {
       Rectangle[{10.1, 1.1}, {10.9, 1.9}], 
       Text["Rx", {10.5, 1.5}]}, {
       Rectangle[{10.1, 2.1}, {10.9, 2.9}], 
       Text["Rx", {10.5, 2.5}]}, {
       Rectangle[{10.1, 0.1}, {10.9, 0.9}], 
       Text["Rx", {10.5, 0.5}]}, {
       Rectangle[{11.1, 2.1}, {11.9, 2.9}], 
       Text["Rz", {11.5, 2.5}]}, {{
        FaceForm[
         GrayLevel[0]], {
         Disk[{11.5, 1.5}, 0.1]}, 
        Line[{{11.5, 0.5}, {11.5, 1.5}}]}, {
        Rectangle[{11.1, 0.1}, {11.9, 0.9}], 
        Text["Rz", {11.5, 0.5}]}}, {
       Rectangle[{12.1, 1.1}, {12.9, 1.9}], 
       Text["Ry", {12.5, 1.5}]}, {
       Rectangle[{12.1, 0.1}, {12.9, 0.9}], 
       Text["Rx", {12.5, 0.5}]}, {
       Rectangle[{13.1, 0.1}, {13.9, 0.9}], 
       Text["Rz", {13.5, 0.5}]}, {
       Rectangle[{13.1, 1.1}, {13.9, 1.9}], 
       Text["Rz", {13.5, 1.5}]}}}, {ImageSize -> {Automatic, 60}}, ImageSize -> 
    450, PlotRangePadding -> None], "\n", {
    Subscript[QuEST`Gate`Rx, $CellContext`n2][Rational[7, 2] Pi], 
    Subscript[C, $CellContext`n1][
     Subscript[QuEST`Gate`Rz, $CellContext`n2][3 Pi]], 
    Subscript[QuEST`Gate`Ry, $CellContext`n2][Rational[3, 4] Pi], 
    Subscript[QuEST`Gate`Rz, $CellContext`n2][3 Pi], 
    Subscript[C, $CellContext`c][
     Subscript[QuEST`Gate`Rz, $CellContext`n2][Pi]], 
    Subscript[QuEST`Gate`Ry, $CellContext`n1][Rational[5, 2] Pi], 
    Subscript[QuEST`Gate`Ry, $CellContext`n2][Rational[7, 4] Pi], 
    Subscript[C, $CellContext`n2][
     Subscript[QuEST`Gate`Rz, $CellContext`n1][Pi]], 
    Subscript[C, $CellContext`c][
     Subscript[QuEST`Gate`Rz, $CellContext`n1][Rational[5, 2] Pi]], 
    Subscript[QuEST`Gate`Rx, $CellContext`n1][Rational[3, 2] Pi], 
    Subscript[QuEST`Gate`Rx, $CellContext`n2][Rational[3, 4] Pi], 
    Subscript[QuEST`Gate`Rz, $CellContext`n1][Rational[5, 2] Pi], 
    Subscript[C, $CellContext`c][
     Subscript[QuEST`Gate`Rz, $CellContext`n2][Pi]], 
    Subscript[QuEST`Gate`Rx, $CellContext`n1][Pi], 
    Subscript[QuEST`Gate`Rx, $CellContext`n2][Rational[1, 4] Pi], 
    Subscript[C, $CellContext`n2][
     Subscript[QuEST`Gate`Rz, $CellContext`n1][Pi]], 
    Subscript[QuEST`Gate`Ry, $CellContext`n2][Rational[7, 2] Pi], 
    Subscript[QuEST`Gate`Rx, $CellContext`n1][Rational[1, 2] Pi], 
    Subscript[QuEST`Gate`Rx, $CellContext`c][$CellContext`n1], 
    Subscript[QuEST`Gate`Rz, $CellContext`n1][Rational[7, 2] Pi], 
    Subscript[QuEST`Gate`Rz, $CellContext`n2][Rational[1, 2] Pi], 
    Subscript[QuEST`Gate`Rz, $CellContext`c][Rational[3, 4] Pi]}, 
   "\nis the circuit correct:   ", True, "\n\n"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.831725854855904*^9, 3.8317258823995237`*^9}, 
   3.8317259314680758`*^9, 3.831726360219508*^9},
 CellLabel->
  "During evaluation of \
In[13]:=",ExpressionUUID->"8fb43ed2-1416-4582-97bb-2f0f67f2cd75"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Gate Type: \"\>", "\[InvisibleSpace]", "\<\"czUE\"\>", 
   "\[InvisibleSpace]", "\<\"\\n#2-qubit gates:  \"\>", "\[InvisibleSpace]", 
   "5", "\[InvisibleSpace]", "\<\"\\n#1-qubit gates:  \"\>", 
   "\[InvisibleSpace]", "5", 
   "\[InvisibleSpace]", "\<\"(-1) by removing the Z gate at the end\\n\"\>", 
   "\[InvisibleSpace]", 
   GraphicsBox[
    {EdgeForm[GrayLevel[0]], FaceForm[GrayLevel[
     1]], {{LineBox[{{0, 0.5}, {1, 0.5}}], LineBox[{{0, 1.5}, {1, 1.5}}], 
       LineBox[{{0, 2.5}, {1, 2.5}}]}, {LineBox[{{1, 0.5}, {2, 0.5}}], 
       LineBox[{{1, 1.5}, {2, 1.5}}], LineBox[{{1, 2.5}, {2, 2.5}}]}, {
       LineBox[{{2, 0.5}, {3, 0.5}}], LineBox[{{2, 1.5}, {3, 1.5}}], 
       LineBox[{{2, 2.5}, {3, 2.5}}]}, {LineBox[{{3, 0.5}, {4, 0.5}}], 
       LineBox[{{3, 1.5}, {4, 1.5}}], LineBox[{{3, 2.5}, {4, 2.5}}]}, {
       LineBox[{{4, 0.5}, {5, 0.5}}], LineBox[{{4, 1.5}, {5, 1.5}}], 
       LineBox[{{4, 2.5}, {5, 2.5}}]}, {LineBox[{{5, 0.5}, {6, 0.5}}], 
       LineBox[{{5, 1.5}, {6, 1.5}}], LineBox[{{5, 2.5}, {6, 2.5}}]}, {
       LineBox[{{6, 0.5}, {7, 0.5}}], LineBox[{{6, 1.5}, {7, 1.5}}], 
       LineBox[{{6, 2.5}, {7, 2.5}}]}, {LineBox[{{7, 0.5}, {8, 0.5}}], 
       LineBox[{{7, 1.5}, {8, 1.5}}], LineBox[{{7, 2.5}, {8, 2.5}}]}}, {{
       RectangleBox[{0.1, 0.1}, {0.9, 0.9}], 
       InsetBox["\<\"Ry\"\>", {0.5, 0.5}]}, {
       {FaceForm[GrayLevel[0]], DiskBox[{1.5, 1.5}, 0.1], 
        LineBox[{{1.5, 0.5}, {1.5, 1.5}}]}, {
        RectangleBox[{1.1, 0.1}, {1.9, 0.9}], 
        InsetBox["\<\"Rz\"\>", {1.5, 0.5}]}}, {
       {FaceForm[GrayLevel[0]], DiskBox[{2.5, 2.5}, 0.1], 
        LineBox[{{2.5, 0.5}, {2.5, 2.5}}]}, {
        RectangleBox[{2.1, 0.1}, {2.9, 0.9}], 
        InsetBox["\<\"Rz\"\>", {2.5, 0.5}]}}, {
       RectangleBox[{3.1, 1.1}, {3.9, 1.9}], 
       InsetBox["\<\"Rx\"\>", {3.5, 1.5}]}, {
       RectangleBox[{3.1, 0.1}, {3.9, 0.9}], 
       InsetBox["\<\"Rx\"\>", {3.5, 0.5}]}, {
       {FaceForm[GrayLevel[0]], DiskBox[{4.5, 1.5}, 0.1], 
        LineBox[{{4.5, 0.5}, {4.5, 1.5}}]}, {
        RectangleBox[{4.1, 0.1}, {4.9, 0.9}], 
        InsetBox["\<\"Rz\"\>", {4.5, 0.5}]}}, {
       RectangleBox[{5.1, 0.1}, {5.9, 0.9}], 
       InsetBox["\<\"Rx\"\>", {5.5, 0.5}]}, {
       {FaceForm[GrayLevel[0]], DiskBox[{5.5, 2.5}, 0.1], 
        LineBox[{{5.5, 1.5}, {5.5, 2.5}}]}, {
        RectangleBox[{5.1, 1.1}, {5.9, 1.9}], 
        InsetBox["\<\"Rz\"\>", {5.5, 1.5}]}}, {
       {FaceForm[GrayLevel[0]], DiskBox[{6.5, 2.5}, 0.1], 
        LineBox[{{6.5, 0.5}, {6.5, 2.5}}]}, {
        RectangleBox[{6.1, 0.1}, {6.9, 0.9}], 
        InsetBox["\<\"Rz\"\>", {6.5, 0.5}]}}, {
       RectangleBox[{7.1, 2.1}, {7.9, 2.9}], 
       InsetBox["\<\"Rz\"\>", {7.5, 2.5}]}}},
    ImageSize->{Automatic, 60},
    PlotRangePadding->None], "\[InvisibleSpace]", "\<\"\\n\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      SubscriptBox["Ry", "n1"], "[", 
      FractionBox["\[Pi]", "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["C", "n2"], "[", 
      RowBox[{
       SubscriptBox["Rz", "n1"], "[", 
       RowBox[{"-", "\[Pi]"}], "]"}], "]"}], ",", 
     RowBox[{
      SubscriptBox["C", "c"], "[", 
      RowBox[{
       SubscriptBox["Rz", "n1"], "[", "\[Pi]", "]"}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rx", "n1"], "[", 
      FractionBox[
       RowBox[{"3", " ", "\[Pi]"}], "4"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rx", "n2"], "[", 
      FractionBox[
       RowBox[{"5", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["C", "n2"], "[", 
      RowBox[{
       SubscriptBox["Rz", "n1"], "[", 
       RowBox[{"-", "\[Pi]"}], "]"}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rx", "n1"], "[", 
      FractionBox[
       RowBox[{"11", " ", "\[Pi]"}], "4"], "]"}], ",", 
     RowBox[{
      SubscriptBox["C", "c"], "[", 
      RowBox[{
       SubscriptBox["Rz", "n2"], "[", 
       FractionBox[
        RowBox[{"7", " ", "\[Pi]"}], "2"], "]"}], "]"}], ",", 
     RowBox[{
      SubscriptBox["C", "c"], "[", 
      RowBox[{
       SubscriptBox["Rz", "n1"], "[", 
       RowBox[{"-", "\[Pi]"}], "]"}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rz", "c"], "[", 
      FractionBox[
       RowBox[{"9", " ", "\[Pi]"}], "4"], "]"}]}], "}"}], 
   "\[InvisibleSpace]", "\<\"\\nis the circuit correct:   \"\>", 
   "\[InvisibleSpace]", "True", "\[InvisibleSpace]", "\<\"\\n\\n\"\>"}],
  SequenceForm[
  "Gate Type: ", "czUE", "\n#2-qubit gates:  ", 5, "\n#1-qubit gates:  ", 5, 
   "(-1) by removing the Z gate at the end\n", 
   Graphics[{
     FaceForm[
      GrayLevel[1]], 
     EdgeForm[
      GrayLevel[0]], {{
       Line[{{0, 0.5}, {1, 0.5}}], 
       Line[{{0, 1.5}, {1, 1.5}}], 
       Line[{{0, 2.5}, {1, 2.5}}]}, {
       Line[{{1, 0.5}, {2, 0.5}}], 
       Line[{{1, 1.5}, {2, 1.5}}], 
       Line[{{1, 2.5}, {2, 2.5}}]}, {
       Line[{{2, 0.5}, {3, 0.5}}], 
       Line[{{2, 1.5}, {3, 1.5}}], 
       Line[{{2, 2.5}, {3, 2.5}}]}, {
       Line[{{3, 0.5}, {4, 0.5}}], 
       Line[{{3, 1.5}, {4, 1.5}}], 
       Line[{{3, 2.5}, {4, 2.5}}]}, {
       Line[{{4, 0.5}, {5, 0.5}}], 
       Line[{{4, 1.5}, {5, 1.5}}], 
       Line[{{4, 2.5}, {5, 2.5}}]}, {
       Line[{{5, 0.5}, {6, 0.5}}], 
       Line[{{5, 1.5}, {6, 1.5}}], 
       Line[{{5, 2.5}, {6, 2.5}}]}, {
       Line[{{6, 0.5}, {7, 0.5}}], 
       Line[{{6, 1.5}, {7, 1.5}}], 
       Line[{{6, 2.5}, {7, 2.5}}]}, {
       Line[{{7, 0.5}, {8, 0.5}}], 
       Line[{{7, 1.5}, {8, 1.5}}], 
       Line[{{7, 2.5}, {8, 2.5}}]}}, {{
       Rectangle[{0.1, 0.1}, {0.9, 0.9}], 
       Text["Ry", {0.5, 0.5}]}, {{
        FaceForm[
         GrayLevel[0]], {
         Disk[{1.5, 1.5}, 0.1]}, 
        Line[{{1.5, 0.5}, {1.5, 1.5}}]}, {
        Rectangle[{1.1, 0.1}, {1.9, 0.9}], 
        Text["Rz", {1.5, 0.5}]}}, {{
        FaceForm[
         GrayLevel[0]], {
         Disk[{2.5, 2.5}, 0.1]}, 
        Line[{{2.5, 0.5}, {2.5, 2.5}}]}, {
        Rectangle[{2.1, 0.1}, {2.9, 0.9}], 
        Text["Rz", {2.5, 0.5}]}}, {
       Rectangle[{3.1, 1.1}, {3.9, 1.9}], 
       Text["Rx", {3.5, 1.5}]}, {
       Rectangle[{3.1, 0.1}, {3.9, 0.9}], 
       Text["Rx", {3.5, 0.5}]}, {{
        FaceForm[
         GrayLevel[0]], {
         Disk[{4.5, 1.5}, 0.1]}, 
        Line[{{4.5, 0.5}, {4.5, 1.5}}]}, {
        Rectangle[{4.1, 0.1}, {4.9, 0.9}], 
        Text["Rz", {4.5, 0.5}]}}, {
       Rectangle[{5.1, 0.1}, {5.9, 0.9}], 
       Text["Rx", {5.5, 0.5}]}, {{
        FaceForm[
         GrayLevel[0]], {
         Disk[{5.5, 2.5}, 0.1]}, 
        Line[{{5.5, 1.5}, {5.5, 2.5}}]}, {
        Rectangle[{5.1, 1.1}, {5.9, 1.9}], 
        Text["Rz", {5.5, 1.5}]}}, {{
        FaceForm[
         GrayLevel[0]], {
         Disk[{6.5, 2.5}, 0.1]}, 
        Line[{{6.5, 0.5}, {6.5, 2.5}}]}, {
        Rectangle[{6.1, 0.1}, {6.9, 0.9}], 
        Text["Rz", {6.5, 0.5}]}}, {
       Rectangle[{7.1, 2.1}, {7.9, 2.9}], 
       Text["Rz", {7.5, 2.5}]}}}, {ImageSize -> {Automatic, 60}}, ImageSize -> 
    270, PlotRangePadding -> None], "\n", {
    Subscript[QuEST`Gate`Ry, $CellContext`n1][Rational[1, 2] Pi], 
    Subscript[C, $CellContext`n2][
     Subscript[QuEST`Gate`Rz, $CellContext`n1][-Pi]], 
    Subscript[C, $CellContext`c][
     Subscript[QuEST`Gate`Rz, $CellContext`n1][Pi]], 
    Subscript[QuEST`Gate`Rx, $CellContext`n1][Rational[3, 4] Pi], 
    Subscript[QuEST`Gate`Rx, $CellContext`n2][Rational[5, 2] Pi], 
    Subscript[C, $CellContext`n2][
     Subscript[QuEST`Gate`Rz, $CellContext`n1][-Pi]], 
    Subscript[QuEST`Gate`Rx, $CellContext`n1][Rational[11, 4] Pi], 
    Subscript[C, $CellContext`c][
     Subscript[QuEST`Gate`Rz, $CellContext`n2][Rational[7, 2] Pi]], 
    Subscript[C, $CellContext`c][
     Subscript[QuEST`Gate`Rz, $CellContext`n1][-Pi]], 
    Subscript[QuEST`Gate`Rz, $CellContext`c][Rational[9, 4] Pi]}, 
   "\nis the circuit correct:   ", True, "\n\n"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.831725854855904*^9, 3.8317258823995237`*^9}, 
   3.8317259314680758`*^9, 3.8317263602461824`*^9},
 CellLabel->
  "During evaluation of \
In[13]:=",ExpressionUUID->"63b53b19-400f-4b73-b971-ff789dfd167d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Gate Type: \"\>", "\[InvisibleSpace]", "\<\"xxx\"\>", 
   "\[InvisibleSpace]", "\<\"\\n#2-qubit gates:  \"\>", "\[InvisibleSpace]", 
   "6", "\[InvisibleSpace]", "\<\"\\n#1-qubit gates:  \"\>", 
   "\[InvisibleSpace]", "11", 
   "\[InvisibleSpace]", "\<\"(-1) by removing the Z gate at the end\\n\"\>", 
   "\[InvisibleSpace]", 
   GraphicsBox[
    {EdgeForm[GrayLevel[0]], FaceForm[GrayLevel[
     1]], {{LineBox[{{0, 0.5}, {1, 0.5}}], LineBox[{{0, 1.5}, {1, 1.5}}], 
       LineBox[{{0, 2.5}, {1, 2.5}}]}, {LineBox[{{1, 0.5}, {2, 0.5}}], 
       LineBox[{{1, 1.5}, {2, 1.5}}], LineBox[{{1, 2.5}, {2, 2.5}}]}, {
       LineBox[{{2, 0.5}, {3, 0.5}}], LineBox[{{2, 1.5}, {3, 1.5}}], 
       LineBox[{{2, 2.5}, {3, 2.5}}]}, {LineBox[{{3, 0.5}, {4, 0.5}}], 
       LineBox[{{3, 1.5}, {4, 1.5}}], LineBox[{{3, 2.5}, {4, 2.5}}]}, {
       LineBox[{{4, 0.5}, {5, 0.5}}], LineBox[{{4, 1.5}, {5, 1.5}}], 
       LineBox[{{4, 2.5}, {5, 2.5}}]}, {LineBox[{{5, 0.5}, {6, 0.5}}], 
       LineBox[{{5, 1.5}, {6, 1.5}}], LineBox[{{5, 2.5}, {6, 2.5}}]}, {
       LineBox[{{6, 0.5}, {7, 0.5}}], LineBox[{{6, 1.5}, {7, 1.5}}], 
       LineBox[{{6, 2.5}, {7, 2.5}}]}, {LineBox[{{7, 0.5}, {8, 0.5}}], 
       LineBox[{{7, 1.5}, {8, 1.5}}], LineBox[{{7, 2.5}, {8, 2.5}}]}, {
       LineBox[{{8, 0.5}, {9, 0.5}}], LineBox[{{8, 1.5}, {9, 1.5}}], 
       LineBox[{{8, 2.5}, {9, 2.5}}]}, {LineBox[{{9, 0.5}, {10, 0.5}}], 
       LineBox[{{9, 1.5}, {10, 1.5}}], LineBox[{{9, 2.5}, {10, 2.5}}]}, {
       LineBox[{{10, 0.5}, {11, 0.5}}], LineBox[{{10, 1.5}, {11, 1.5}}], 
       LineBox[{{10, 2.5}, {11, 2.5}}]}}, {{
       RectangleBox[{0.1, 2.1}, {0.9, 2.9}], 
       InsetBox["\<\"Ry\"\>", {0.5, 2.5}]}, {
       LineBox[{{0.5, 0.5}, {0.5, 1.5}}], {
        RectangleBox[{0.1, 0.1}, {0.9, 0.9}], 
        InsetBox["\<\"Rx\"\>", {0.5, 0.5}]}, {
        RectangleBox[{0.1, 1.1}, {0.9, 1.9}], 
        InsetBox["\<\"Rx\"\>", {0.5, 1.5}]}}, {
       LineBox[{{1.5, 0.5}, {1.5, 2.5}}], {
        RectangleBox[{1.1, 0.1}, {1.9, 0.9}], 
        InsetBox["\<\"Rx\"\>", {1.5, 0.5}]}, {
        RectangleBox[{1.1, 1.1}, {1.9, 1.9}], 
        InsetBox["\<\"Rx\"\>", {1.5, 1.5}]}, {
        RectangleBox[{1.1, 2.1}, {1.9, 2.9}], 
        InsetBox["\<\"Rx\"\>", {1.5, 2.5}]}}, {
       RectangleBox[{2.1, 0.1}, {2.9, 0.9}], 
       InsetBox["\<\"Ry\"\>", {2.5, 0.5}]}, {
       RectangleBox[{2.1, 1.1}, {2.9, 1.9}], 
       InsetBox["\<\"Ry\"\>", {2.5, 1.5}]}, {
       LineBox[{{3.5, 0.5}, {3.5, 1.5}}], {
        RectangleBox[{3.1, 0.1}, {3.9, 0.9}], 
        InsetBox["\<\"Rx\"\>", {3.5, 0.5}]}, {
        RectangleBox[{3.1, 1.1}, {3.9, 1.9}], 
        InsetBox["\<\"Rx\"\>", {3.5, 1.5}]}}, {
       LineBox[{{4.5, 0.5}, {4.5, 2.5}}], {
        RectangleBox[{4.1, 0.1}, {4.9, 0.9}], 
        InsetBox["\<\"Rx\"\>", {4.5, 0.5}]}, {
        RectangleBox[{4.1, 1.1}, {4.9, 1.9}], 
        InsetBox["\<\"Rx\"\>", {4.5, 1.5}]}, {
        RectangleBox[{4.1, 2.1}, {4.9, 2.9}], 
        InsetBox["\<\"Rx\"\>", {4.5, 2.5}]}}, {
       RectangleBox[{5.1, 0.1}, {5.9, 0.9}], 
       InsetBox["\<\"Ry\"\>", {5.5, 0.5}]}, {
       RectangleBox[{5.1, 1.1}, {5.9, 1.9}], 
       InsetBox["\<\"Ry\"\>", {5.5, 1.5}]}, {
       RectangleBox[{6.1, 0.1}, {6.9, 0.9}], 
       InsetBox["\<\"Rz\"\>", {6.5, 0.5}]}, {
       RectangleBox[{6.1, 1.1}, {6.9, 1.9}], 
       InsetBox["\<\"Rz\"\>", {6.5, 1.5}]}, {
       LineBox[{{7.5, 0.5}, {7.5, 1.5}}], {
        RectangleBox[{7.1, 0.1}, {7.9, 0.9}], 
        InsetBox["\<\"Rx\"\>", {7.5, 0.5}]}, {
        RectangleBox[{7.1, 1.1}, {7.9, 1.9}], 
        InsetBox["\<\"Rx\"\>", {7.5, 1.5}]}}, {
       LineBox[{{8.5, 0.5}, {8.5, 2.5}}], {
        RectangleBox[{8.1, 0.1}, {8.9, 0.9}], 
        InsetBox["\<\"Rx\"\>", {8.5, 0.5}]}, {
        RectangleBox[{8.1, 1.1}, {8.9, 1.9}], 
        InsetBox["\<\"Rx\"\>", {8.5, 1.5}]}, {
        RectangleBox[{8.1, 2.1}, {8.9, 2.9}], 
        InsetBox["\<\"Rx\"\>", {8.5, 2.5}]}}, {
       RectangleBox[{9.1, 2.1}, {9.9, 2.9}], 
       InsetBox["\<\"Ry\"\>", {9.5, 2.5}]}, {
       RectangleBox[{9.1, 0.1}, {9.9, 0.9}], 
       InsetBox["\<\"Rz\"\>", {9.5, 0.5}]}, {
       RectangleBox[{9.1, 1.1}, {9.9, 1.9}], 
       InsetBox["\<\"Rz\"\>", {9.5, 1.5}]}, {
       RectangleBox[{10.1, 2.1}, {10.9, 2.9}], 
       InsetBox["\<\"Rz\"\>", {10.5, 2.5}]}}},
    ImageSize->{Automatic, 60},
    PlotRangePadding->None], "\[InvisibleSpace]", "\<\"\\n\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      SubscriptBox["Ry", "c"], "[", 
      FractionBox["\[Pi]", "2"], "]"}], ",", 
     RowBox[{"R", "[", 
      RowBox[{
       FractionBox[
        RowBox[{"11", " ", "\[Pi]"}], "4"], ",", 
       RowBox[{
        SubscriptBox["X", "n1"], " ", 
        SubscriptBox["X", "n2"]}]}], "]"}], ",", 
     RowBox[{"R", "[", 
      RowBox[{
       FractionBox["\[Pi]", "4"], ",", 
       RowBox[{
        SubscriptBox["X", "c"], " ", 
        SubscriptBox["X", "n1"], " ", 
        SubscriptBox["X", "n2"]}]}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Ry", "n1"], "[", 
      FractionBox[
       RowBox[{"3", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Ry", "n2"], "[", 
      FractionBox[
       RowBox[{"5", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{"R", "[", 
      RowBox[{
       FractionBox["\[Pi]", "4"], ",", 
       RowBox[{
        SubscriptBox["X", "n1"], " ", 
        SubscriptBox["X", "n2"]}]}], "]"}], ",", 
     RowBox[{"R", "[", 
      RowBox[{
       FractionBox[
        RowBox[{"3", " ", "\[Pi]"}], "4"], ",", 
       RowBox[{
        SubscriptBox["X", "c"], " ", 
        SubscriptBox["X", "n1"], " ", 
        SubscriptBox["X", "n2"]}]}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Ry", "n1"], "[", 
      FractionBox["\[Pi]", "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Ry", "n2"], "[", 
      FractionBox[
       RowBox[{"3", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rz", "n1"], "[", 
      FractionBox[
       RowBox[{"5", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rz", "n2"], "[", 
      FractionBox[
       RowBox[{"3", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{"R", "[", 
      RowBox[{
       FractionBox[
        RowBox[{"5", " ", "\[Pi]"}], "4"], ",", 
       RowBox[{
        SubscriptBox["X", "n1"], " ", 
        SubscriptBox["X", "n2"]}]}], "]"}], ",", 
     RowBox[{"R", "[", 
      RowBox[{
       FractionBox[
        RowBox[{"15", " ", "\[Pi]"}], "4"], ",", 
       RowBox[{
        SubscriptBox["X", "c"], " ", 
        SubscriptBox["X", "n1"], " ", 
        SubscriptBox["X", "n2"]}]}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Ry", "c"], "[", 
      FractionBox[
       RowBox[{"3", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rz", "n1"], "[", 
      FractionBox[
       RowBox[{"7", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rz", "n2"], "[", 
      FractionBox["\[Pi]", "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rz", "c"], "[", 
      FractionBox[
       RowBox[{"11", " ", "\[Pi]"}], "4"], "]"}]}], "}"}], 
   "\[InvisibleSpace]", "\<\"\\nis the circuit correct:   \"\>", 
   "\[InvisibleSpace]", "True", "\[InvisibleSpace]", "\<\"\\n\\n\"\>"}],
  SequenceForm[
  "Gate Type: ", "xxx", "\n#2-qubit gates:  ", 6, "\n#1-qubit gates:  ", 11, 
   "(-1) by removing the Z gate at the end\n", 
   Graphics[{
     FaceForm[
      GrayLevel[1]], 
     EdgeForm[
      GrayLevel[0]], {{
       Line[{{0, 0.5}, {1, 0.5}}], 
       Line[{{0, 1.5}, {1, 1.5}}], 
       Line[{{0, 2.5}, {1, 2.5}}]}, {
       Line[{{1, 0.5}, {2, 0.5}}], 
       Line[{{1, 1.5}, {2, 1.5}}], 
       Line[{{1, 2.5}, {2, 2.5}}]}, {
       Line[{{2, 0.5}, {3, 0.5}}], 
       Line[{{2, 1.5}, {3, 1.5}}], 
       Line[{{2, 2.5}, {3, 2.5}}]}, {
       Line[{{3, 0.5}, {4, 0.5}}], 
       Line[{{3, 1.5}, {4, 1.5}}], 
       Line[{{3, 2.5}, {4, 2.5}}]}, {
       Line[{{4, 0.5}, {5, 0.5}}], 
       Line[{{4, 1.5}, {5, 1.5}}], 
       Line[{{4, 2.5}, {5, 2.5}}]}, {
       Line[{{5, 0.5}, {6, 0.5}}], 
       Line[{{5, 1.5}, {6, 1.5}}], 
       Line[{{5, 2.5}, {6, 2.5}}]}, {
       Line[{{6, 0.5}, {7, 0.5}}], 
       Line[{{6, 1.5}, {7, 1.5}}], 
       Line[{{6, 2.5}, {7, 2.5}}]}, {
       Line[{{7, 0.5}, {8, 0.5}}], 
       Line[{{7, 1.5}, {8, 1.5}}], 
       Line[{{7, 2.5}, {8, 2.5}}]}, {
       Line[{{8, 0.5}, {9, 0.5}}], 
       Line[{{8, 1.5}, {9, 1.5}}], 
       Line[{{8, 2.5}, {9, 2.5}}]}, {
       Line[{{9, 0.5}, {10, 0.5}}], 
       Line[{{9, 1.5}, {10, 1.5}}], 
       Line[{{9, 2.5}, {10, 2.5}}]}, {
       Line[{{10, 0.5}, {11, 0.5}}], 
       Line[{{10, 1.5}, {11, 1.5}}], 
       Line[{{10, 2.5}, {11, 2.5}}]}}, {{
       Rectangle[{0.1, 2.1}, {0.9, 2.9}], 
       Text["Ry", {0.5, 2.5}]}, {
       Line[{{0.5, 0.5}, {0.5, 1.5}}], {
        Rectangle[{0.1, 0.1}, {0.9, 0.9}], 
        Text["Rx", {0.5, 0.5}]}, {
        Rectangle[{0.1, 1.1}, {0.9, 1.9}], 
        Text["Rx", {0.5, 1.5}]}}, {
       Line[{{1.5, 0.5}, {1.5, 2.5}}], {
        Rectangle[{1.1, 0.1}, {1.9, 0.9}], 
        Text["Rx", {1.5, 0.5}]}, {
        Rectangle[{1.1, 1.1}, {1.9, 1.9}], 
        Text["Rx", {1.5, 1.5}]}, {
        Rectangle[{1.1, 2.1}, {1.9, 2.9}], 
        Text["Rx", {1.5, 2.5}]}}, {
       Rectangle[{2.1, 0.1}, {2.9, 0.9}], 
       Text["Ry", {2.5, 0.5}]}, {
       Rectangle[{2.1, 1.1}, {2.9, 1.9}], 
       Text["Ry", {2.5, 1.5}]}, {
       Line[{{3.5, 0.5}, {3.5, 1.5}}], {
        Rectangle[{3.1, 0.1}, {3.9, 0.9}], 
        Text["Rx", {3.5, 0.5}]}, {
        Rectangle[{3.1, 1.1}, {3.9, 1.9}], 
        Text["Rx", {3.5, 1.5}]}}, {
       Line[{{4.5, 0.5}, {4.5, 2.5}}], {
        Rectangle[{4.1, 0.1}, {4.9, 0.9}], 
        Text["Rx", {4.5, 0.5}]}, {
        Rectangle[{4.1, 1.1}, {4.9, 1.9}], 
        Text["Rx", {4.5, 1.5}]}, {
        Rectangle[{4.1, 2.1}, {4.9, 2.9}], 
        Text["Rx", {4.5, 2.5}]}}, {
       Rectangle[{5.1, 0.1}, {5.9, 0.9}], 
       Text["Ry", {5.5, 0.5}]}, {
       Rectangle[{5.1, 1.1}, {5.9, 1.9}], 
       Text["Ry", {5.5, 1.5}]}, {
       Rectangle[{6.1, 0.1}, {6.9, 0.9}], 
       Text["Rz", {6.5, 0.5}]}, {
       Rectangle[{6.1, 1.1}, {6.9, 1.9}], 
       Text["Rz", {6.5, 1.5}]}, {
       Line[{{7.5, 0.5}, {7.5, 1.5}}], {
        Rectangle[{7.1, 0.1}, {7.9, 0.9}], 
        Text["Rx", {7.5, 0.5}]}, {
        Rectangle[{7.1, 1.1}, {7.9, 1.9}], 
        Text["Rx", {7.5, 1.5}]}}, {
       Line[{{8.5, 0.5}, {8.5, 2.5}}], {
        Rectangle[{8.1, 0.1}, {8.9, 0.9}], 
        Text["Rx", {8.5, 0.5}]}, {
        Rectangle[{8.1, 1.1}, {8.9, 1.9}], 
        Text["Rx", {8.5, 1.5}]}, {
        Rectangle[{8.1, 2.1}, {8.9, 2.9}], 
        Text["Rx", {8.5, 2.5}]}}, {
       Rectangle[{9.1, 2.1}, {9.9, 2.9}], 
       Text["Ry", {9.5, 2.5}]}, {
       Rectangle[{9.1, 0.1}, {9.9, 0.9}], 
       Text["Rz", {9.5, 0.5}]}, {
       Rectangle[{9.1, 1.1}, {9.9, 1.9}], 
       Text["Rz", {9.5, 1.5}]}, {
       Rectangle[{10.1, 2.1}, {10.9, 2.9}], 
       Text["Rz", {10.5, 2.5}]}}}, {ImageSize -> {Automatic, 60}}, ImageSize -> 
    360, PlotRangePadding -> None], "\n", {
    Subscript[QuEST`Gate`Ry, $CellContext`c][Rational[1, 2] Pi], 
    QuEST`Gate`R[
    Rational[11, 4] Pi, Subscript[QuEST`Gate`X, $CellContext`n1] 
     Subscript[QuEST`Gate`X, $CellContext`n2]], 
    QuEST`Gate`R[
    Rational[1, 4] Pi, Subscript[QuEST`Gate`X, $CellContext`c] 
     Subscript[QuEST`Gate`X, $CellContext`n1] 
     Subscript[QuEST`Gate`X, $CellContext`n2]], 
    Subscript[QuEST`Gate`Ry, $CellContext`n1][Rational[3, 2] Pi], 
    Subscript[QuEST`Gate`Ry, $CellContext`n2][Rational[5, 2] Pi], 
    QuEST`Gate`R[
    Rational[1, 4] Pi, Subscript[QuEST`Gate`X, $CellContext`n1] 
     Subscript[QuEST`Gate`X, $CellContext`n2]], 
    QuEST`Gate`R[
    Rational[3, 4] Pi, Subscript[QuEST`Gate`X, $CellContext`c] 
     Subscript[QuEST`Gate`X, $CellContext`n1] 
     Subscript[QuEST`Gate`X, $CellContext`n2]], 
    Subscript[QuEST`Gate`Ry, $CellContext`n1][Rational[1, 2] Pi], 
    Subscript[QuEST`Gate`Ry, $CellContext`n2][Rational[3, 2] Pi], 
    Subscript[QuEST`Gate`Rz, $CellContext`n1][Rational[5, 2] Pi], 
    Subscript[QuEST`Gate`Rz, $CellContext`n2][Rational[3, 2] Pi], 
    QuEST`Gate`R[
    Rational[5, 4] Pi, Subscript[QuEST`Gate`X, $CellContext`n1] 
     Subscript[QuEST`Gate`X, $CellContext`n2]], 
    QuEST`Gate`R[
    Rational[15, 4] Pi, Subscript[QuEST`Gate`X, $CellContext`c] 
     Subscript[QuEST`Gate`X, $CellContext`n1] 
     Subscript[QuEST`Gate`X, $CellContext`n2]], 
    Subscript[QuEST`Gate`Ry, $CellContext`c][Rational[3, 2] Pi], 
    Subscript[QuEST`Gate`Rz, $CellContext`n1][Rational[7, 2] Pi], 
    Subscript[QuEST`Gate`Rz, $CellContext`n2][Rational[1, 2] Pi], 
    Subscript[QuEST`Gate`Rz, $CellContext`c][Rational[11, 4] Pi]}, 
   "\nis the circuit correct:   ", True, "\n\n"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.831725854855904*^9, 3.8317258823995237`*^9}, 
   3.8317259314680758`*^9, 3.8317263602731237`*^9},
 CellLabel->
  "During evaluation of \
In[13]:=",ExpressionUUID->"2ec01d45-2335-4e53-83d7-ad5514364d08"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Gate Type: \"\>", "\[InvisibleSpace]", "\<\"xxxUE\"\>", 
   "\[InvisibleSpace]", "\<\"\\n#2-qubit gates:  \"\>", "\[InvisibleSpace]", 
   "3", "\[InvisibleSpace]", "\<\"\\n#1-qubit gates:  \"\>", 
   "\[InvisibleSpace]", "7", 
   "\[InvisibleSpace]", "\<\"(-1) by removing the Z gate at the end\\n\"\>", 
   "\[InvisibleSpace]", 
   GraphicsBox[
    {EdgeForm[GrayLevel[0]], FaceForm[GrayLevel[
     1]], {{LineBox[{{0, 0.5}, {1, 0.5}}], LineBox[{{0, 1.5}, {1, 1.5}}], 
       LineBox[{{0, 2.5}, {1, 2.5}}]}, {LineBox[{{1, 0.5}, {2, 0.5}}], 
       LineBox[{{1, 1.5}, {2, 1.5}}], LineBox[{{1, 2.5}, {2, 2.5}}]}, {
       LineBox[{{2, 0.5}, {3, 0.5}}], LineBox[{{2, 1.5}, {3, 1.5}}], 
       LineBox[{{2, 2.5}, {3, 2.5}}]}, {LineBox[{{3, 0.5}, {4, 0.5}}], 
       LineBox[{{3, 1.5}, {4, 1.5}}], LineBox[{{3, 2.5}, {4, 2.5}}]}, {
       LineBox[{{4, 0.5}, {5, 0.5}}], LineBox[{{4, 1.5}, {5, 1.5}}], 
       LineBox[{{4, 2.5}, {5, 2.5}}]}, {LineBox[{{5, 0.5}, {6, 0.5}}], 
       LineBox[{{5, 1.5}, {6, 1.5}}], LineBox[{{5, 2.5}, {6, 2.5}}]}, {
       LineBox[{{6, 0.5}, {7, 0.5}}], LineBox[{{6, 1.5}, {7, 1.5}}], 
       LineBox[{{6, 2.5}, {7, 2.5}}]}, {LineBox[{{7, 0.5}, {8, 0.5}}], 
       LineBox[{{7, 1.5}, {8, 1.5}}], LineBox[{{7, 2.5}, {8, 2.5}}]}}, {{
       RectangleBox[{0.1, 2.1}, {0.9, 2.9}], 
       InsetBox["\<\"Ry\"\>", {0.5, 2.5}]}, {
       LineBox[{{1.5, 0.5}, {1.5, 2.5}}], {
        RectangleBox[{1.1, 0.1}, {1.9, 0.9}], 
        InsetBox["\<\"Rx\"\>", {1.5, 0.5}]}, {
        RectangleBox[{1.1, 1.1}, {1.9, 1.9}], 
        InsetBox["\<\"Rx\"\>", {1.5, 1.5}]}, {
        RectangleBox[{1.1, 2.1}, {1.9, 2.9}], 
        InsetBox["\<\"Rx\"\>", {1.5, 2.5}]}}, {
       RectangleBox[{2.1, 0.1}, {2.9, 0.9}], 
       InsetBox["\<\"Ry\"\>", {2.5, 0.5}]}, {
       RectangleBox[{2.1, 1.1}, {2.9, 1.9}], 
       InsetBox["\<\"Ry\"\>", {2.5, 1.5}]}, {
       LineBox[{{3.5, 0.5}, {3.5, 2.5}}], {
        RectangleBox[{3.1, 0.1}, {3.9, 0.9}], 
        InsetBox["\<\"Rx\"\>", {3.5, 0.5}]}, {
        RectangleBox[{3.1, 1.1}, {3.9, 1.9}], 
        InsetBox["\<\"Rx\"\>", {3.5, 1.5}]}, {
        RectangleBox[{3.1, 2.1}, {3.9, 2.9}], 
        InsetBox["\<\"Rx\"\>", {3.5, 2.5}]}}, {
       RectangleBox[{4.1, 0.1}, {4.9, 0.9}], 
       InsetBox["\<\"Rz\"\>", {4.5, 0.5}]}, {
       RectangleBox[{4.1, 1.1}, {4.9, 1.9}], 
       InsetBox["\<\"Rz\"\>", {4.5, 1.5}]}, {
       LineBox[{{5.5, 0.5}, {5.5, 2.5}}], {
        RectangleBox[{5.1, 0.1}, {5.9, 0.9}], 
        InsetBox["\<\"Rx\"\>", {5.5, 0.5}]}, {
        RectangleBox[{5.1, 1.1}, {5.9, 1.9}], 
        InsetBox["\<\"Rx\"\>", {5.5, 1.5}]}, {
        RectangleBox[{5.1, 2.1}, {5.9, 2.9}], 
        InsetBox["\<\"Rx\"\>", {5.5, 2.5}]}}, {
       RectangleBox[{6.1, 2.1}, {6.9, 2.9}], 
       InsetBox["\<\"Ry\"\>", {6.5, 2.5}]}, {
       RectangleBox[{7.1, 2.1}, {7.9, 2.9}], 
       InsetBox["\<\"Rz\"\>", {7.5, 2.5}]}}},
    ImageSize->{Automatic, 60},
    PlotRangePadding->None], "\[InvisibleSpace]", "\<\"\\n\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      SubscriptBox["Ry", "c"], "[", 
      FractionBox["\[Pi]", "2"], "]"}], ",", 
     RowBox[{"R", "[", 
      RowBox[{
       FractionBox[
        RowBox[{"3", " ", "\[Pi]"}], "4"], ",", 
       RowBox[{
        SubscriptBox["X", "c"], " ", 
        SubscriptBox["X", "n1"], " ", 
        SubscriptBox["X", "n2"]}]}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Ry", "n1"], "[", 
      FractionBox["\[Pi]", "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Ry", "n2"], "[", 
      FractionBox[
       RowBox[{"7", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{"R", "[", 
      RowBox[{
       FractionBox[
        RowBox[{"13", " ", "\[Pi]"}], "4"], ",", 
       RowBox[{
        SubscriptBox["X", "c"], " ", 
        SubscriptBox["X", "n1"], " ", 
        SubscriptBox["X", "n2"]}]}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rz", "n1"], "[", 
      FractionBox[
       RowBox[{"5", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rz", "n2"], "[", 
      FractionBox["\[Pi]", "2"], "]"}], ",", 
     RowBox[{"R", "[", 
      RowBox[{
       FractionBox[
        RowBox[{"11", " ", "\[Pi]"}], "4"], ",", 
       RowBox[{
        SubscriptBox["X", "c"], " ", 
        SubscriptBox["X", "n1"], " ", 
        SubscriptBox["X", "n2"]}]}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Ry", "c"], "[", 
      FractionBox[
       RowBox[{"3", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rz", "c"], "[", 
      FractionBox[
       RowBox[{"13", " ", "\[Pi]"}], "4"], "]"}]}], "}"}], 
   "\[InvisibleSpace]", "\<\"\\nis the circuit correct:   \"\>", 
   "\[InvisibleSpace]", "True", "\[InvisibleSpace]", "\<\"\\n\\n\"\>"}],
  SequenceForm[
  "Gate Type: ", "xxxUE", "\n#2-qubit gates:  ", 3, "\n#1-qubit gates:  ", 7, 
   "(-1) by removing the Z gate at the end\n", 
   Graphics[{
     FaceForm[
      GrayLevel[1]], 
     EdgeForm[
      GrayLevel[0]], {{
       Line[{{0, 0.5}, {1, 0.5}}], 
       Line[{{0, 1.5}, {1, 1.5}}], 
       Line[{{0, 2.5}, {1, 2.5}}]}, {
       Line[{{1, 0.5}, {2, 0.5}}], 
       Line[{{1, 1.5}, {2, 1.5}}], 
       Line[{{1, 2.5}, {2, 2.5}}]}, {
       Line[{{2, 0.5}, {3, 0.5}}], 
       Line[{{2, 1.5}, {3, 1.5}}], 
       Line[{{2, 2.5}, {3, 2.5}}]}, {
       Line[{{3, 0.5}, {4, 0.5}}], 
       Line[{{3, 1.5}, {4, 1.5}}], 
       Line[{{3, 2.5}, {4, 2.5}}]}, {
       Line[{{4, 0.5}, {5, 0.5}}], 
       Line[{{4, 1.5}, {5, 1.5}}], 
       Line[{{4, 2.5}, {5, 2.5}}]}, {
       Line[{{5, 0.5}, {6, 0.5}}], 
       Line[{{5, 1.5}, {6, 1.5}}], 
       Line[{{5, 2.5}, {6, 2.5}}]}, {
       Line[{{6, 0.5}, {7, 0.5}}], 
       Line[{{6, 1.5}, {7, 1.5}}], 
       Line[{{6, 2.5}, {7, 2.5}}]}, {
       Line[{{7, 0.5}, {8, 0.5}}], 
       Line[{{7, 1.5}, {8, 1.5}}], 
       Line[{{7, 2.5}, {8, 2.5}}]}}, {{
       Rectangle[{0.1, 2.1}, {0.9, 2.9}], 
       Text["Ry", {0.5, 2.5}]}, {
       Line[{{1.5, 0.5}, {1.5, 2.5}}], {
        Rectangle[{1.1, 0.1}, {1.9, 0.9}], 
        Text["Rx", {1.5, 0.5}]}, {
        Rectangle[{1.1, 1.1}, {1.9, 1.9}], 
        Text["Rx", {1.5, 1.5}]}, {
        Rectangle[{1.1, 2.1}, {1.9, 2.9}], 
        Text["Rx", {1.5, 2.5}]}}, {
       Rectangle[{2.1, 0.1}, {2.9, 0.9}], 
       Text["Ry", {2.5, 0.5}]}, {
       Rectangle[{2.1, 1.1}, {2.9, 1.9}], 
       Text["Ry", {2.5, 1.5}]}, {
       Line[{{3.5, 0.5}, {3.5, 2.5}}], {
        Rectangle[{3.1, 0.1}, {3.9, 0.9}], 
        Text["Rx", {3.5, 0.5}]}, {
        Rectangle[{3.1, 1.1}, {3.9, 1.9}], 
        Text["Rx", {3.5, 1.5}]}, {
        Rectangle[{3.1, 2.1}, {3.9, 2.9}], 
        Text["Rx", {3.5, 2.5}]}}, {
       Rectangle[{4.1, 0.1}, {4.9, 0.9}], 
       Text["Rz", {4.5, 0.5}]}, {
       Rectangle[{4.1, 1.1}, {4.9, 1.9}], 
       Text["Rz", {4.5, 1.5}]}, {
       Line[{{5.5, 0.5}, {5.5, 2.5}}], {
        Rectangle[{5.1, 0.1}, {5.9, 0.9}], 
        Text["Rx", {5.5, 0.5}]}, {
        Rectangle[{5.1, 1.1}, {5.9, 1.9}], 
        Text["Rx", {5.5, 1.5}]}, {
        Rectangle[{5.1, 2.1}, {5.9, 2.9}], 
        Text["Rx", {5.5, 2.5}]}}, {
       Rectangle[{6.1, 2.1}, {6.9, 2.9}], 
       Text["Ry", {6.5, 2.5}]}, {
       Rectangle[{7.1, 2.1}, {7.9, 2.9}], 
       Text["Rz", {7.5, 2.5}]}}}, {ImageSize -> {Automatic, 60}}, ImageSize -> 
    270, PlotRangePadding -> None], "\n", {
    Subscript[QuEST`Gate`Ry, $CellContext`c][Rational[1, 2] Pi], 
    QuEST`Gate`R[
    Rational[3, 4] Pi, Subscript[QuEST`Gate`X, $CellContext`c] 
     Subscript[QuEST`Gate`X, $CellContext`n1] 
     Subscript[QuEST`Gate`X, $CellContext`n2]], 
    Subscript[QuEST`Gate`Ry, $CellContext`n1][Rational[1, 2] Pi], 
    Subscript[QuEST`Gate`Ry, $CellContext`n2][Rational[7, 2] Pi], 
    QuEST`Gate`R[
    Rational[13, 4] Pi, Subscript[QuEST`Gate`X, $CellContext`c] 
     Subscript[QuEST`Gate`X, $CellContext`n1] 
     Subscript[QuEST`Gate`X, $CellContext`n2]], 
    Subscript[QuEST`Gate`Rz, $CellContext`n1][Rational[5, 2] Pi], 
    Subscript[QuEST`Gate`Rz, $CellContext`n2][Rational[1, 2] Pi], 
    QuEST`Gate`R[
    Rational[11, 4] Pi, Subscript[QuEST`Gate`X, $CellContext`c] 
     Subscript[QuEST`Gate`X, $CellContext`n1] 
     Subscript[QuEST`Gate`X, $CellContext`n2]], 
    Subscript[QuEST`Gate`Ry, $CellContext`c][Rational[3, 2] Pi], 
    Subscript[QuEST`Gate`Rz, $CellContext`c][Rational[13, 4] Pi]}, 
   "\nis the circuit correct:   ", True, "\n\n"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.831725854855904*^9, 3.8317258823995237`*^9}, 
   3.8317259314680758`*^9, 3.8317263602980556`*^9},
 CellLabel->
  "During evaluation of \
In[13]:=",ExpressionUUID->"8c174d10-53d8-46e8-a36f-b44c96524b50"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Gate Type: \"\>", "\[InvisibleSpace]", "\<\"ccphase\"\>", 
   "\[InvisibleSpace]", "\<\"\\n#2-qubit gates:  \"\>", "\[InvisibleSpace]", 
   "3", "\[InvisibleSpace]", "\<\"\\n#1-qubit gates:  \"\>", 
   "\[InvisibleSpace]", "6", 
   "\[InvisibleSpace]", "\<\"(-1) by removing the Z gate at the end\\n\"\>", 
   "\[InvisibleSpace]", 
   GraphicsBox[
    {EdgeForm[GrayLevel[0]], FaceForm[GrayLevel[
     1]], {{LineBox[{{0, 0.5}, {1, 0.5}}], LineBox[{{0, 1.5}, {1, 1.5}}], 
       LineBox[{{0, 2.5}, {1, 2.5}}]}, {LineBox[{{1, 0.5}, {2, 0.5}}], 
       LineBox[{{1, 1.5}, {2, 1.5}}], LineBox[{{1, 2.5}, {2, 2.5}}]}, {
       LineBox[{{2, 0.5}, {3, 0.5}}], LineBox[{{2, 1.5}, {3, 1.5}}], 
       LineBox[{{2, 2.5}, {3, 2.5}}]}, {LineBox[{{3, 0.5}, {4, 0.5}}], 
       LineBox[{{3, 1.5}, {4, 1.5}}], LineBox[{{3, 2.5}, {4, 2.5}}]}, {
       LineBox[{{4, 0.5}, {5, 0.5}}], LineBox[{{4, 1.5}, {5, 1.5}}], 
       LineBox[{{4, 2.5}, {5, 2.5}}]}, {LineBox[{{5, 0.5}, {6, 0.5}}], 
       LineBox[{{5, 1.5}, {6, 1.5}}], LineBox[{{5, 2.5}, {6, 2.5}}]}, {
       LineBox[{{6, 0.5}, {7, 0.5}}], LineBox[{{6, 1.5}, {7, 1.5}}], 
       LineBox[{{6, 2.5}, {7, 2.5}}]}}, {{
       RectangleBox[{0.1, 1.1}, {0.9, 1.9}], 
       InsetBox["\<\"Rx\"\>", {0.5, 1.5}]}, {
       {FaceForm[GrayLevel[0]], DiskBox[{1.5, 1.5}, 0.1], 
        LineBox[{{1.5, 0.5}, {1.5, 1.5}}]}, {
        RectangleBox[{1.1, 0.1}, {1.9, 0.9}], 
        InsetBox["\<\"Rz\"\>", {1.5, 0.5}]}}, {
       RectangleBox[{2.1, 1.1}, {2.9, 1.9}], 
       InsetBox["\<\"Ry\"\>", {2.5, 1.5}]}, {
       RectangleBox[{2.1, 0.1}, {2.9, 0.9}], 
       InsetBox["\<\"Rx\"\>", {2.5, 0.5}]}, {
       {FaceForm[GrayLevel[
        0]], {DiskBox[{3.5, 2.5}, 0.1], DiskBox[{3.5, 0.5}, 0.1], 
         DiskBox[{3.5, 1.5}, 0.1]}, LineBox[{{3.5, 0.5}, {3.5, 2.5}}]}, 
       LineBox[{{3.5, 0.5}, {3.5, 2.5}}]}, {
       RectangleBox[{4.1, 1.1}, {4.9, 1.9}], 
       InsetBox["\<\"Ry\"\>", {4.5, 1.5}]}, {
       RectangleBox[{4.1, 0.1}, {4.9, 0.9}], 
       InsetBox["\<\"Rx\"\>", {4.5, 0.5}]}, {
       {FaceForm[GrayLevel[0]], DiskBox[{5.5, 1.5}, 0.1], 
        LineBox[{{5.5, 0.5}, {5.5, 1.5}}]}, {
        RectangleBox[{5.1, 0.1}, {5.9, 0.9}], 
        InsetBox["\<\"Rz\"\>", {5.5, 0.5}]}}, {
       RectangleBox[{6.1, 1.1}, {6.9, 1.9}], 
       InsetBox["\<\"Rx\"\>", {6.5, 1.5}]}}},
    ImageSize->{Automatic, 60},
    PlotRangePadding->None], "\[InvisibleSpace]", "\<\"\\n\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      SubscriptBox["Rx", "n2"], "[", 
      FractionBox[
       RowBox[{"5", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["C", "n2"], "[", 
      RowBox[{
       SubscriptBox["Rz", "n1"], "[", "\[Pi]", "]"}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Ry", "n2"], "[", 
      FractionBox["\[Pi]", "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rx", "n1"], "[", 
      FractionBox["\[Pi]", "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["CCPhase", 
       RowBox[{"c", ",", "n1", ",", "n2"}]], "[", 
      RowBox[{"2", " ", "\[Pi]"}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Ry", "n2"], "[", 
      FractionBox[
       RowBox[{"7", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rx", "n1"], "[", 
      FractionBox[
       RowBox[{"7", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["C", "n2"], "[", 
      RowBox[{
       SubscriptBox["Rz", "n1"], "[", 
       RowBox[{"3", " ", "\[Pi]"}], "]"}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rx", "n2"], "[", 
      FractionBox[
       RowBox[{"3", " ", "\[Pi]"}], "2"], "]"}]}], "}"}], 
   "\[InvisibleSpace]", "\<\"\\nis the circuit correct:   \"\>", 
   "\[InvisibleSpace]", "True", "\[InvisibleSpace]", "\<\"\\n\\n\"\>"}],
  SequenceForm[
  "Gate Type: ", "ccphase", "\n#2-qubit gates:  ", 3, "\n#1-qubit gates:  ", 
   6, "(-1) by removing the Z gate at the end\n", 
   Graphics[{
     FaceForm[
      GrayLevel[1]], 
     EdgeForm[
      GrayLevel[0]], {{
       Line[{{0, 0.5}, {1, 0.5}}], 
       Line[{{0, 1.5}, {1, 1.5}}], 
       Line[{{0, 2.5}, {1, 2.5}}]}, {
       Line[{{1, 0.5}, {2, 0.5}}], 
       Line[{{1, 1.5}, {2, 1.5}}], 
       Line[{{1, 2.5}, {2, 2.5}}]}, {
       Line[{{2, 0.5}, {3, 0.5}}], 
       Line[{{2, 1.5}, {3, 1.5}}], 
       Line[{{2, 2.5}, {3, 2.5}}]}, {
       Line[{{3, 0.5}, {4, 0.5}}], 
       Line[{{3, 1.5}, {4, 1.5}}], 
       Line[{{3, 2.5}, {4, 2.5}}]}, {
       Line[{{4, 0.5}, {5, 0.5}}], 
       Line[{{4, 1.5}, {5, 1.5}}], 
       Line[{{4, 2.5}, {5, 2.5}}]}, {
       Line[{{5, 0.5}, {6, 0.5}}], 
       Line[{{5, 1.5}, {6, 1.5}}], 
       Line[{{5, 2.5}, {6, 2.5}}]}, {
       Line[{{6, 0.5}, {7, 0.5}}], 
       Line[{{6, 1.5}, {7, 1.5}}], 
       Line[{{6, 2.5}, {7, 2.5}}]}}, {{
       Rectangle[{0.1, 1.1}, {0.9, 1.9}], 
       Text["Rx", {0.5, 1.5}]}, {{
        FaceForm[
         GrayLevel[0]], {
         Disk[{1.5, 1.5}, 0.1]}, 
        Line[{{1.5, 0.5}, {1.5, 1.5}}]}, {
        Rectangle[{1.1, 0.1}, {1.9, 0.9}], 
        Text["Rz", {1.5, 0.5}]}}, {
       Rectangle[{2.1, 1.1}, {2.9, 1.9}], 
       Text["Ry", {2.5, 1.5}]}, {
       Rectangle[{2.1, 0.1}, {2.9, 0.9}], 
       Text["Rx", {2.5, 0.5}]}, {{
        FaceForm[
         GrayLevel[0]], {
         Disk[{3.5, 2.5}, 0.1], 
         Disk[{3.5, 0.5}, 0.1], 
         Disk[{3.5, 1.5}, 0.1]}, 
        Line[{{3.5, 0.5}, {3.5, 2.5}}]}, 
       Line[{{3.5, 0.5}, {3.5, 2.5}}]}, {
       Rectangle[{4.1, 1.1}, {4.9, 1.9}], 
       Text["Ry", {4.5, 1.5}]}, {
       Rectangle[{4.1, 0.1}, {4.9, 0.9}], 
       Text["Rx", {4.5, 0.5}]}, {{
        FaceForm[
         GrayLevel[0]], {
         Disk[{5.5, 1.5}, 0.1]}, 
        Line[{{5.5, 0.5}, {5.5, 1.5}}]}, {
        Rectangle[{5.1, 0.1}, {5.9, 0.9}], 
        Text["Rz", {5.5, 0.5}]}}, {
       Rectangle[{6.1, 1.1}, {6.9, 1.9}], 
       Text["Rx", {6.5, 1.5}]}}}, {ImageSize -> {Automatic, 60}}, ImageSize -> 
    240, PlotRangePadding -> None], "\n", {
    Subscript[QuEST`Gate`Rx, $CellContext`n2][Rational[5, 2] Pi], 
    Subscript[C, $CellContext`n2][
     Subscript[QuEST`Gate`Rz, $CellContext`n1][Pi]], 
    Subscript[QuEST`Gate`Ry, $CellContext`n2][Rational[1, 2] Pi], 
    Subscript[QuEST`Gate`Rx, $CellContext`n1][Rational[1, 2] Pi], 
    Subscript[$CellContext`CCPhase, $CellContext`c, $CellContext`n1, \
$CellContext`n2][2 Pi], 
    Subscript[QuEST`Gate`Ry, $CellContext`n2][Rational[7, 2] Pi], 
    Subscript[QuEST`Gate`Rx, $CellContext`n1][Rational[7, 2] Pi], 
    Subscript[C, $CellContext`n2][
     Subscript[QuEST`Gate`Rz, $CellContext`n1][3 Pi]], 
    Subscript[QuEST`Gate`Rx, $CellContext`n2][Rational[3, 2] Pi]}, 
   "\nis the circuit correct:   ", True, "\n\n"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.831725854855904*^9, 3.8317258823995237`*^9}, 
   3.8317259314680758`*^9, 3.831726360319955*^9},
 CellLabel->
  "During evaluation of \
In[13]:=",ExpressionUUID->"d3cf821a-8ec9-4a2d-8d57-f044549deeb3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Gate Type: \"\>", "\[InvisibleSpace]", "\<\"ccphaseUE\"\>", 
   "\[InvisibleSpace]", "\<\"\\n#2-qubit gates:  \"\>", "\[InvisibleSpace]", 
   "2", "\[InvisibleSpace]", "\<\"\\n#1-qubit gates:  \"\>", 
   "\[InvisibleSpace]", "3", 
   "\[InvisibleSpace]", "\<\"(-1) by removing the Z gate at the end\\n\"\>", 
   "\[InvisibleSpace]", 
   GraphicsBox[
    {EdgeForm[GrayLevel[0]], FaceForm[GrayLevel[
     1]], {{LineBox[{{0, 0.5}, {1, 0.5}}], LineBox[{{0, 1.5}, {1, 1.5}}], 
       LineBox[{{0, 2.5}, {1, 2.5}}]}, {LineBox[{{1, 0.5}, {2, 0.5}}], 
       LineBox[{{1, 1.5}, {2, 1.5}}], LineBox[{{1, 2.5}, {2, 2.5}}]}, {
       LineBox[{{2, 0.5}, {3, 0.5}}], LineBox[{{2, 1.5}, {3, 1.5}}], 
       LineBox[{{2, 2.5}, {3, 2.5}}]}, {LineBox[{{3, 0.5}, {4, 0.5}}], 
       LineBox[{{3, 1.5}, {4, 1.5}}], LineBox[{{3, 2.5}, {4, 2.5}}]}}, {{
       RectangleBox[{0.1, 0.1}, {0.9, 0.9}], 
       InsetBox["\<\"Ry\"\>", {0.5, 0.5}]}, {
       {FaceForm[GrayLevel[0]], DiskBox[{1.5, 1.5}, 0.1], 
        LineBox[{{1.5, 0.5}, {1.5, 1.5}}]}, {
        RectangleBox[{1.1, 0.1}, {1.9, 0.9}], 
        InsetBox["\<\"Rz\"\>", {1.5, 0.5}]}}, {
       RectangleBox[{2.1, 0.1}, {2.9, 0.9}], 
       InsetBox["\<\"Ry\"\>", {2.5, 0.5}]}, {
       RectangleBox[{2.1, 1.1}, {2.9, 1.9}], 
       InsetBox["\<\"Rx\"\>", {2.5, 1.5}]}, {
       {FaceForm[GrayLevel[
        0]], {DiskBox[{3.5, 2.5}, 0.1], DiskBox[{3.5, 0.5}, 0.1], 
         DiskBox[{3.5, 1.5}, 0.1]}, LineBox[{{3.5, 0.5}, {3.5, 2.5}}]}, 
       LineBox[{{3.5, 0.5}, {3.5, 2.5}}]}}},
    ImageSize->{Automatic, 60},
    PlotRangePadding->None], "\[InvisibleSpace]", "\<\"\\n\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      SubscriptBox["Ry", "n1"], "[", 
      FractionBox[
       RowBox[{"7", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["C", "n2"], "[", 
      RowBox[{
       SubscriptBox["Rz", "n1"], "[", "\[Pi]", "]"}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Ry", "n1"], "[", 
      FractionBox[
       RowBox[{"5", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rx", "n2"], "[", 
      FractionBox[
       RowBox[{"7", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["CCPhase", 
       RowBox[{"c", ",", "n1", ",", "n2"}]], "[", 
      RowBox[{"2", " ", "\[Pi]"}], "]"}]}], "}"}], 
   "\[InvisibleSpace]", "\<\"\\nis the circuit correct:   \"\>", 
   "\[InvisibleSpace]", "True", "\[InvisibleSpace]", "\<\"\\n\\n\"\>"}],
  SequenceForm[
  "Gate Type: ", "ccphaseUE", "\n#2-qubit gates:  ", 2, "\n#1-qubit gates:  ",
    3, "(-1) by removing the Z gate at the end\n", 
   Graphics[{
     FaceForm[
      GrayLevel[1]], 
     EdgeForm[
      GrayLevel[0]], {{
       Line[{{0, 0.5}, {1, 0.5}}], 
       Line[{{0, 1.5}, {1, 1.5}}], 
       Line[{{0, 2.5}, {1, 2.5}}]}, {
       Line[{{1, 0.5}, {2, 0.5}}], 
       Line[{{1, 1.5}, {2, 1.5}}], 
       Line[{{1, 2.5}, {2, 2.5}}]}, {
       Line[{{2, 0.5}, {3, 0.5}}], 
       Line[{{2, 1.5}, {3, 1.5}}], 
       Line[{{2, 2.5}, {3, 2.5}}]}, {
       Line[{{3, 0.5}, {4, 0.5}}], 
       Line[{{3, 1.5}, {4, 1.5}}], 
       Line[{{3, 2.5}, {4, 2.5}}]}}, {{
       Rectangle[{0.1, 0.1}, {0.9, 0.9}], 
       Text["Ry", {0.5, 0.5}]}, {{
        FaceForm[
         GrayLevel[0]], {
         Disk[{1.5, 1.5}, 0.1]}, 
        Line[{{1.5, 0.5}, {1.5, 1.5}}]}, {
        Rectangle[{1.1, 0.1}, {1.9, 0.9}], 
        Text["Rz", {1.5, 0.5}]}}, {
       Rectangle[{2.1, 0.1}, {2.9, 0.9}], 
       Text["Ry", {2.5, 0.5}]}, {
       Rectangle[{2.1, 1.1}, {2.9, 1.9}], 
       Text["Rx", {2.5, 1.5}]}, {{
        FaceForm[
         GrayLevel[0]], {
         Disk[{3.5, 2.5}, 0.1], 
         Disk[{3.5, 0.5}, 0.1], 
         Disk[{3.5, 1.5}, 0.1]}, 
        Line[{{3.5, 0.5}, {3.5, 2.5}}]}, 
       Line[{{3.5, 0.5}, {3.5, 2.5}}]}}}, {ImageSize -> {Automatic, 60}}, 
    ImageSize -> 150, PlotRangePadding -> None], "\n", {
    Subscript[QuEST`Gate`Ry, $CellContext`n1][Rational[7, 2] Pi], 
    Subscript[C, $CellContext`n2][
     Subscript[QuEST`Gate`Rz, $CellContext`n1][Pi]], 
    Subscript[QuEST`Gate`Ry, $CellContext`n1][Rational[5, 2] Pi], 
    Subscript[QuEST`Gate`Rx, $CellContext`n2][Rational[7, 2] Pi], 
    Subscript[$CellContext`CCPhase, $CellContext`c, $CellContext`n1, \
$CellContext`n2][2 Pi]}, "\nis the circuit correct:   ", True, "\n\n"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.831725854855904*^9, 3.8317258823995237`*^9}, 
   3.8317259314680758`*^9, 3.8317263603339586`*^9},
 CellLabel->
  "During evaluation of \
In[13]:=",ExpressionUUID->"82a28189-178d-4e58-bcf4-d2446007f8df"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["1) Type C recompilations", "Section"]], \
"Subsubsection",
 CellChangeTimes->{{3.826872090791264*^9, 3.8268721137745934`*^9}, {
  3.826872162007494*^9, 3.826872162855002*^9}, {3.8268758156045923`*^9, 
  3.826875819318865*^9}, {3.8268761409065065`*^9, 3.8268761426449947`*^9}, {
  3.8268892945064564`*^9, 3.826889318494529*^9}, {3.82689704773733*^9, 
  3.826897048300024*^9}, {3.8317261453455906`*^9, 
  3.831726179096449*^9}},ExpressionUUID->"8ac7037a-eae3-4db4-a324-\
6983a1bfae70"],

Cell[TextData[{
 StyleBox["Type C recompilation: ",
  FontWeight->"Bold"],
 "the product of",
 StyleBox[" ",
  FontWeight->"Bold"],
 "the elementary controlled-SWAP gate and the controlled X observable was \
recompiled up to an SU(4) freedom on the two swapped qubits"
}], "Text",
 CellChangeTimes->{{3.8262650902861843`*^9, 3.826265091099492*^9}, {
  3.8262652312441196`*^9, 3.826265473334661*^9}, {3.8264936657315893`*^9, 
  3.826493710958598*^9}, {3.826493827200305*^9, 3.8264938282809477`*^9}, {
  3.8264939742007303`*^9, 3.82649405518382*^9}, {3.8272392140975666`*^9, 
  3.827239224966739*^9}, {3.827239268488271*^9, 3.8272392931488256`*^9}, {
  3.8317261941842413`*^9, 3.831726320350439*^9}},
 Background->RGBColor[
  0.88, 1, 0.88],ExpressionUUID->"1720caf5-c5a5-4546-9475-b8a63e9aa856"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[Rho]", "=", 
   RowBox[{"CreateDensityQureg", "[", "3", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gateCanDo", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<crxOBSX\>\"", ",", "\"\<xxOBSX\>\"", ",", "\"\<czOBSX\>\"", ",", 
     "\"\<ccphaseOBSX\>\"", ",", "\"\<pswapOBSX\>\"", ",", 
     "\"\<xxxOBSX\>\""}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dat", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"gateTyp", "=", 
      RowBox[{"gateCanDo", "[", 
       RowBox[{"[", "k", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"cSWAPCirc", "=", 
      RowBox[{"gate", "[", 
       RowBox[{"2", ",", "0", ",", "1", ",", "gateTyp"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"circ", "=", 
      RowBox[{
       RowBox[{"Flatten", "@", 
        RowBox[{"{", 
         RowBox[{
          SubscriptBox["H", "2"], ",", "cSWAPCirc", ",", 
          SubscriptBox["H", "2"]}], "}"}]}], "/.", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{
           SubscriptBox["pSWAP", 
            RowBox[{"n1_", ",", "n2_"}]], "[", 
           RowBox[{"p1_", ",", "p2_"}], "]"}], "\[RuleDelayed]", 
          RowBox[{
           SubscriptBox["U", 
            RowBox[{"n1", ",", "n2"}]], "[", 
           RowBox[{"pswap", "[", 
            RowBox[{"p1", ",", "p2"}], "]"}], "]"}]}], ",", 
         RowBox[{
          RowBox[{
           SubscriptBox["CCPhase", 
            RowBox[{"c_", ",", "n1_", ",", "n2_"}]], "[", "p1_", "]"}], 
          "\[RuleDelayed]", 
          RowBox[{
           SubscriptBox["U", 
            RowBox[{"c", ",", "n1", ",", "n2"}]], "[", 
           RowBox[{"ccphasemat", "[", "p1", "]"}], "]"}]}]}], "}"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"twoQubitGateCount", "=", 
      RowBox[{"Count", "[", 
       RowBox[{"cSWAPCirc", ",", 
        RowBox[{
         RowBox[{"R", "[", "__", "]"}], "|", 
         RowBox[{
          SubscriptBox["U", "__"], "[", "__", "]"}], "|", 
         RowBox[{
          SubscriptBox["C", "__"], "[", "__", "]"}], "|", 
         RowBox[{
          SubscriptBox["CCPhase", "__"], "[", "__", "]"}], "|", 
         RowBox[{
          SubscriptBox["pSWAP", "__"], "[", "__", "]"}]}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"rand", "=", 
      RowBox[{"With", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"r", "=", 
          RowBox[{"RandomComplex", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "1"}], "-", "\[ImaginaryI]"}], ",", 
              RowBox[{"1", "+", "\[ImaginaryI]"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}]}], "]"}]}], "}"}], ",", 
        "\[IndentingNewLine]", "\t", 
        RowBox[{
         RowBox[{"r", " ", ".", " ", 
          RowBox[{"r", "\[ConjugateTranspose]"}]}], " ", "/", " ", 
         RowBox[{"Tr", "[", 
          RowBox[{"r", " ", ".", " ", 
           RowBox[{"r", "\[ConjugateTranspose]"}]}], "]"}]}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"SetQuregMatrix", "[", 
      RowBox[{"\[Rho]", ",", 
       RowBox[{"KroneckerProduct", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "0"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "0"}], "}"}]}], "}"}], ",", 
         RowBox[{"KroneckerProduct", "[", 
          RowBox[{"rand", ",", "rand"}], "]"}]}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ApplyCircuit", "[", 
      RowBox[{"circ", ",", "\[Rho]"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"circPic", "=", 
      RowBox[{"DrawCircuit", "[", 
       RowBox[{
        RowBox[{"cSWAPCirc", "/.", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{
             SubscriptBox["CCPhase", 
              RowBox[{"c_", ",", "n1_", ",", "n2_"}]], "[", "__", "]"}], 
            "\[RuleDelayed]", 
            RowBox[{
             SubscriptBox["C", 
              RowBox[{"c", ",", "n1"}]], "[", 
             SubscriptBox["Z", "n2"], "]"}]}], ",", 
           RowBox[{
            RowBox[{
             SubscriptBox["pSWAP", 
              RowBox[{"n1_", ",", "n2_"}]], "[", "__", "]"}], 
            "\[RuleDelayed]", 
            SubscriptBox["pSW", 
             RowBox[{"n1", ",", "n2"}]]}]}], "}"}]}], ",", 
        RowBox[{"ImageSize", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Automatic", ",", "60"}], "}"}]}], ",", 
        RowBox[{"FontFamily", "\[Rule]", "\"\<Times New Roman\>\""}]}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"dat", ",", 
       RowBox[{"{", 
        RowBox[{"circPic", ",", "twoQubitGateCount", ",", 
         RowBox[{
          RowBox[{"Length", "@", "cSWAPCirc"}], "-", "twoQubitGateCount"}]}], 
        "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{
      "\"\<Gate Type: \>\"", ",", "gateTyp", ",", 
       "\"\<\\n#2-qubit gates:  \>\"", " ", ",", "twoQubitGateCount", ",", 
       "\"\<\\n#1-qubit gates:  \>\"", ",", 
       RowBox[{
        RowBox[{"Length", "@", "cSWAPCirc"}], "-", "twoQubitGateCount"}], 
       ",", "\"\<(-1) by removing the Z gate at the end\\n\>\"", ",", 
       "\[IndentingNewLine]", "circPic", "\[IndentingNewLine]", ",", 
       "\"\<\\n\>\"", ",", 
       RowBox[{"gate", "[", 
        RowBox[{"c", ",", "n1", ",", "n2", ",", "gateTyp"}], "]"}], ",", 
       "\[IndentingNewLine]", " ", "\"\<\\nis the circuit correct:   \>\"", 
       "\[IndentingNewLine]", ",", 
       RowBox[{
        RowBox[{"Chop", "[", 
         RowBox[{
          RowBox[{"2", 
           RowBox[{"CalcProbOfOutcome", "[", 
            RowBox[{"\[Rho]", ",", "2", ",", "0"}], "]"}]}], "-", "1", "-", 
          RowBox[{"Tr", "[", 
           RowBox[{"rand", ".", "rand", ".", 
            RowBox[{"PauliMatrix", "[", "1", "]"}]}], "]"}]}], "]"}], 
        "\[Equal]", "0"}], ",", "\"\<\\n\\n\>\""}], "\[IndentingNewLine]", 
      "]"}], ";"}], "\[IndentingNewLine]", ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", "1", ",", 
      RowBox[{"Length", "@", "gateCanDo"}]}], "}"}]}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DestroyAllQuregs", "[", "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.831725986792098*^9, 3.8317260114701524`*^9}},
 CellLabel->"In[18]:=",ExpressionUUID->"d7b6cc07-93d4-47d4-8049-59273a1a29e5"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Gate Type: \"\>", "\[InvisibleSpace]", "\<\"crxOBSX\"\>", 
   "\[InvisibleSpace]", "\<\"\\n#2-qubit gates:  \"\>", "\[InvisibleSpace]", 
   "4", "\[InvisibleSpace]", "\<\"\\n#1-qubit gates:  \"\>", 
   "\[InvisibleSpace]", "3", 
   "\[InvisibleSpace]", "\<\"(-1) by removing the Z gate at the end\\n\"\>", 
   "\[InvisibleSpace]", 
   GraphicsBox[
    {EdgeForm[GrayLevel[0]], FaceForm[GrayLevel[
     1]], {{LineBox[{{0, 0.5}, {1, 0.5}}], LineBox[{{0, 1.5}, {1, 1.5}}], 
       LineBox[{{0, 2.5}, {1, 2.5}}]}, {LineBox[{{1, 0.5}, {2, 0.5}}], 
       LineBox[{{1, 1.5}, {2, 1.5}}], LineBox[{{1, 2.5}, {2, 2.5}}]}, {
       LineBox[{{2, 0.5}, {3, 0.5}}], LineBox[{{2, 1.5}, {3, 1.5}}], 
       LineBox[{{2, 2.5}, {3, 2.5}}]}, {LineBox[{{3, 0.5}, {4, 0.5}}], 
       LineBox[{{3, 1.5}, {4, 1.5}}], LineBox[{{3, 2.5}, {4, 2.5}}]}, {
       LineBox[{{4, 0.5}, {5, 0.5}}], LineBox[{{4, 1.5}, {5, 1.5}}], 
       LineBox[{{4, 2.5}, {5, 2.5}}]}, {LineBox[{{5, 0.5}, {6, 0.5}}], 
       LineBox[{{5, 1.5}, {6, 1.5}}], LineBox[{{5, 2.5}, {6, 2.5}}]}}, {{
       {FaceForm[GrayLevel[0]], DiskBox[{0.5, 0.5}, 0.1], 
        LineBox[{{0.5, 0.5}, {0.5, 1.5}}]}, {
        RectangleBox[{0.1, 1.1}, {0.9, 1.9}], 
        InsetBox["\<\"Rx\"\>", {0.5, 1.5}]}}, {
       RectangleBox[{1.1, 0.1}, {1.9, 0.9}], 
       InsetBox["\<\"Rz\"\>", {1.5, 0.5}]}, {
       RectangleBox[{1.1, 1.1}, {1.9, 1.9}], 
       InsetBox["\<\"Rz\"\>", {1.5, 1.5}]}, {
       {FaceForm[GrayLevel[0]], DiskBox[{2.5, 1.5}, 0.1], 
        LineBox[{{2.5, 0.5}, {2.5, 1.5}}]}, {
        RectangleBox[{2.1, 0.1}, {2.9, 0.9}], 
        InsetBox["\<\"Rx\"\>", {2.5, 0.5}]}}, {
       {FaceForm[GrayLevel[0]], DiskBox[{3.5, 2.5}, 0.1], 
        LineBox[{{3.5, 1.5}, {3.5, 2.5}}]}, {
        RectangleBox[{3.1, 1.1}, {3.9, 1.9}], 
        InsetBox["\<\"Rx\"\>", {3.5, 1.5}]}}, {
       {FaceForm[GrayLevel[0]], DiskBox[{4.5, 2.5}, 0.1], 
        LineBox[{{4.5, 0.5}, {4.5, 2.5}}]}, {
        RectangleBox[{4.1, 0.1}, {4.9, 0.9}], 
        InsetBox["\<\"Rx\"\>", {4.5, 0.5}]}}, {
       RectangleBox[{5.1, 2.1}, {5.9, 2.9}], 
       InsetBox["\<\"Rz\"\>", {5.5, 2.5}]}}},
    ImageSize->{Automatic, 60},
    PlotRangePadding->None], "\[InvisibleSpace]", "\<\"\\n\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      SubscriptBox["C", "n1"], "[", 
      RowBox[{
       SubscriptBox["Rx", "n2"], "[", "\[Pi]", "]"}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rz", "n1"], "[", 
      FractionBox[
       RowBox[{"5", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rz", "n2"], "[", 
      FractionBox[
       RowBox[{"15", " ", "\[Pi]"}], "4"], "]"}], ",", 
     RowBox[{
      SubscriptBox["C", "n2"], "[", 
      RowBox[{
       SubscriptBox["Rx", "n1"], "[", 
       FractionBox[
        RowBox[{"3", " ", "\[Pi]"}], "2"], "]"}], "]"}], ",", 
     RowBox[{
      SubscriptBox["C", "c"], "[", 
      RowBox[{
       SubscriptBox["Rx", "n2"], "[", "\[Pi]", "]"}], "]"}], ",", 
     RowBox[{
      SubscriptBox["C", "c"], "[", 
      RowBox[{
       SubscriptBox["Rx", "n1"], "[", 
       FractionBox["\[Pi]", "2"], "]"}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rz", "c"], "[", 
      RowBox[{"-", 
       FractionBox["\[Pi]", "4"]}], "]"}]}], "}"}], 
   "\[InvisibleSpace]", "\<\"\\nis the circuit correct:   \"\>", 
   "\[InvisibleSpace]", "True", "\[InvisibleSpace]", "\<\"\\n\\n\"\>"}],
  SequenceForm[
  "Gate Type: ", "crxOBSX", "\n#2-qubit gates:  ", 4, "\n#1-qubit gates:  ", 
   3, "(-1) by removing the Z gate at the end\n", 
   Graphics[{
     FaceForm[
      GrayLevel[1]], 
     EdgeForm[
      GrayLevel[0]], {{
       Line[{{0, 0.5}, {1, 0.5}}], 
       Line[{{0, 1.5}, {1, 1.5}}], 
       Line[{{0, 2.5}, {1, 2.5}}]}, {
       Line[{{1, 0.5}, {2, 0.5}}], 
       Line[{{1, 1.5}, {2, 1.5}}], 
       Line[{{1, 2.5}, {2, 2.5}}]}, {
       Line[{{2, 0.5}, {3, 0.5}}], 
       Line[{{2, 1.5}, {3, 1.5}}], 
       Line[{{2, 2.5}, {3, 2.5}}]}, {
       Line[{{3, 0.5}, {4, 0.5}}], 
       Line[{{3, 1.5}, {4, 1.5}}], 
       Line[{{3, 2.5}, {4, 2.5}}]}, {
       Line[{{4, 0.5}, {5, 0.5}}], 
       Line[{{4, 1.5}, {5, 1.5}}], 
       Line[{{4, 2.5}, {5, 2.5}}]}, {
       Line[{{5, 0.5}, {6, 0.5}}], 
       Line[{{5, 1.5}, {6, 1.5}}], 
       Line[{{5, 2.5}, {6, 2.5}}]}}, {{{
        FaceForm[
         GrayLevel[0]], {
         Disk[{0.5, 0.5}, 0.1]}, 
        Line[{{0.5, 0.5}, {0.5, 1.5}}]}, {
        Rectangle[{0.1, 1.1}, {0.9, 1.9}], 
        Text["Rx", {0.5, 1.5}]}}, {
       Rectangle[{1.1, 0.1}, {1.9, 0.9}], 
       Text["Rz", {1.5, 0.5}]}, {
       Rectangle[{1.1, 1.1}, {1.9, 1.9}], 
       Text["Rz", {1.5, 1.5}]}, {{
        FaceForm[
         GrayLevel[0]], {
         Disk[{2.5, 1.5}, 0.1]}, 
        Line[{{2.5, 0.5}, {2.5, 1.5}}]}, {
        Rectangle[{2.1, 0.1}, {2.9, 0.9}], 
        Text["Rx", {2.5, 0.5}]}}, {{
        FaceForm[
         GrayLevel[0]], {
         Disk[{3.5, 2.5}, 0.1]}, 
        Line[{{3.5, 1.5}, {3.5, 2.5}}]}, {
        Rectangle[{3.1, 1.1}, {3.9, 1.9}], 
        Text["Rx", {3.5, 1.5}]}}, {{
        FaceForm[
         GrayLevel[0]], {
         Disk[{4.5, 2.5}, 0.1]}, 
        Line[{{4.5, 0.5}, {4.5, 2.5}}]}, {
        Rectangle[{4.1, 0.1}, {4.9, 0.9}], 
        Text["Rx", {4.5, 0.5}]}}, {
       Rectangle[{5.1, 2.1}, {5.9, 2.9}], 
       Text["Rz", {5.5, 2.5}]}}}, {ImageSize -> {Automatic, 60}}, ImageSize -> 
    210, PlotRangePadding -> None], "\n", {
    Subscript[C, $CellContext`n1][
     Subscript[QuEST`Gate`Rx, $CellContext`n2][Pi]], 
    Subscript[QuEST`Gate`Rz, $CellContext`n1][Rational[5, 2] Pi], 
    Subscript[QuEST`Gate`Rz, $CellContext`n2][Rational[15, 4] Pi], 
    Subscript[C, $CellContext`n2][
     Subscript[QuEST`Gate`Rx, $CellContext`n1][Rational[3, 2] Pi]], 
    Subscript[C, $CellContext`c][
     Subscript[QuEST`Gate`Rx, $CellContext`n2][Pi]], 
    Subscript[C, $CellContext`c][
     Subscript[QuEST`Gate`Rx, $CellContext`n1][Rational[1, 2] Pi]], 
    Subscript[QuEST`Gate`Rz, $CellContext`c][Rational[-1, 4] Pi]}, 
   "\nis the circuit correct:   ", True, "\n\n"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.8317260055449686`*^9, 3.831726012244398*^9}, 
   3.8317263604200373`*^9},
 CellLabel->
  "During evaluation of \
In[18]:=",ExpressionUUID->"da2c2054-2fee-4da9-aaf3-7c663030bba5"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Gate Type: \"\>", "\[InvisibleSpace]", "\<\"xxOBSX\"\>", 
   "\[InvisibleSpace]", "\<\"\\n#2-qubit gates:  \"\>", "\[InvisibleSpace]", 
   "4", "\[InvisibleSpace]", "\<\"\\n#1-qubit gates:  \"\>", 
   "\[InvisibleSpace]", "7", 
   "\[InvisibleSpace]", "\<\"(-1) by removing the Z gate at the end\\n\"\>", 
   "\[InvisibleSpace]", 
   GraphicsBox[
    {EdgeForm[GrayLevel[0]], FaceForm[GrayLevel[
     1]], {{LineBox[{{0, 0.5}, {1, 0.5}}], LineBox[{{0, 1.5}, {1, 1.5}}], 
       LineBox[{{0, 2.5}, {1, 2.5}}]}, {LineBox[{{1, 0.5}, {2, 0.5}}], 
       LineBox[{{1, 1.5}, {2, 1.5}}], LineBox[{{1, 2.5}, {2, 2.5}}]}, {
       LineBox[{{2, 0.5}, {3, 0.5}}], LineBox[{{2, 1.5}, {3, 1.5}}], 
       LineBox[{{2, 2.5}, {3, 2.5}}]}, {LineBox[{{3, 0.5}, {4, 0.5}}], 
       LineBox[{{3, 1.5}, {4, 1.5}}], LineBox[{{3, 2.5}, {4, 2.5}}]}, {
       LineBox[{{4, 0.5}, {5, 0.5}}], LineBox[{{4, 1.5}, {5, 1.5}}], 
       LineBox[{{4, 2.5}, {5, 2.5}}]}, {LineBox[{{5, 0.5}, {6, 0.5}}], 
       LineBox[{{5, 1.5}, {6, 1.5}}], LineBox[{{5, 2.5}, {6, 2.5}}]}, {
       LineBox[{{6, 0.5}, {7, 0.5}}], LineBox[{{6, 1.5}, {7, 1.5}}], 
       LineBox[{{6, 2.5}, {7, 2.5}}]}, {LineBox[{{7, 0.5}, {8, 0.5}}], 
       LineBox[{{7, 1.5}, {8, 1.5}}], LineBox[{{7, 2.5}, {8, 2.5}}]}}, {{
       RectangleBox[{0.1, 1.1}, {0.9, 1.9}], 
       InsetBox["\<\"Rz\"\>", {0.5, 1.5}]}, {
       RectangleBox[{0.1, 2.1}, {0.9, 2.9}], 
       InsetBox["\<\"Ry\"\>", {0.5, 2.5}]}, {
       LineBox[{{1.5, 0.5}, {1.5, 1.5}}], {
        RectangleBox[{1.1, 0.1}, {1.9, 0.9}], 
        InsetBox["\<\"Rx\"\>", {1.5, 0.5}]}, {
        RectangleBox[{1.1, 1.1}, {1.9, 1.9}], 
        InsetBox["\<\"Rx\"\>", {1.5, 1.5}]}}, {
       RectangleBox[{2.1, 0.1}, {2.9, 0.9}], 
       InsetBox["\<\"Rz\"\>", {2.5, 0.5}]}, {
       RectangleBox[{2.1, 1.1}, {2.9, 1.9}], 
       InsetBox["\<\"Ry\"\>", {2.5, 1.5}]}, {
       LineBox[{{3.5, 0.5}, {3.5, 1.5}}], {
        RectangleBox[{3.1, 0.1}, {3.9, 0.9}], 
        InsetBox["\<\"Rx\"\>", {3.5, 0.5}]}, {
        RectangleBox[{3.1, 1.1}, {3.9, 1.9}], 
        InsetBox["\<\"Rx\"\>", {3.5, 1.5}]}}, {
       LineBox[{{4.5, 1.5}, {4.5, 2.5}}], {
        RectangleBox[{4.1, 1.1}, {4.9, 1.9}], 
        InsetBox["\<\"Rx\"\>", {4.5, 1.5}]}, {
        RectangleBox[{4.1, 2.1}, {4.9, 2.9}], 
        InsetBox["\<\"Rx\"\>", {4.5, 2.5}]}}, {
       RectangleBox[{4.1, 0.1}, {4.9, 0.9}], 
       InsetBox["\<\"Ry\"\>", {4.5, 0.5}]}, {
       LineBox[{{5.5, 0.5}, {5.5, 2.5}}], {
        RectangleBox[{5.1, 0.1}, {5.9, 0.9}], 
        InsetBox["\<\"Rx\"\>", {5.5, 0.5}]}, {
        RectangleBox[{5.1, 2.1}, {5.9, 2.9}], 
        InsetBox["\<\"Rx\"\>", {5.5, 2.5}]}}, {
       RectangleBox[{6.1, 2.1}, {6.9, 2.9}], 
       InsetBox["\<\"Ry\"\>", {6.5, 2.5}]}, {
       RectangleBox[{7.1, 2.1}, {7.9, 2.9}], 
       InsetBox["\<\"Rz\"\>", {7.5, 2.5}]}}},
    ImageSize->{Automatic, 60},
    PlotRangePadding->None], "\[InvisibleSpace]", "\<\"\\n\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      SubscriptBox["Rz", "n2"], "[", 
      RowBox[{"-", 
       FractionBox["\[Pi]", "2"]}], "]"}], ",", 
     RowBox[{"R", "[", 
      RowBox[{
       FractionBox["\[Pi]", "2"], ",", 
       RowBox[{
        SubscriptBox["X", "n1"], " ", 
        SubscriptBox["X", "n2"]}]}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rz", "n1"], "[", 
      FractionBox[
       RowBox[{"3", " ", "\[Pi]"}], "4"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Ry", "n2"], "[", 
      FractionBox["\[Pi]", "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Ry", "c"], "[", 
      FractionBox[
       RowBox[{"3", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{"R", "[", 
      RowBox[{
       FractionBox[
        RowBox[{"7", " ", "\[Pi]"}], "2"], ",", 
       RowBox[{
        SubscriptBox["X", "n1"], " ", 
        SubscriptBox["X", "n2"]}]}], "]"}], ",", 
     RowBox[{"R", "[", 
      RowBox[{
       FractionBox[
        RowBox[{"5", " ", "\[Pi]"}], "4"], ",", 
       RowBox[{
        SubscriptBox["X", "c"], " ", 
        SubscriptBox["X", "n2"]}]}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Ry", "n1"], "[", 
      FractionBox[
       RowBox[{"3", " ", "\[Pi]"}], "4"], "]"}], ",", 
     RowBox[{"R", "[", 
      RowBox[{
       FractionBox["\[Pi]", "2"], ",", 
       RowBox[{
        SubscriptBox["X", "c"], " ", 
        SubscriptBox["X", "n1"]}]}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Ry", "c"], "[", 
      FractionBox["\[Pi]", "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rz", "c"], "[", 
      FractionBox[
       RowBox[{"5", " ", "\[Pi]"}], "4"], "]"}]}], "}"}], 
   "\[InvisibleSpace]", "\<\"\\nis the circuit correct:   \"\>", 
   "\[InvisibleSpace]", "True", "\[InvisibleSpace]", "\<\"\\n\\n\"\>"}],
  SequenceForm[
  "Gate Type: ", "xxOBSX", "\n#2-qubit gates:  ", 4, "\n#1-qubit gates:  ", 7,
    "(-1) by removing the Z gate at the end\n", 
   Graphics[{
     FaceForm[
      GrayLevel[1]], 
     EdgeForm[
      GrayLevel[0]], {{
       Line[{{0, 0.5}, {1, 0.5}}], 
       Line[{{0, 1.5}, {1, 1.5}}], 
       Line[{{0, 2.5}, {1, 2.5}}]}, {
       Line[{{1, 0.5}, {2, 0.5}}], 
       Line[{{1, 1.5}, {2, 1.5}}], 
       Line[{{1, 2.5}, {2, 2.5}}]}, {
       Line[{{2, 0.5}, {3, 0.5}}], 
       Line[{{2, 1.5}, {3, 1.5}}], 
       Line[{{2, 2.5}, {3, 2.5}}]}, {
       Line[{{3, 0.5}, {4, 0.5}}], 
       Line[{{3, 1.5}, {4, 1.5}}], 
       Line[{{3, 2.5}, {4, 2.5}}]}, {
       Line[{{4, 0.5}, {5, 0.5}}], 
       Line[{{4, 1.5}, {5, 1.5}}], 
       Line[{{4, 2.5}, {5, 2.5}}]}, {
       Line[{{5, 0.5}, {6, 0.5}}], 
       Line[{{5, 1.5}, {6, 1.5}}], 
       Line[{{5, 2.5}, {6, 2.5}}]}, {
       Line[{{6, 0.5}, {7, 0.5}}], 
       Line[{{6, 1.5}, {7, 1.5}}], 
       Line[{{6, 2.5}, {7, 2.5}}]}, {
       Line[{{7, 0.5}, {8, 0.5}}], 
       Line[{{7, 1.5}, {8, 1.5}}], 
       Line[{{7, 2.5}, {8, 2.5}}]}}, {{
       Rectangle[{0.1, 1.1}, {0.9, 1.9}], 
       Text["Rz", {0.5, 1.5}]}, {
       Rectangle[{0.1, 2.1}, {0.9, 2.9}], 
       Text["Ry", {0.5, 2.5}]}, {
       Line[{{1.5, 0.5}, {1.5, 1.5}}], {
        Rectangle[{1.1, 0.1}, {1.9, 0.9}], 
        Text["Rx", {1.5, 0.5}]}, {
        Rectangle[{1.1, 1.1}, {1.9, 1.9}], 
        Text["Rx", {1.5, 1.5}]}}, {
       Rectangle[{2.1, 0.1}, {2.9, 0.9}], 
       Text["Rz", {2.5, 0.5}]}, {
       Rectangle[{2.1, 1.1}, {2.9, 1.9}], 
       Text["Ry", {2.5, 1.5}]}, {
       Line[{{3.5, 0.5}, {3.5, 1.5}}], {
        Rectangle[{3.1, 0.1}, {3.9, 0.9}], 
        Text["Rx", {3.5, 0.5}]}, {
        Rectangle[{3.1, 1.1}, {3.9, 1.9}], 
        Text["Rx", {3.5, 1.5}]}}, {
       Line[{{4.5, 1.5}, {4.5, 2.5}}], {
        Rectangle[{4.1, 1.1}, {4.9, 1.9}], 
        Text["Rx", {4.5, 1.5}]}, {
        Rectangle[{4.1, 2.1}, {4.9, 2.9}], 
        Text["Rx", {4.5, 2.5}]}}, {
       Rectangle[{4.1, 0.1}, {4.9, 0.9}], 
       Text["Ry", {4.5, 0.5}]}, {
       Line[{{5.5, 0.5}, {5.5, 2.5}}], {
        Rectangle[{5.1, 0.1}, {5.9, 0.9}], 
        Text["Rx", {5.5, 0.5}]}, {
        Rectangle[{5.1, 2.1}, {5.9, 2.9}], 
        Text["Rx", {5.5, 2.5}]}}, {
       Rectangle[{6.1, 2.1}, {6.9, 2.9}], 
       Text["Ry", {6.5, 2.5}]}, {
       Rectangle[{7.1, 2.1}, {7.9, 2.9}], 
       Text["Rz", {7.5, 2.5}]}}}, {ImageSize -> {Automatic, 60}}, ImageSize -> 
    270, PlotRangePadding -> None], "\n", {
    Subscript[QuEST`Gate`Rz, $CellContext`n2][Rational[-1, 2] Pi], 
    QuEST`Gate`R[
    Rational[1, 2] Pi, Subscript[QuEST`Gate`X, $CellContext`n1] 
     Subscript[QuEST`Gate`X, $CellContext`n2]], 
    Subscript[QuEST`Gate`Rz, $CellContext`n1][Rational[3, 4] Pi], 
    Subscript[QuEST`Gate`Ry, $CellContext`n2][Rational[1, 2] Pi], 
    Subscript[QuEST`Gate`Ry, $CellContext`c][Rational[3, 2] Pi], 
    QuEST`Gate`R[
    Rational[7, 2] Pi, Subscript[QuEST`Gate`X, $CellContext`n1] 
     Subscript[QuEST`Gate`X, $CellContext`n2]], 
    QuEST`Gate`R[
    Rational[5, 4] Pi, Subscript[QuEST`Gate`X, $CellContext`c] 
     Subscript[QuEST`Gate`X, $CellContext`n2]], 
    Subscript[QuEST`Gate`Ry, $CellContext`n1][Rational[3, 4] Pi], 
    QuEST`Gate`R[
    Rational[1, 2] Pi, Subscript[QuEST`Gate`X, $CellContext`c] 
     Subscript[QuEST`Gate`X, $CellContext`n1]], 
    Subscript[QuEST`Gate`Ry, $CellContext`c][Rational[1, 2] Pi], 
    Subscript[QuEST`Gate`Rz, $CellContext`c][Rational[5, 4] Pi]}, 
   "\nis the circuit correct:   ", True, "\n\n"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.8317260055449686`*^9, 3.831726012244398*^9}, 
   3.831726360445975*^9},
 CellLabel->
  "During evaluation of \
In[18]:=",ExpressionUUID->"3fbdefdf-90fb-4d03-9543-ef5074e30759"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Gate Type: \"\>", "\[InvisibleSpace]", "\<\"czOBSX\"\>", 
   "\[InvisibleSpace]", "\<\"\\n#2-qubit gates:  \"\>", "\[InvisibleSpace]", 
   "4", "\[InvisibleSpace]", "\<\"\\n#1-qubit gates:  \"\>", 
   "\[InvisibleSpace]", "5", 
   "\[InvisibleSpace]", "\<\"(-1) by removing the Z gate at the end\\n\"\>", 
   "\[InvisibleSpace]", 
   GraphicsBox[
    {EdgeForm[GrayLevel[0]], FaceForm[GrayLevel[
     1]], {{LineBox[{{0, 0.5}, {1, 0.5}}], LineBox[{{0, 1.5}, {1, 1.5}}], 
       LineBox[{{0, 2.5}, {1, 2.5}}]}, {LineBox[{{1, 0.5}, {2, 0.5}}], 
       LineBox[{{1, 1.5}, {2, 1.5}}], LineBox[{{1, 2.5}, {2, 2.5}}]}, {
       LineBox[{{2, 0.5}, {3, 0.5}}], LineBox[{{2, 1.5}, {3, 1.5}}], 
       LineBox[{{2, 2.5}, {3, 2.5}}]}, {LineBox[{{3, 0.5}, {4, 0.5}}], 
       LineBox[{{3, 1.5}, {4, 1.5}}], LineBox[{{3, 2.5}, {4, 2.5}}]}, {
       LineBox[{{4, 0.5}, {5, 0.5}}], LineBox[{{4, 1.5}, {5, 1.5}}], 
       LineBox[{{4, 2.5}, {5, 2.5}}]}, {LineBox[{{5, 0.5}, {6, 0.5}}], 
       LineBox[{{5, 1.5}, {6, 1.5}}], LineBox[{{5, 2.5}, {6, 2.5}}]}, {
       LineBox[{{6, 0.5}, {7, 0.5}}], LineBox[{{6, 1.5}, {7, 1.5}}], 
       LineBox[{{6, 2.5}, {7, 2.5}}]}}, {{
       RectangleBox[{0.1, 0.1}, {0.9, 0.9}], 
       InsetBox["\<\"Ry\"\>", {0.5, 0.5}]}, {
       {FaceForm[GrayLevel[0]], DiskBox[{1.5, 0.5}, 0.1], 
        LineBox[{{1.5, 0.5}, {1.5, 1.5}}]}, {
        RectangleBox[{1.1, 1.1}, {1.9, 1.9}], 
        InsetBox["\<\"Rz\"\>", {1.5, 1.5}]}}, {
       RectangleBox[{2.1, 1.1}, {2.9, 1.9}], 
       InsetBox["\<\"Ry\"\>", {2.5, 1.5}]}, {
       RectangleBox[{2.1, 0.1}, {2.9, 0.9}], 
       InsetBox["\<\"Rx\"\>", {2.5, 0.5}]}, {
       {FaceForm[GrayLevel[0]], DiskBox[{3.5, 1.5}, 0.1], 
        LineBox[{{3.5, 0.5}, {3.5, 1.5}}]}, {
        RectangleBox[{3.1, 0.1}, {3.9, 0.9}], 
        InsetBox["\<\"Rz\"\>", {3.5, 0.5}]}}, {
       {FaceForm[GrayLevel[0]], DiskBox[{4.5, 2.5}, 0.1], 
        LineBox[{{4.5, 1.5}, {4.5, 2.5}}]}, {
        RectangleBox[{4.1, 1.1}, {4.9, 1.9}], 
        InsetBox["\<\"Rz\"\>", {4.5, 1.5}]}}, {
       RectangleBox[{4.1, 0.1}, {4.9, 0.9}], 
       InsetBox["\<\"Rx\"\>", {4.5, 0.5}]}, {
       {FaceForm[GrayLevel[0]], DiskBox[{5.5, 2.5}, 0.1], 
        LineBox[{{5.5, 0.5}, {5.5, 2.5}}]}, {
        RectangleBox[{5.1, 0.1}, {5.9, 0.9}], 
        InsetBox["\<\"Rz\"\>", {5.5, 0.5}]}}, {
       RectangleBox[{6.1, 2.1}, {6.9, 2.9}], 
       InsetBox["\<\"Rz\"\>", {6.5, 2.5}]}}},
    ImageSize->{Automatic, 60},
    PlotRangePadding->None], "\[InvisibleSpace]", "\<\"\\n\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      SubscriptBox["Ry", "n1"], "[", 
      FractionBox[
       RowBox[{"7", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["C", "n1"], "[", 
      RowBox[{
       SubscriptBox["Rz", "n2"], "[", "\[Pi]", "]"}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Ry", "n2"], "[", 
      FractionBox[
       RowBox[{"7", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rx", "n1"], "[", 
      FractionBox[
       RowBox[{"3", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["C", "n2"], "[", 
      RowBox[{
       SubscriptBox["Rz", "n1"], "[", 
       FractionBox[
        RowBox[{"3", " ", "\[Pi]"}], "2"], "]"}], "]"}], ",", 
     RowBox[{
      SubscriptBox["C", "c"], "[", 
      RowBox[{
       SubscriptBox["Rz", "n2"], "[", 
       FractionBox[
        RowBox[{"5", " ", "\[Pi]"}], "2"], "]"}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rx", "n1"], "[", 
      FractionBox["\[Pi]", "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["C", "c"], "[", 
      RowBox[{
       SubscriptBox["Rz", "n1"], "[", "\[Pi]", "]"}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rz", "c"], "[", 
      FractionBox[
       RowBox[{"15", " ", "\[Pi]"}], "4"], "]"}]}], "}"}], 
   "\[InvisibleSpace]", "\<\"\\nis the circuit correct:   \"\>", 
   "\[InvisibleSpace]", "True", "\[InvisibleSpace]", "\<\"\\n\\n\"\>"}],
  SequenceForm[
  "Gate Type: ", "czOBSX", "\n#2-qubit gates:  ", 4, "\n#1-qubit gates:  ", 5,
    "(-1) by removing the Z gate at the end\n", 
   Graphics[{
     FaceForm[
      GrayLevel[1]], 
     EdgeForm[
      GrayLevel[0]], {{
       Line[{{0, 0.5}, {1, 0.5}}], 
       Line[{{0, 1.5}, {1, 1.5}}], 
       Line[{{0, 2.5}, {1, 2.5}}]}, {
       Line[{{1, 0.5}, {2, 0.5}}], 
       Line[{{1, 1.5}, {2, 1.5}}], 
       Line[{{1, 2.5}, {2, 2.5}}]}, {
       Line[{{2, 0.5}, {3, 0.5}}], 
       Line[{{2, 1.5}, {3, 1.5}}], 
       Line[{{2, 2.5}, {3, 2.5}}]}, {
       Line[{{3, 0.5}, {4, 0.5}}], 
       Line[{{3, 1.5}, {4, 1.5}}], 
       Line[{{3, 2.5}, {4, 2.5}}]}, {
       Line[{{4, 0.5}, {5, 0.5}}], 
       Line[{{4, 1.5}, {5, 1.5}}], 
       Line[{{4, 2.5}, {5, 2.5}}]}, {
       Line[{{5, 0.5}, {6, 0.5}}], 
       Line[{{5, 1.5}, {6, 1.5}}], 
       Line[{{5, 2.5}, {6, 2.5}}]}, {
       Line[{{6, 0.5}, {7, 0.5}}], 
       Line[{{6, 1.5}, {7, 1.5}}], 
       Line[{{6, 2.5}, {7, 2.5}}]}}, {{
       Rectangle[{0.1, 0.1}, {0.9, 0.9}], 
       Text["Ry", {0.5, 0.5}]}, {{
        FaceForm[
         GrayLevel[0]], {
         Disk[{1.5, 0.5}, 0.1]}, 
        Line[{{1.5, 0.5}, {1.5, 1.5}}]}, {
        Rectangle[{1.1, 1.1}, {1.9, 1.9}], 
        Text["Rz", {1.5, 1.5}]}}, {
       Rectangle[{2.1, 1.1}, {2.9, 1.9}], 
       Text["Ry", {2.5, 1.5}]}, {
       Rectangle[{2.1, 0.1}, {2.9, 0.9}], 
       Text["Rx", {2.5, 0.5}]}, {{
        FaceForm[
         GrayLevel[0]], {
         Disk[{3.5, 1.5}, 0.1]}, 
        Line[{{3.5, 0.5}, {3.5, 1.5}}]}, {
        Rectangle[{3.1, 0.1}, {3.9, 0.9}], 
        Text["Rz", {3.5, 0.5}]}}, {{
        FaceForm[
         GrayLevel[0]], {
         Disk[{4.5, 2.5}, 0.1]}, 
        Line[{{4.5, 1.5}, {4.5, 2.5}}]}, {
        Rectangle[{4.1, 1.1}, {4.9, 1.9}], 
        Text["Rz", {4.5, 1.5}]}}, {
       Rectangle[{4.1, 0.1}, {4.9, 0.9}], 
       Text["Rx", {4.5, 0.5}]}, {{
        FaceForm[
         GrayLevel[0]], {
         Disk[{5.5, 2.5}, 0.1]}, 
        Line[{{5.5, 0.5}, {5.5, 2.5}}]}, {
        Rectangle[{5.1, 0.1}, {5.9, 0.9}], 
        Text["Rz", {5.5, 0.5}]}}, {
       Rectangle[{6.1, 2.1}, {6.9, 2.9}], 
       Text["Rz", {6.5, 2.5}]}}}, {ImageSize -> {Automatic, 60}}, ImageSize -> 
    240, PlotRangePadding -> None], "\n", {
    Subscript[QuEST`Gate`Ry, $CellContext`n1][Rational[7, 2] Pi], 
    Subscript[C, $CellContext`n1][
     Subscript[QuEST`Gate`Rz, $CellContext`n2][Pi]], 
    Subscript[QuEST`Gate`Ry, $CellContext`n2][Rational[7, 2] Pi], 
    Subscript[QuEST`Gate`Rx, $CellContext`n1][Rational[3, 2] Pi], 
    Subscript[C, $CellContext`n2][
     Subscript[QuEST`Gate`Rz, $CellContext`n1][Rational[3, 2] Pi]], 
    Subscript[C, $CellContext`c][
     Subscript[QuEST`Gate`Rz, $CellContext`n2][Rational[5, 2] Pi]], 
    Subscript[QuEST`Gate`Rx, $CellContext`n1][Rational[1, 2] Pi], 
    Subscript[C, $CellContext`c][
     Subscript[QuEST`Gate`Rz, $CellContext`n1][Pi]], 
    Subscript[QuEST`Gate`Rz, $CellContext`c][Rational[15, 4] Pi]}, 
   "\nis the circuit correct:   ", True, "\n\n"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.8317260055449686`*^9, 3.831726012244398*^9}, 
   3.8317263604711*^9},
 CellLabel->
  "During evaluation of \
In[18]:=",ExpressionUUID->"a8be3785-0101-4a9d-a5a4-291c493a4216"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Gate Type: \"\>", "\[InvisibleSpace]", "\<\"ccphaseOBSX\"\>", 
   "\[InvisibleSpace]", "\<\"\\n#2-qubit gates:  \"\>", "\[InvisibleSpace]", 
   "3", "\[InvisibleSpace]", "\<\"\\n#1-qubit gates:  \"\>", 
   "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\"(-1) by removing the Z gate at the end\\n\"\>", 
   "\[InvisibleSpace]", 
   GraphicsBox[
    {EdgeForm[GrayLevel[0]], FaceForm[GrayLevel[
     1]], {{LineBox[{{0, 0.5}, {1, 0.5}}], LineBox[{{0, 1.5}, {1, 1.5}}], 
       LineBox[{{0, 2.5}, {1, 2.5}}]}, {LineBox[{{1, 0.5}, {2, 0.5}}], 
       LineBox[{{1, 1.5}, {2, 1.5}}], LineBox[{{1, 2.5}, {2, 2.5}}]}, {
       LineBox[{{2, 0.5}, {3, 0.5}}], LineBox[{{2, 1.5}, {3, 1.5}}], 
       LineBox[{{2, 2.5}, {3, 2.5}}]}, {LineBox[{{3, 0.5}, {4, 0.5}}], 
       LineBox[{{3, 1.5}, {4, 1.5}}], LineBox[{{3, 2.5}, {4, 2.5}}]}, {
       LineBox[{{4, 0.5}, {5, 0.5}}], LineBox[{{4, 1.5}, {5, 1.5}}], 
       LineBox[{{4, 2.5}, {5, 2.5}}]}, {LineBox[{{5, 0.5}, {6, 0.5}}], 
       LineBox[{{5, 1.5}, {6, 1.5}}], LineBox[{{5, 2.5}, {6, 2.5}}]}}, {{
       RectangleBox[{0.1, 1.1}, {0.9, 1.9}], 
       InsetBox["\<\"Ry\"\>", {0.5, 1.5}]}, {
       {FaceForm[GrayLevel[0]], DiskBox[{1.5, 1.5}, 0.1], 
        LineBox[{{1.5, 0.5}, {1.5, 1.5}}]}, {
        RectangleBox[{1.1, 0.1}, {1.9, 0.9}], 
        InsetBox["\<\"Rz\"\>", {1.5, 0.5}]}}, {
       {FaceForm[GrayLevel[0]], DiskBox[{2.5, 2.5}, 0.1], 
        LineBox[{{2.5, 1.5}, {2.5, 2.5}}]}, {
        RectangleBox[{2.1, 1.1}, {2.9, 1.9}], 
        InsetBox["\<\"Rz\"\>", {2.5, 1.5}]}}, {
       RectangleBox[{2.1, 0.1}, {2.9, 0.9}], 
       InsetBox["\<\"Ry\"\>", {2.5, 0.5}]}, {
       RectangleBox[{3.1, 1.1}, {3.9, 1.9}], 
       InsetBox["\<\"Rx\"\>", {3.5, 1.5}]}, {
       {FaceForm[GrayLevel[
        0]], {DiskBox[{4.5, 2.5}, 0.1], DiskBox[{4.5, 0.5}, 0.1], 
         DiskBox[{4.5, 1.5}, 0.1]}, LineBox[{{4.5, 0.5}, {4.5, 2.5}}]}, 
       LineBox[{{4.5, 0.5}, {4.5, 2.5}}]}, {
       RectangleBox[{5.1, 2.1}, {5.9, 2.9}], 
       InsetBox["\<\"Rz\"\>", {5.5, 2.5}]}}},
    ImageSize->{Automatic, 60},
    PlotRangePadding->None], "\[InvisibleSpace]", "\<\"\\n\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      SubscriptBox["Ry", "n2"], "[", 
      FractionBox[
       RowBox[{"5", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["C", "n2"], "[", 
      RowBox[{
       SubscriptBox["Rz", "n1"], "[", "\[Pi]", "]"}], "]"}], ",", 
     RowBox[{
      SubscriptBox["C", "c"], "[", 
      RowBox[{
       SubscriptBox["Rz", "n2"], "[", 
       RowBox[{"-", "\[Pi]"}], "]"}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Ry", "n1"], "[", 
      FractionBox["\[Pi]", "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rx", "n2"], "[", 
      FractionBox[
       RowBox[{"5", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["CCPhase", 
       RowBox[{"c", ",", "n1", ",", "n2"}]], "[", 
      RowBox[{"2", " ", "\[Pi]"}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rz", "c"], "[", 
      FractionBox["\[Pi]", "2"], "]"}]}], "}"}], 
   "\[InvisibleSpace]", "\<\"\\nis the circuit correct:   \"\>", 
   "\[InvisibleSpace]", "True", "\[InvisibleSpace]", "\<\"\\n\\n\"\>"}],
  SequenceForm[
  "Gate Type: ", "ccphaseOBSX", "\n#2-qubit gates:  ", 3, 
   "\n#1-qubit gates:  ", 4, "(-1) by removing the Z gate at the end\n", 
   Graphics[{
     FaceForm[
      GrayLevel[1]], 
     EdgeForm[
      GrayLevel[0]], {{
       Line[{{0, 0.5}, {1, 0.5}}], 
       Line[{{0, 1.5}, {1, 1.5}}], 
       Line[{{0, 2.5}, {1, 2.5}}]}, {
       Line[{{1, 0.5}, {2, 0.5}}], 
       Line[{{1, 1.5}, {2, 1.5}}], 
       Line[{{1, 2.5}, {2, 2.5}}]}, {
       Line[{{2, 0.5}, {3, 0.5}}], 
       Line[{{2, 1.5}, {3, 1.5}}], 
       Line[{{2, 2.5}, {3, 2.5}}]}, {
       Line[{{3, 0.5}, {4, 0.5}}], 
       Line[{{3, 1.5}, {4, 1.5}}], 
       Line[{{3, 2.5}, {4, 2.5}}]}, {
       Line[{{4, 0.5}, {5, 0.5}}], 
       Line[{{4, 1.5}, {5, 1.5}}], 
       Line[{{4, 2.5}, {5, 2.5}}]}, {
       Line[{{5, 0.5}, {6, 0.5}}], 
       Line[{{5, 1.5}, {6, 1.5}}], 
       Line[{{5, 2.5}, {6, 2.5}}]}}, {{
       Rectangle[{0.1, 1.1}, {0.9, 1.9}], 
       Text["Ry", {0.5, 1.5}]}, {{
        FaceForm[
         GrayLevel[0]], {
         Disk[{1.5, 1.5}, 0.1]}, 
        Line[{{1.5, 0.5}, {1.5, 1.5}}]}, {
        Rectangle[{1.1, 0.1}, {1.9, 0.9}], 
        Text["Rz", {1.5, 0.5}]}}, {{
        FaceForm[
         GrayLevel[0]], {
         Disk[{2.5, 2.5}, 0.1]}, 
        Line[{{2.5, 1.5}, {2.5, 2.5}}]}, {
        Rectangle[{2.1, 1.1}, {2.9, 1.9}], 
        Text["Rz", {2.5, 1.5}]}}, {
       Rectangle[{2.1, 0.1}, {2.9, 0.9}], 
       Text["Ry", {2.5, 0.5}]}, {
       Rectangle[{3.1, 1.1}, {3.9, 1.9}], 
       Text["Rx", {3.5, 1.5}]}, {{
        FaceForm[
         GrayLevel[0]], {
         Disk[{4.5, 2.5}, 0.1], 
         Disk[{4.5, 0.5}, 0.1], 
         Disk[{4.5, 1.5}, 0.1]}, 
        Line[{{4.5, 0.5}, {4.5, 2.5}}]}, 
       Line[{{4.5, 0.5}, {4.5, 2.5}}]}, {
       Rectangle[{5.1, 2.1}, {5.9, 2.9}], 
       Text["Rz", {5.5, 2.5}]}}}, {ImageSize -> {Automatic, 60}}, ImageSize -> 
    210, PlotRangePadding -> None], "\n", {
    Subscript[QuEST`Gate`Ry, $CellContext`n2][Rational[5, 2] Pi], 
    Subscript[C, $CellContext`n2][
     Subscript[QuEST`Gate`Rz, $CellContext`n1][Pi]], 
    Subscript[C, $CellContext`c][
     Subscript[QuEST`Gate`Rz, $CellContext`n2][-Pi]], 
    Subscript[QuEST`Gate`Ry, $CellContext`n1][Rational[1, 2] Pi], 
    Subscript[QuEST`Gate`Rx, $CellContext`n2][Rational[5, 2] Pi], 
    Subscript[$CellContext`CCPhase, $CellContext`c, $CellContext`n1, \
$CellContext`n2][2 Pi], 
    Subscript[QuEST`Gate`Rz, $CellContext`c][Rational[1, 2] Pi]}, 
   "\nis the circuit correct:   ", True, "\n\n"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.8317260055449686`*^9, 3.831726012244398*^9}, 
   3.8317263604881*^9},
 CellLabel->
  "During evaluation of \
In[18]:=",ExpressionUUID->"6ce3ac3b-e46e-4a21-8be2-44f28e0d49de"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Gate Type: \"\>", "\[InvisibleSpace]", "\<\"pswapOBSX\"\>", 
   "\[InvisibleSpace]", "\<\"\\n#2-qubit gates:  \"\>", "\[InvisibleSpace]", 
   "4", "\[InvisibleSpace]", "\<\"\\n#1-qubit gates:  \"\>", 
   "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\"(-1) by removing the Z gate at the end\\n\"\>", 
   "\[InvisibleSpace]", 
   GraphicsBox[
    {EdgeForm[GrayLevel[0]], FaceForm[GrayLevel[
     1]], {{LineBox[{{0, 0.5}, {1, 0.5}}], LineBox[{{0, 1.5}, {1, 1.5}}], 
       LineBox[{{0, 2.5}, {1, 2.5}}]}, {LineBox[{{1, 0.5}, {2, 0.5}}], 
       LineBox[{{1, 1.5}, {2, 1.5}}], LineBox[{{1, 2.5}, {2, 2.5}}]}, {
       LineBox[{{2, 0.5}, {3, 0.5}}], LineBox[{{2, 1.5}, {3, 1.5}}], 
       LineBox[{{2, 2.5}, {3, 2.5}}]}, {LineBox[{{3, 0.5}, {4, 0.5}}], 
       LineBox[{{3, 1.5}, {4, 1.5}}], 
       LineBox[{{3, 2.5}, {4, 2.5}}]}, {{LineBox[{{4.5, 0.5}, {5.5, 0.5}}], 
        LineBox[{{4.5, 1.5}, {5.5, 1.5}}], LineBox[{{4.5, 2.5}, {5.5, 2.5}}]},
        LineBox[{{4, 0.5}, {5, 0.5}}], LineBox[{{5, 0.5}, {6, 0.5}}]}, {
       LineBox[{{6, 0.5}, {7, 0.5}}], LineBox[{{6, 1.5}, {7, 1.5}}], 
       LineBox[{{6, 2.5}, {7, 2.5}}]}}, {{
       RectangleBox[{0.1, 0.1}, {0.9, 1.9}], 
       InsetBox["\<\"pSW\"\>", {0.5, 1.}]}, {
       RectangleBox[{1.1, 1.1}, {1.9, 2.9}], 
       InsetBox["\<\"pSW\"\>", {1.5, 2.}]}, {
       RectangleBox[{1.1, 0.1}, {1.9, 0.9}], 
       InsetBox["\<\"Rz\"\>", {1.5, 0.5}]}, {
       RectangleBox[{2.1, 0.1}, {2.9, 0.9}], 
       InsetBox["\<\"Ry\"\>", {2.5, 0.5}]}, {
       RectangleBox[{2.1, 1.1}, {2.9, 1.9}], 
       InsetBox["\<\"Ry\"\>", {2.5, 1.5}]}, {
       RectangleBox[{3.1, 0.1}, {3.9, 1.9}], 
       InsetBox["\<\"pSW\"\>", {3.5, 1.}]}, {{{
         LineBox[{{4, 2.5}, {4.1, 2.5}}], LineBox[{{4.1, 2.5}, {4.4, 1.5}}], 
         LineBox[{{4.4, 1.5}, {4.5, 1.5}}]}, {LineBox[{{4, 1.5}, {4.1, 1.5}}],
          LineBox[{{4.1, 1.5}, {4.4, 2.5}}], 
         LineBox[{{4.4, 2.5}, {4.5, 2.5}}]}}, {
        RectangleBox[{4.6, 0.1}, {5.4, 1.9}], 
        InsetBox["\<\"pSW\"\>", {5., 1.}]}, {{
         LineBox[{{5.5, 2.5}, {5.6, 2.5}}], LineBox[{{5.6, 2.5}, {5.9, 1.5}}],
          LineBox[{{5.9, 1.5}, {6., 1.5}}]}, {
         LineBox[{{5.5, 1.5}, {5.6, 1.5}}], LineBox[{{5.6, 1.5}, {5.9, 2.5}}],
          LineBox[{{5.9, 2.5}, {6., 2.5}}]}}}, {
       RectangleBox[{6.1, 2.1}, {6.9, 2.9}], 
       InsetBox["\<\"Rz\"\>", {6.5, 2.5}]}}},
    ImageSize->{Automatic, 60},
    PlotRangePadding->None], "\[InvisibleSpace]", "\<\"\\n\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      SubscriptBox["pSWAP", 
       RowBox[{"0", ",", "1"}]], "[", 
      RowBox[{
       FractionBox[
        RowBox[{"5", " ", "\[Pi]"}], "8"], ",", 
       FractionBox[
        RowBox[{"5", " ", "\[Pi]"}], "2"]}], "]"}], ",", 
     RowBox[{
      SubscriptBox["pSWAP", 
       RowBox[{"1", ",", "2"}]], "[", 
      RowBox[{
       FractionBox["\[Pi]", "2"], ",", 
       FractionBox[
        RowBox[{"13", " ", "\[Pi]"}], "4"]}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rz", "n1"], "[", 
      FractionBox["\[Pi]", "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Ry", "n1"], "[", 
      FractionBox[
       RowBox[{"3", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Ry", "n2"], "[", 
      FractionBox[
       RowBox[{"5", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["pSWAP", 
       RowBox[{"0", ",", "1"}]], "[", 
      RowBox[{
       FractionBox[
        RowBox[{"25", " ", "\[Pi]"}], "8"], ",", "0"}], "]"}], ",", 
     RowBox[{
      SubscriptBox["pSWAP", 
       RowBox[{"0", ",", "2"}]], "[", 
      RowBox[{"\[Pi]", ",", 
       FractionBox[
        RowBox[{"15", " ", "\[Pi]"}], "4"]}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rz", "c"], "[", 
      FractionBox[
       RowBox[{"13", " ", "\[Pi]"}], "4"], "]"}]}], "}"}], 
   "\[InvisibleSpace]", "\<\"\\nis the circuit correct:   \"\>", 
   "\[InvisibleSpace]", "True", "\[InvisibleSpace]", "\<\"\\n\\n\"\>"}],
  SequenceForm[
  "Gate Type: ", "pswapOBSX", "\n#2-qubit gates:  ", 4, "\n#1-qubit gates:  ",
    4, "(-1) by removing the Z gate at the end\n", 
   Graphics[{
     FaceForm[
      GrayLevel[1]], 
     EdgeForm[
      GrayLevel[0]], {{
       Line[{{0, 0.5}, {1, 0.5}}], 
       Line[{{0, 1.5}, {1, 1.5}}], 
       Line[{{0, 2.5}, {1, 2.5}}]}, {
       Line[{{1, 0.5}, {2, 0.5}}], 
       Line[{{1, 1.5}, {2, 1.5}}], 
       Line[{{1, 2.5}, {2, 2.5}}]}, {
       Line[{{2, 0.5}, {3, 0.5}}], 
       Line[{{2, 1.5}, {3, 1.5}}], 
       Line[{{2, 2.5}, {3, 2.5}}]}, {
       Line[{{3, 0.5}, {4, 0.5}}], 
       Line[{{3, 1.5}, {4, 1.5}}], 
       Line[{{3, 2.5}, {4, 2.5}}]}, {{
        Line[{{4.5, 0.5}, {5.5, 0.5}}], 
        Line[{{4.5, 1.5}, {5.5, 1.5}}], 
        Line[{{4.5, 2.5}, {5.5, 2.5}}]}, {
        Line[{{4, 0.5}, {5, 0.5}}]}, {
        Line[{{5, 0.5}, {6, 0.5}}]}}, {
       Line[{{6, 0.5}, {7, 0.5}}], 
       Line[{{6, 1.5}, {7, 1.5}}], 
       Line[{{6, 2.5}, {7, 2.5}}]}}, {{
       Rectangle[{0.1, 0.1}, {0.9, 1.9}], 
       Text["pSW", {0.5, 1.}]}, {
       Rectangle[{1.1, 1.1}, {1.9, 2.9}], 
       Text["pSW", {1.5, 2.}]}, {
       Rectangle[{1.1, 0.1}, {1.9, 0.9}], 
       Text["Rz", {1.5, 0.5}]}, {
       Rectangle[{2.1, 0.1}, {2.9, 0.9}], 
       Text["Ry", {2.5, 0.5}]}, {
       Rectangle[{2.1, 1.1}, {2.9, 1.9}], 
       Text["Ry", {2.5, 1.5}]}, {
       Rectangle[{3.1, 0.1}, {3.9, 1.9}], 
       Text["pSW", {3.5, 1.}]}, {{{
         Line[{{4, 2.5}, {4.1, 2.5}}], 
         Line[{{4.1, 2.5}, {4.4, 1.5}}], 
         Line[{{4.4, 1.5}, {4.5, 1.5}}]}, {
         Line[{{4, 1.5}, {4.1, 1.5}}], 
         Line[{{4.1, 1.5}, {4.4, 2.5}}], 
         Line[{{4.4, 2.5}, {4.5, 2.5}}]}}, {
        Rectangle[{4.6, 0.1}, {5.4, 1.9}], 
        Text["pSW", {5., 1.}]}, {{
         Line[{{5.5, 2.5}, {5.6, 2.5}}], 
         Line[{{5.6, 2.5}, {5.9, 1.5}}], 
         Line[{{5.9, 1.5}, {6., 1.5}}]}, {
         Line[{{5.5, 1.5}, {5.6, 1.5}}], 
         Line[{{5.6, 1.5}, {5.9, 2.5}}], 
         Line[{{5.9, 2.5}, {6., 2.5}}]}}}, {
       Rectangle[{6.1, 2.1}, {6.9, 2.9}], 
       Text["Rz", {6.5, 2.5}]}}}, {ImageSize -> {Automatic, 60}}, ImageSize -> 
    240, PlotRangePadding -> None], "\n", {
    Subscript[$CellContext`pSWAP, 0, 1][Rational[5, 8] Pi, Rational[5, 2] Pi], 
    Subscript[$CellContext`pSWAP, 1, 2][
    Rational[1, 2] Pi, Rational[13, 4] Pi], 
    Subscript[QuEST`Gate`Rz, $CellContext`n1][Rational[1, 2] Pi], 
    Subscript[QuEST`Gate`Ry, $CellContext`n1][Rational[3, 2] Pi], 
    Subscript[QuEST`Gate`Ry, $CellContext`n2][Rational[5, 2] Pi], 
    Subscript[$CellContext`pSWAP, 0, 1][Rational[25, 8] Pi, 0], 
    Subscript[$CellContext`pSWAP, 0, 2][Pi, Rational[15, 4] Pi], 
    Subscript[QuEST`Gate`Rz, $CellContext`c][Rational[13, 4] Pi]}, 
   "\nis the circuit correct:   ", True, "\n\n"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.8317260055449686`*^9, 3.831726012244398*^9}, 
   3.8317263605080023`*^9},
 CellLabel->
  "During evaluation of \
In[18]:=",ExpressionUUID->"4cb9c2fa-bd54-4720-a059-39d26683d3d5"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Gate Type: \"\>", "\[InvisibleSpace]", "\<\"xxxOBSX\"\>", 
   "\[InvisibleSpace]", "\<\"\\n#2-qubit gates:  \"\>", "\[InvisibleSpace]", 
   "3", "\[InvisibleSpace]", "\<\"\\n#1-qubit gates:  \"\>", 
   "\[InvisibleSpace]", "7", 
   "\[InvisibleSpace]", "\<\"(-1) by removing the Z gate at the end\\n\"\>", 
   "\[InvisibleSpace]", 
   GraphicsBox[
    {EdgeForm[GrayLevel[0]], FaceForm[GrayLevel[
     1]], {{LineBox[{{0, 0.5}, {1, 0.5}}], LineBox[{{0, 1.5}, {1, 1.5}}], 
       LineBox[{{0, 2.5}, {1, 2.5}}]}, {LineBox[{{1, 0.5}, {2, 0.5}}], 
       LineBox[{{1, 1.5}, {2, 1.5}}], LineBox[{{1, 2.5}, {2, 2.5}}]}, {
       LineBox[{{2, 0.5}, {3, 0.5}}], LineBox[{{2, 1.5}, {3, 1.5}}], 
       LineBox[{{2, 2.5}, {3, 2.5}}]}, {LineBox[{{3, 0.5}, {4, 0.5}}], 
       LineBox[{{3, 1.5}, {4, 1.5}}], LineBox[{{3, 2.5}, {4, 2.5}}]}, {
       LineBox[{{4, 0.5}, {5, 0.5}}], LineBox[{{4, 1.5}, {5, 1.5}}], 
       LineBox[{{4, 2.5}, {5, 2.5}}]}, {LineBox[{{5, 0.5}, {6, 0.5}}], 
       LineBox[{{5, 1.5}, {6, 1.5}}], LineBox[{{5, 2.5}, {6, 2.5}}]}, {
       LineBox[{{6, 0.5}, {7, 0.5}}], LineBox[{{6, 1.5}, {7, 1.5}}], 
       LineBox[{{6, 2.5}, {7, 2.5}}]}, {LineBox[{{7, 0.5}, {8, 0.5}}], 
       LineBox[{{7, 1.5}, {8, 1.5}}], LineBox[{{7, 2.5}, {8, 2.5}}]}}, {{
       RectangleBox[{0.1, 2.1}, {0.9, 2.9}], 
       InsetBox["\<\"Ry\"\>", {0.5, 2.5}]}, {
       LineBox[{{1.5, 0.5}, {1.5, 2.5}}], {
        RectangleBox[{1.1, 0.1}, {1.9, 0.9}], 
        InsetBox["\<\"Rx\"\>", {1.5, 0.5}]}, {
        RectangleBox[{1.1, 1.1}, {1.9, 1.9}], 
        InsetBox["\<\"Rx\"\>", {1.5, 1.5}]}, {
        RectangleBox[{1.1, 2.1}, {1.9, 2.9}], 
        InsetBox["\<\"Rx\"\>", {1.5, 2.5}]}}, {
       RectangleBox[{2.1, 1.1}, {2.9, 1.9}], 
       InsetBox["\<\"Ry\"\>", {2.5, 1.5}]}, {
       RectangleBox[{2.1, 0.1}, {2.9, 0.9}], 
       InsetBox["\<\"Rz\"\>", {2.5, 0.5}]}, {
       LineBox[{{3.5, 0.5}, {3.5, 1.5}}], {
        RectangleBox[{3.1, 0.1}, {3.9, 0.9}], 
        InsetBox["\<\"Rx\"\>", {3.5, 0.5}]}, {
        RectangleBox[{3.1, 1.1}, {3.9, 1.9}], 
        InsetBox["\<\"Rx\"\>", {3.5, 1.5}]}}, {
       RectangleBox[{4.1, 0.1}, {4.9, 0.9}], 
       InsetBox["\<\"Ry\"\>", {4.5, 0.5}]}, {
       RectangleBox[{4.1, 1.1}, {4.9, 1.9}], 
       InsetBox["\<\"Rz\"\>", {4.5, 1.5}]}, {
       LineBox[{{5.5, 0.5}, {5.5, 2.5}}], {
        RectangleBox[{5.1, 0.1}, {5.9, 0.9}], 
        InsetBox["\<\"Rx\"\>", {5.5, 0.5}]}, {
        RectangleBox[{5.1, 1.1}, {5.9, 1.9}], 
        InsetBox["\<\"Rx\"\>", {5.5, 1.5}]}, {
        RectangleBox[{5.1, 2.1}, {5.9, 2.9}], 
        InsetBox["\<\"Rx\"\>", {5.5, 2.5}]}}, {
       RectangleBox[{6.1, 2.1}, {6.9, 2.9}], 
       InsetBox["\<\"Ry\"\>", {6.5, 2.5}]}, {
       RectangleBox[{7.1, 2.1}, {7.9, 2.9}], 
       InsetBox["\<\"Rz\"\>", {7.5, 2.5}]}}},
    ImageSize->{Automatic, 60},
    PlotRangePadding->None], "\[InvisibleSpace]", "\<\"\\n\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      SubscriptBox["Ry", "c"], "[", 
      FractionBox["\[Pi]", "2"], "]"}], ",", 
     RowBox[{"R", "[", 
      RowBox[{
       FractionBox[
        RowBox[{"5", " ", "\[Pi]"}], "4"], ",", 
       RowBox[{
        SubscriptBox["X", "c"], " ", 
        SubscriptBox["X", "n1"], " ", 
        SubscriptBox["X", "n2"]}]}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Ry", "n2"], "[", 
      FractionBox["\[Pi]", "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rz", "n1"], "[", 
      FractionBox[
       RowBox[{"3", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{"R", "[", 
      RowBox[{
       FractionBox["\[Pi]", "2"], ",", 
       RowBox[{
        SubscriptBox["X", "n1"], " ", 
        SubscriptBox["X", "n2"]}]}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Ry", "n1"], "[", 
      FractionBox[
       RowBox[{"15", " ", "\[Pi]"}], "4"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rz", "n2"], "[", 
      FractionBox[
       RowBox[{"15", " ", "\[Pi]"}], "4"], "]"}], ",", 
     RowBox[{"R", "[", 
      RowBox[{
       FractionBox["\[Pi]", "2"], ",", 
       RowBox[{
        SubscriptBox["X", "c"], " ", 
        SubscriptBox["X", "n1"], " ", 
        SubscriptBox["X", "n2"]}]}], "]"}], ",", 
     RowBox[{
      SubscriptBox["Ry", "c"], "[", 
      FractionBox[
       RowBox[{"3", " ", "\[Pi]"}], "2"], "]"}], ",", 
     RowBox[{
      SubscriptBox["Rz", "c"], "[", 
      FractionBox[
       RowBox[{"9", " ", "\[Pi]"}], "4"], "]"}]}], "}"}], 
   "\[InvisibleSpace]", "\<\"\\nis the circuit correct:   \"\>", 
   "\[InvisibleSpace]", "True", "\[InvisibleSpace]", "\<\"\\n\\n\"\>"}],
  SequenceForm[
  "Gate Type: ", "xxxOBSX", "\n#2-qubit gates:  ", 3, "\n#1-qubit gates:  ", 
   7, "(-1) by removing the Z gate at the end\n", 
   Graphics[{
     FaceForm[
      GrayLevel[1]], 
     EdgeForm[
      GrayLevel[0]], {{
       Line[{{0, 0.5}, {1, 0.5}}], 
       Line[{{0, 1.5}, {1, 1.5}}], 
       Line[{{0, 2.5}, {1, 2.5}}]}, {
       Line[{{1, 0.5}, {2, 0.5}}], 
       Line[{{1, 1.5}, {2, 1.5}}], 
       Line[{{1, 2.5}, {2, 2.5}}]}, {
       Line[{{2, 0.5}, {3, 0.5}}], 
       Line[{{2, 1.5}, {3, 1.5}}], 
       Line[{{2, 2.5}, {3, 2.5}}]}, {
       Line[{{3, 0.5}, {4, 0.5}}], 
       Line[{{3, 1.5}, {4, 1.5}}], 
       Line[{{3, 2.5}, {4, 2.5}}]}, {
       Line[{{4, 0.5}, {5, 0.5}}], 
       Line[{{4, 1.5}, {5, 1.5}}], 
       Line[{{4, 2.5}, {5, 2.5}}]}, {
       Line[{{5, 0.5}, {6, 0.5}}], 
       Line[{{5, 1.5}, {6, 1.5}}], 
       Line[{{5, 2.5}, {6, 2.5}}]}, {
       Line[{{6, 0.5}, {7, 0.5}}], 
       Line[{{6, 1.5}, {7, 1.5}}], 
       Line[{{6, 2.5}, {7, 2.5}}]}, {
       Line[{{7, 0.5}, {8, 0.5}}], 
       Line[{{7, 1.5}, {8, 1.5}}], 
       Line[{{7, 2.5}, {8, 2.5}}]}}, {{
       Rectangle[{0.1, 2.1}, {0.9, 2.9}], 
       Text["Ry", {0.5, 2.5}]}, {
       Line[{{1.5, 0.5}, {1.5, 2.5}}], {
        Rectangle[{1.1, 0.1}, {1.9, 0.9}], 
        Text["Rx", {1.5, 0.5}]}, {
        Rectangle[{1.1, 1.1}, {1.9, 1.9}], 
        Text["Rx", {1.5, 1.5}]}, {
        Rectangle[{1.1, 2.1}, {1.9, 2.9}], 
        Text["Rx", {1.5, 2.5}]}}, {
       Rectangle[{2.1, 1.1}, {2.9, 1.9}], 
       Text["Ry", {2.5, 1.5}]}, {
       Rectangle[{2.1, 0.1}, {2.9, 0.9}], 
       Text["Rz", {2.5, 0.5}]}, {
       Line[{{3.5, 0.5}, {3.5, 1.5}}], {
        Rectangle[{3.1, 0.1}, {3.9, 0.9}], 
        Text["Rx", {3.5, 0.5}]}, {
        Rectangle[{3.1, 1.1}, {3.9, 1.9}], 
        Text["Rx", {3.5, 1.5}]}}, {
       Rectangle[{4.1, 0.1}, {4.9, 0.9}], 
       Text["Ry", {4.5, 0.5}]}, {
       Rectangle[{4.1, 1.1}, {4.9, 1.9}], 
       Text["Rz", {4.5, 1.5}]}, {
       Line[{{5.5, 0.5}, {5.5, 2.5}}], {
        Rectangle[{5.1, 0.1}, {5.9, 0.9}], 
        Text["Rx", {5.5, 0.5}]}, {
        Rectangle[{5.1, 1.1}, {5.9, 1.9}], 
        Text["Rx", {5.5, 1.5}]}, {
        Rectangle[{5.1, 2.1}, {5.9, 2.9}], 
        Text["Rx", {5.5, 2.5}]}}, {
       Rectangle[{6.1, 2.1}, {6.9, 2.9}], 
       Text["Ry", {6.5, 2.5}]}, {
       Rectangle[{7.1, 2.1}, {7.9, 2.9}], 
       Text["Rz", {7.5, 2.5}]}}}, {ImageSize -> {Automatic, 60}}, ImageSize -> 
    270, PlotRangePadding -> None], "\n", {
    Subscript[QuEST`Gate`Ry, $CellContext`c][Rational[1, 2] Pi], 
    QuEST`Gate`R[
    Rational[5, 4] Pi, Subscript[QuEST`Gate`X, $CellContext`c] 
     Subscript[QuEST`Gate`X, $CellContext`n1] 
     Subscript[QuEST`Gate`X, $CellContext`n2]], 
    Subscript[QuEST`Gate`Ry, $CellContext`n2][Rational[1, 2] Pi], 
    Subscript[QuEST`Gate`Rz, $CellContext`n1][Rational[3, 2] Pi], 
    QuEST`Gate`R[
    Rational[1, 2] Pi, Subscript[QuEST`Gate`X, $CellContext`n1] 
     Subscript[QuEST`Gate`X, $CellContext`n2]], 
    Subscript[QuEST`Gate`Ry, $CellContext`n1][Rational[15, 4] Pi], 
    Subscript[QuEST`Gate`Rz, $CellContext`n2][Rational[15, 4] Pi], 
    QuEST`Gate`R[
    Rational[1, 2] Pi, Subscript[QuEST`Gate`X, $CellContext`c] 
     Subscript[QuEST`Gate`X, $CellContext`n1] 
     Subscript[QuEST`Gate`X, $CellContext`n2]], 
    Subscript[QuEST`Gate`Ry, $CellContext`c][Rational[3, 2] Pi], 
    Subscript[QuEST`Gate`Rz, $CellContext`c][Rational[9, 4] Pi]}, 
   "\nis the circuit correct:   ", True, "\n\n"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.8317260055449686`*^9, 3.831726012244398*^9}, 
   3.831726360531214*^9},
 CellLabel->
  "During evaluation of \
In[18]:=",ExpressionUUID->"1f102259-6634-4f1b-9197-cc896674124c"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1289, 776},
WindowMargins->{{-8, Automatic}, {Automatic, -8}},
Magnification:>1.5 Inherited,
FrontEndVersion->"12.0 for Microsoft Windows (64-bit) (April 8, 2019)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 390, 6, 82, "Subsubsection",ExpressionUUID->"2ec9fe91-5b2e-440a-95fb-792e309927f2"],
Cell[973, 30, 672, 10, 110, "Text",ExpressionUUID->"18766686-4706-4c59-8807-cd44caabb3e2"],
Cell[1648, 42, 38605, 1145, 3133, "Input",ExpressionUUID->"d862482c-9b4a-49dc-b1ec-d006a34c40cb",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[40290, 1192, 520, 8, 82, "Subsubsection",ExpressionUUID->"1ff7798e-b57f-4f99-b80b-a1ed14b8ee28"],
Cell[40813, 1202, 842, 16, 143, "Text",ExpressionUUID->"f3b5fe19-9cd4-406a-8c1e-6557540b0cd1"],
Cell[CellGroupData[{
Cell[41680, 1222, 6825, 175, 832, "Input",ExpressionUUID->"92d50411-2e68-4056-a9f8-a69c97438ddb"],
Cell[CellGroupData[{
Cell[48530, 1401, 9972, 240, 383, "Print",ExpressionUUID->"70440f64-b715-4c77-b3d9-d49109b36149"],
Cell[58505, 1643, 7212, 174, 335, "Print",ExpressionUUID->"1b72ae66-4b25-411d-9124-251e273fe3c5"],
Cell[65720, 1819, 12923, 310, 383, "Print",ExpressionUUID->"f8c0072b-0fac-4bd0-84b2-59ebeb312560"],
Cell[78646, 2131, 9659, 233, 383, "Print",ExpressionUUID->"068b191d-609a-4f1a-8067-c0ec6059bc7e"],
Cell[88308, 2366, 13740, 318, 431, "Print",ExpressionUUID->"0316abb2-dbd2-40b2-a14f-7ab9de2e9c3b"],
Cell[102051, 2686, 10348, 236, 383, "Print",ExpressionUUID->"53e07ff8-39bf-465d-8e01-e90047cfd22d"],
Cell[112402, 2924, 13900, 330, 431, "Print",ExpressionUUID->"8fb43ed2-1416-4582-97bb-2f0f67f2cd75"],
Cell[126305, 3256, 8149, 197, 383, "Print",ExpressionUUID->"63b53b19-400f-4b73-b971-ff789dfd167d"],
Cell[134457, 3455, 13069, 314, 383, "Print",ExpressionUUID->"2ec01d45-2335-4e53-83d7-ad5514364d08"],
Cell[147529, 3771, 8668, 206, 383, "Print",ExpressionUUID->"8c174d10-53d8-46e8-a36f-b44c96524b50"],
Cell[156200, 3979, 6978, 166, 335, "Print",ExpressionUUID->"d3cf821a-8ec9-4a2d-8d57-f044549deeb3"],
Cell[163181, 4147, 4641, 109, 335, "Print",ExpressionUUID->"82a28189-178d-4e58-bcf4-d2446007f8df"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[167883, 4263, 507, 8, 82, "Subsubsection",ExpressionUUID->"8ac7037a-eae3-4db4-a324-6983a1bfae70"],
Cell[168393, 4273, 794, 16, 110, "Text",ExpressionUUID->"1720caf5-c5a5-4546-9475-b8a63e9aa856"],
Cell[CellGroupData[{
Cell[169212, 4293, 6663, 172, 803, "Input",ExpressionUUID->"d7b6cc07-93d4-47d4-8049-59273a1a29e5"],
Cell[CellGroupData[{
Cell[175900, 4469, 6344, 153, 335, "Print",ExpressionUUID->"da2c2054-2fee-4da9-aaf3-7c663030bba5"],
Cell[182247, 4624, 8607, 207, 383, "Print",ExpressionUUID->"3fbdefdf-90fb-4d03-9543-ef5074e30759"],
Cell[190857, 4833, 7288, 176, 335, "Print",ExpressionUUID->"a8be3785-0101-4a9d-a5a4-291c493a4216"],
Cell[198148, 5011, 6005, 143, 335, "Print",ExpressionUUID->"6ce3ac3b-e46e-4a21-8be2-44f28e0d49de"],
Cell[204156, 5156, 7102, 166, 383, "Print",ExpressionUUID->"4cb9c2fa-bd54-4720-a059-39d26683d3d5"],
Cell[211261, 5324, 8357, 199, 383, "Print",ExpressionUUID->"1f102259-6634-4f1b-9197-cc896674124c"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

